/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Rewriters                                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

 case Intrinsic::sin:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FMul
              auto fwdarg_0 = dif;
              auto fwdarg_1 = ({
                // Computing cos
                auto fwdarg_2_0 = gutils->getNewFromOriginal(I.getOperand(0));
                Builder2.CreateCall(Intrinsic::getDeclaration(mod, Intrinsic::cos, std::vector<Type*>({fwdarg_2_0->getType()})), ArrayRef<Value*>({fwdarg_2_0}));
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FMul
              auto revarg_0 = dif;
              auto revarg_1 = ({
                // Computing cos
                auto revarg_2_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                Builder2.CreateCall(Intrinsic::getDeclaration(mod, Intrinsic::cos, std::vector<Type*>({revarg_2_0->getType()})), ArrayRef<Value*>({revarg_2_0}));
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::cos:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FMul
              auto fwdarg_0 = dif;
              auto fwdarg_1 = ({
                // Computing FNeg
                auto fwdarg_2_0 = ({
                  // Computing sin
                  auto fwdarg_2_1_0 = gutils->getNewFromOriginal(I.getOperand(0));
                  Builder2.CreateCall(Intrinsic::getDeclaration(mod, Intrinsic::sin, std::vector<Type*>({fwdarg_2_1_0->getType()})), ArrayRef<Value*>({fwdarg_2_1_0}));
                });
                Builder2.CreateFNeg(fwdarg_2_0);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FMul
              auto revarg_0 = dif;
              auto revarg_1 = ({
                // Computing FNeg
                auto revarg_2_0 = ({
                  // Computing sin
                  auto revarg_2_1_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                  Builder2.CreateCall(Intrinsic::getDeclaration(mod, Intrinsic::sin, std::vector<Type*>({revarg_2_1_0->getType()})), ArrayRef<Value*>({revarg_2_1_0}));
                });
                Builder2.CreateFNeg(revarg_2_0);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::exp:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FMul
              auto fwdarg_0 = dif;
              auto fwdarg_1 = ({
                // Computing Call
                auto fwdarg_2_0 = gutils->getNewFromOriginal(I.getOperand(0));
                auto callval = cast<CallInst>(&I)->getCalledOperand();
                auto FT = cast<CallInst>(&I)->getFunctionType();
                auto cconv = cast<CallInst>(&I)->getCallingConv();
                CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({fwdarg_2_0})));
                V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                V->setCallingConv(cconv);
                V;
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FMul
              auto revarg_0 = dif;
              auto revarg_1 = ({
                // Computing Call
                auto revarg_2_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                auto callval = cast<CallInst>(&I)->getCalledOperand();
                auto FT = cast<CallInst>(&I)->getFunctionType();
                auto cconv = cast<CallInst>(&I)->getCallingConv();
                CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({revarg_2_0})));
                V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                V->setCallingConv(cconv);
                V;
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::exp2:
 case Intrinsic::nvvm_ex2_approx_ftz_f:
 case Intrinsic::nvvm_ex2_approx_f:
 case Intrinsic::nvvm_ex2_approx_d:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FMul
              auto fwdarg_0 = dif;
              auto fwdarg_1 = ({
                // Computing FMul
                auto fwdarg_2_0 = ConstantFP::get(I.getOperand(0)->getType(), "0.6931471805599453");
                auto fwdarg_2_1 = ({
                  // Computing Call
                  auto fwdarg_2_2_0 = gutils->getNewFromOriginal(I.getOperand(0));
                  auto callval = cast<CallInst>(&I)->getCalledOperand();
                  auto FT = cast<CallInst>(&I)->getFunctionType();
                  auto cconv = cast<CallInst>(&I)->getCallingConv();
                  CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({fwdarg_2_2_0})));
                  V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                  V->setCallingConv(cconv);
                  V;
                });
                Builder2.CreateFMul(fwdarg_2_0, fwdarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FMul
              auto revarg_0 = dif;
              auto revarg_1 = ({
                // Computing FMul
                auto revarg_2_0 = ConstantFP::get(I.getOperand(0)->getType(), "0.6931471805599453");
                auto revarg_2_1 = ({
                  // Computing Call
                  auto revarg_2_2_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                  auto callval = cast<CallInst>(&I)->getCalledOperand();
                  auto FT = cast<CallInst>(&I)->getFunctionType();
                  auto cconv = cast<CallInst>(&I)->getCallingConv();
                  CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({revarg_2_2_0})));
                  V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                  V->setCallingConv(cconv);
                  V;
                });
                Builder2.CreateFMul(revarg_2_0, revarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::log:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FDiv
              auto fwdarg_0 = dif;
              auto fwdarg_1 = gutils->getNewFromOriginal(I.getOperand(0));
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFDiv((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FDiv
              auto revarg_0 = dif;
              auto revarg_1 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFDiv((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::log2:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FDiv
              auto fwdarg_0 = dif;
              auto fwdarg_1 = ({
                // Computing FMul
                auto fwdarg_2_0 = ConstantFP::get(I.getOperand(0)->getType(), "0.6931471805599453");
                auto fwdarg_2_1 = gutils->getNewFromOriginal(I.getOperand(0));
                Builder2.CreateFMul(fwdarg_2_0, fwdarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFDiv((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FDiv
              auto revarg_0 = dif;
              auto revarg_1 = ({
                // Computing FMul
                auto revarg_2_0 = ConstantFP::get(I.getOperand(0)->getType(), "0.6931471805599453");
                auto revarg_2_1 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                Builder2.CreateFMul(revarg_2_0, revarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFDiv((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::log10:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FDiv
              auto fwdarg_0 = dif;
              auto fwdarg_1 = ({
                // Computing FMul
                auto fwdarg_2_0 = ConstantFP::get(I.getOperand(0)->getType(), "2.302585092994046");
                auto fwdarg_2_1 = gutils->getNewFromOriginal(I.getOperand(0));
                Builder2.CreateFMul(fwdarg_2_0, fwdarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFDiv((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FDiv
              auto revarg_0 = dif;
              auto revarg_1 = ({
                // Computing FMul
                auto revarg_2_0 = ConstantFP::get(I.getOperand(0)->getType(), "2.302585092994046");
                auto revarg_2_1 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                Builder2.CreateFMul(revarg_2_0, revarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFDiv((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::copysign:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FMul
              auto fwdarg_0 = dif;
              auto fwdarg_1 = ({
                // Computing FMul
                auto fwdarg_2_0 = ({
                  // Computing Call
                  auto fwdarg_2_1_0 = ConstantFP::get(I.getOperand(0)->getType(), "1.0");
                  auto fwdarg_2_1_1 = gutils->getNewFromOriginal(I.getOperand(0));
                  auto callval = cast<CallInst>(&I)->getCalledOperand();
                  auto FT = cast<CallInst>(&I)->getFunctionType();
                  auto cconv = cast<CallInst>(&I)->getCallingConv();
                  CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({fwdarg_2_1_0, fwdarg_2_1_1})));
                  V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                  V->setCallingConv(cconv);
                  V;
                });
                auto fwdarg_2_1 = ({
                  // Computing Call
                  auto fwdarg_2_2_0 = ConstantFP::get(I.getOperand(1)->getType(), "1.0");
                  auto fwdarg_2_2_1 = gutils->getNewFromOriginal(I.getOperand(1));
                  auto callval = cast<CallInst>(&I)->getCalledOperand();
                  auto FT = cast<CallInst>(&I)->getFunctionType();
                  auto cconv = cast<CallInst>(&I)->getCallingConv();
                  CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({fwdarg_2_2_0, fwdarg_2_2_1})));
                  V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                  V->setCallingConv(cconv);
                  V;
                });
                Builder2.CreateFMul(fwdarg_2_0, fwdarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FMul
              auto revarg_0 = dif;
              auto revarg_1 = ({
                // Computing FMul
                auto revarg_2_0 = ({
                  // Computing Call
                  auto revarg_2_1_0 = ConstantFP::get(I.getOperand(0)->getType(), "1.0");
                  auto revarg_2_1_1 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                  auto callval = cast<CallInst>(&I)->getCalledOperand();
                  auto FT = cast<CallInst>(&I)->getFunctionType();
                  auto cconv = cast<CallInst>(&I)->getCallingConv();
                  CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({revarg_2_1_0, revarg_2_1_1})));
                  V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                  V->setCallingConv(cconv);
                  V;
                });
                auto revarg_2_1 = ({
                  // Computing Call
                  auto revarg_2_2_0 = ConstantFP::get(I.getOperand(1)->getType(), "1.0");
                  auto revarg_2_2_1 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                  auto callval = cast<CallInst>(&I)->getCalledOperand();
                  auto FT = cast<CallInst>(&I)->getFunctionType();
                  auto cconv = cast<CallInst>(&I)->getCallingConv();
                  CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({revarg_2_2_0, revarg_2_2_1})));
                  V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                  V->setCallingConv(cconv);
                  V;
                });
                Builder2.CreateFMul(revarg_2_0, revarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::minnum:
 case Intrinsic::nvvm_fmin_f:
 case Intrinsic::nvvm_fmin_d:
 case Intrinsic::nvvm_fmin_ftz_f:
 case Intrinsic::x86_sse2_min_pd:
 case Intrinsic::minimum:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
            Value *res = ({
              // Computing Select
              auto fwdnsrarg_0 = ({
                // Computing FCmpOLT
                auto fwdnsrarg_1_0 = gutils->getNewFromOriginal(I.getOperand(0));
                auto fwdnsrarg_1_1 = gutils->getNewFromOriginal(I.getOperand(1));
                Builder2.CreateFCmpOLT(fwdnsrarg_1_0, fwdnsrarg_1_1);
              });
              auto fwdnsrarg_1 = ({
                // Computing SelectIfActive
                llvm::Value *imVal = nullptr;
                if (!gutils->isConstantValue(I.getOperand(0))) {
                  imVal = gutils->invertPointerM(I.getOperand(0), Builder2);
                } else {
                  imVal = Constant::getNullValue(I.getOperand(0)->getType());
                  llvm::Value* vec_imVal = gutils->getWidth() == 1 ? imVal : UndefValue::get(gutils->getShadowType(imVal->getType()));
                  if (gutils->getWidth() != 1)
                    for (size_t i=0; i<gutils->getWidth(); i++)
                      vec_imVal = Builder2.CreateInsertValue(vec_imVal, imVal, std::vector<unsigned>({(unsigned)i}));
                  imVal = vec_imVal;
                }
                imVal;
              });
              auto fwdnsrarg_2 = ({
                // Computing SelectIfActive
                llvm::Value *imVal = nullptr;
                if (!gutils->isConstantValue(I.getOperand(1))) {
                  imVal = gutils->invertPointerM(I.getOperand(1), Builder2);
                } else {
                  imVal = Constant::getNullValue(I.getOperand(1)->getType());
                  llvm::Value* vec_imVal = gutils->getWidth() == 1 ? imVal : UndefValue::get(gutils->getShadowType(imVal->getType()));
                  if (gutils->getWidth() != 1)
                    for (size_t i=0; i<gutils->getWidth(); i++)
                      vec_imVal = Builder2.CreateInsertValue(vec_imVal, imVal, std::vector<unsigned>({(unsigned)i}));
                  imVal = vec_imVal;
                }
                imVal;
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateSelect(fwdnsrarg_0, (gutils->getWidth() == 1) ? fwdnsrarg_1 : gutils->extractMeta(Builder2, fwdnsrarg_1, idx), (gutils->getWidth() == 1) ? fwdnsrarg_2 : gutils->extractMeta(Builder2, fwdnsrarg_2, idx));
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        } else if (!dif && !gutils->isConstantValue(I.getOperand(1))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing Select
              auto revarg_0 = ({
                // Computing FCmpOLT
                auto revarg_1_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                auto revarg_1_1 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                Builder2.CreateFCmpOLT(revarg_1_0, revarg_1_1);
              });
              auto revarg_1 = dif;
              auto revarg_2 = ConstantFP::get(I.getOperand(0)->getType(), "0");
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateSelect(revarg_0, (gutils->getWidth() == 1) ? revarg_1 : gutils->extractMeta(Builder2, revarg_1, idx), revarg_2);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        if (!gutils->isConstantValue(I.getOperand(1))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing Select
              auto revarg_0 = ({
                // Computing FCmpOLT
                auto revarg_1_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                auto revarg_1_1 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                Builder2.CreateFCmpOLT(revarg_1_0, revarg_1_1);
              });
              auto revarg_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
              auto revarg_2 = dif;
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateSelect(revarg_0, revarg_1, (gutils->getWidth() == 1) ? revarg_2 : gutils->extractMeta(Builder2, revarg_2, idx));
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(1)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(1), toadd, Builder2, I.getOperand(1)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::maxnum:
 case Intrinsic::nvvm_fmax_f:
 case Intrinsic::nvvm_fmax_d:
 case Intrinsic::nvvm_fmax_ftz_f:
 case Intrinsic::x86_sse2_max_pd:
 case Intrinsic::maximum:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
            Value *res = ({
              // Computing Select
              auto fwdnsrarg_0 = ({
                // Computing FCmpOLT
                auto fwdnsrarg_1_0 = gutils->getNewFromOriginal(I.getOperand(0));
                auto fwdnsrarg_1_1 = gutils->getNewFromOriginal(I.getOperand(1));
                Builder2.CreateFCmpOLT(fwdnsrarg_1_0, fwdnsrarg_1_1);
              });
              auto fwdnsrarg_1 = ({
                // Computing SelectIfActive
                llvm::Value *imVal = nullptr;
                if (!gutils->isConstantValue(I.getOperand(1))) {
                  imVal = gutils->invertPointerM(I.getOperand(1), Builder2);
                } else {
                  imVal = Constant::getNullValue(I.getOperand(1)->getType());
                  llvm::Value* vec_imVal = gutils->getWidth() == 1 ? imVal : UndefValue::get(gutils->getShadowType(imVal->getType()));
                  if (gutils->getWidth() != 1)
                    for (size_t i=0; i<gutils->getWidth(); i++)
                      vec_imVal = Builder2.CreateInsertValue(vec_imVal, imVal, std::vector<unsigned>({(unsigned)i}));
                  imVal = vec_imVal;
                }
                imVal;
              });
              auto fwdnsrarg_2 = ({
                // Computing SelectIfActive
                llvm::Value *imVal = nullptr;
                if (!gutils->isConstantValue(I.getOperand(0))) {
                  imVal = gutils->invertPointerM(I.getOperand(0), Builder2);
                } else {
                  imVal = Constant::getNullValue(I.getOperand(0)->getType());
                  llvm::Value* vec_imVal = gutils->getWidth() == 1 ? imVal : UndefValue::get(gutils->getShadowType(imVal->getType()));
                  if (gutils->getWidth() != 1)
                    for (size_t i=0; i<gutils->getWidth(); i++)
                      vec_imVal = Builder2.CreateInsertValue(vec_imVal, imVal, std::vector<unsigned>({(unsigned)i}));
                  imVal = vec_imVal;
                }
                imVal;
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateSelect(fwdnsrarg_0, (gutils->getWidth() == 1) ? fwdnsrarg_1 : gutils->extractMeta(Builder2, fwdnsrarg_1, idx), (gutils->getWidth() == 1) ? fwdnsrarg_2 : gutils->extractMeta(Builder2, fwdnsrarg_2, idx));
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        } else if (!dif && !gutils->isConstantValue(I.getOperand(1))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing Select
              auto revarg_0 = ({
                // Computing FCmpOLT
                auto revarg_1_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                auto revarg_1_1 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                Builder2.CreateFCmpOLT(revarg_1_0, revarg_1_1);
              });
              auto revarg_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
              auto revarg_2 = dif;
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateSelect(revarg_0, revarg_1, (gutils->getWidth() == 1) ? revarg_2 : gutils->extractMeta(Builder2, revarg_2, idx));
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        if (!gutils->isConstantValue(I.getOperand(1))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing Select
              auto revarg_0 = ({
                // Computing FCmpOLT
                auto revarg_1_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                auto revarg_1_1 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                Builder2.CreateFCmpOLT(revarg_1_0, revarg_1_1);
              });
              auto revarg_1 = dif;
              auto revarg_2 = ConstantFP::get(I.getOperand(0)->getType(), "0");
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateSelect(revarg_0, (gutils->getWidth() == 1) ? revarg_1 : gutils->extractMeta(Builder2, revarg_1, idx), revarg_2);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(1)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(1), toadd, Builder2, I.getOperand(1)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::fabs:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FMul
              auto fwdarg_0 = dif;
              auto fwdarg_1 = ({
                // Computing Select
                auto fwdarg_2_0 = ({
                  // Computing FCmpOLT
                  auto fwdarg_2_1_0 = gutils->getNewFromOriginal(I.getOperand(0));
                  auto fwdarg_2_1_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
                  Builder2.CreateFCmpOLT(fwdarg_2_1_0, fwdarg_2_1_1);
                });
                auto fwdarg_2_1 = ConstantFP::get(I.getOperand(0)->getType(), "-1");
                auto fwdarg_2_2 = ConstantFP::get(I.getOperand(0)->getType(), "1");
                Builder2.CreateSelect(fwdarg_2_0, fwdarg_2_1, fwdarg_2_2);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FMul
              auto revarg_0 = dif;
              auto revarg_1 = ({
                // Computing Select
                auto revarg_2_0 = ({
                  // Computing FCmpOLT
                  auto revarg_2_1_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                  auto revarg_2_1_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
                  Builder2.CreateFCmpOLT(revarg_2_1_0, revarg_2_1_1);
                });
                auto revarg_2_1 = ConstantFP::get(I.getOperand(0)->getType(), "-1");
                auto revarg_2_2 = ConstantFP::get(I.getOperand(0)->getType(), "1");
                Builder2.CreateSelect(revarg_2_0, revarg_2_1, revarg_2_2);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::sqrt:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing Select
              auto fwdarg_0 = ({
                // Computing FCmpUEQ
                auto fwdarg_1_0 = gutils->getNewFromOriginal(I.getOperand(0));
                auto fwdarg_1_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
                Builder2.CreateFCmpUEQ(fwdarg_1_0, fwdarg_1_1);
              });
              auto fwdarg_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
              auto fwdarg_2 = ({
                // Computing FDiv
                auto fwdarg_3_0 = dif;
                auto fwdarg_3_1 = ({
                  // Computing FMul
                  auto fwdarg_3_2_0 = ConstantFP::get(I.getOperand(0)->getType(), "2");
                  auto fwdarg_3_2_1 = ({
                    // Computing Call
                    auto fwdarg_3_2_2_0 = gutils->getNewFromOriginal(I.getOperand(0));
                    auto callval = cast<CallInst>(&I)->getCalledOperand();
                    auto FT = cast<CallInst>(&I)->getFunctionType();
                    auto cconv = cast<CallInst>(&I)->getCallingConv();
                    CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({fwdarg_3_2_2_0})));
                    V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                    V->setCallingConv(cconv);
#if LLVM_VERSION_MAJOR >= 16
                    V->setOnlyReadsMemory();
V->setOnlyWritesMemory();
#elif LLVM_VERSION_MAJOR >= 14
                    V->addAttributeAtIndex(AttributeList::FunctionIndex, Attribute::ReadNone);
#else 
                    V->addAttribute(AttributeList::FunctionIndex, Attribute::ReadNone);
#endif 
#if LLVM_VERSION_MAJOR >= 14
                    V->addAttributeAtIndex(AttributeList::FunctionIndex, Attribute::NoUnwind);
#else 
                    V->addAttribute(AttributeList::FunctionIndex, Attribute::NoUnwind);
#endif 
                    V;
                  });
                  Builder2.CreateFMul(fwdarg_3_2_0, fwdarg_3_2_1);
                });
                Value *res = nullptr;
                for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                  Value *V = Builder2.CreateFDiv((gutils->getWidth() == 1) ? fwdarg_3_0 : gutils->extractMeta(Builder2, fwdarg_3_0, idx), fwdarg_3_1);
                  if (gutils->getWidth() == 1) res = V;
                  else {
                    if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                    res = Builder2.CreateInsertValue(res, V, {idx});
                  }
                }
                res;
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateSelect(fwdarg_0, fwdarg_1, (gutils->getWidth() == 1) ? fwdarg_2 : gutils->extractMeta(Builder2, fwdarg_2, idx));
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing Select
              auto revarg_0 = ({
                // Computing FCmpUEQ
                auto revarg_1_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                auto revarg_1_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
                Builder2.CreateFCmpUEQ(revarg_1_0, revarg_1_1);
              });
              auto revarg_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
              auto revarg_2 = ({
                // Computing FDiv
                auto revarg_3_0 = dif;
                auto revarg_3_1 = ({
                  // Computing FMul
                  auto revarg_3_2_0 = ConstantFP::get(I.getOperand(0)->getType(), "2");
                  auto revarg_3_2_1 = ({
                    // Computing Call
                    auto revarg_3_2_2_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                    auto callval = cast<CallInst>(&I)->getCalledOperand();
                    auto FT = cast<CallInst>(&I)->getFunctionType();
                    auto cconv = cast<CallInst>(&I)->getCallingConv();
                    CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({revarg_3_2_2_0})));
                    V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                    V->setCallingConv(cconv);
#if LLVM_VERSION_MAJOR >= 16
                    V->setOnlyReadsMemory();
V->setOnlyWritesMemory();
#elif LLVM_VERSION_MAJOR >= 14
                    V->addAttributeAtIndex(AttributeList::FunctionIndex, Attribute::ReadNone);
#else 
                    V->addAttribute(AttributeList::FunctionIndex, Attribute::ReadNone);
#endif 
#if LLVM_VERSION_MAJOR >= 14
                    V->addAttributeAtIndex(AttributeList::FunctionIndex, Attribute::NoUnwind);
#else 
                    V->addAttribute(AttributeList::FunctionIndex, Attribute::NoUnwind);
#endif 
                    V;
                  });
                  Builder2.CreateFMul(revarg_3_2_0, revarg_3_2_1);
                });
                Value *res = nullptr;
                for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                  Value *V = Builder2.CreateFDiv((gutils->getWidth() == 1) ? revarg_3_0 : gutils->extractMeta(Builder2, revarg_3_0, idx), revarg_3_1);
                  if (gutils->getWidth() == 1) res = V;
                  else {
                    if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                    res = Builder2.CreateInsertValue(res, V, {idx});
                  }
                }
                res;
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateSelect(revarg_0, revarg_1, (gutils->getWidth() == 1) ? revarg_2 : gutils->extractMeta(Builder2, revarg_2, idx));
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::pow:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing CheckedMul
              auto fwdarg_0 = dif;
              auto fwdarg_1 = ({
                // Computing FMul
                auto fwdarg_2_0 = gutils->getNewFromOriginal(I.getOperand(1));
                auto fwdarg_2_1 = ({
                  // Computing Call
                  auto fwdarg_2_2_0 = gutils->getNewFromOriginal(I.getOperand(0));
                  auto fwdarg_2_2_1 = ({
                    // Computing FSub
                    auto fwdarg_2_2_2_0 = gutils->getNewFromOriginal(I.getOperand(1));
                    auto fwdarg_2_2_2_1 = ConstantFP::get(I.getOperand(1)->getType(), "1");
                    Builder2.CreateFSub(fwdarg_2_2_2_0, fwdarg_2_2_2_1);
                  });
                  auto callval = cast<CallInst>(&I)->getCalledOperand();
                  auto FT = cast<CallInst>(&I)->getFunctionType();
                  auto cconv = cast<CallInst>(&I)->getCallingConv();
                  CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({fwdarg_2_2_0, fwdarg_2_2_1})));
                  V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                  V->setCallingConv(cconv);
                  V;
                });
                Builder2.CreateFMul(fwdarg_2_0, fwdarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = checkedMul(Builder2, (gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        if (!gutils->isConstantValue(I.getOperand(1))) {
          Value *dif = diffe(I.getOperand(1), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing CheckedMul
              auto fwdarg_0 = dif;
              auto fwdarg_1 = ({
                // Computing FMul
                auto fwdarg_2_0 = ({
                  // Computing Call
                  auto fwdarg_2_1_0 = gutils->getNewFromOriginal(I.getOperand(0));
                  auto fwdarg_2_1_1 = gutils->getNewFromOriginal(I.getOperand(1));
                  auto callval = cast<CallInst>(&I)->getCalledOperand();
                  auto FT = cast<CallInst>(&I)->getFunctionType();
                  auto cconv = cast<CallInst>(&I)->getCallingConv();
                  CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({fwdarg_2_1_0, fwdarg_2_1_1})));
                  V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                  V->setCallingConv(cconv);
                  V;
                });
                auto fwdarg_2_1 = ({
                  // Computing log
                  auto fwdarg_2_2_0 = gutils->getNewFromOriginal(I.getOperand(0));
                  Builder2.CreateCall(Intrinsic::getDeclaration(mod, Intrinsic::log, std::vector<Type*>({fwdarg_2_2_0->getType()})), ArrayRef<Value*>({fwdarg_2_2_0}));
                });
                Builder2.CreateFMul(fwdarg_2_0, fwdarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = checkedMul(Builder2, (gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        } else if (!dif && !gutils->isConstantValue(I.getOperand(1))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing CheckedMul
              auto revarg_0 = dif;
              auto revarg_1 = ({
                // Computing FMul
                auto revarg_2_0 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                auto revarg_2_1 = ({
                  // Computing Call
                  auto revarg_2_2_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                  auto revarg_2_2_1 = ({
                    // Computing FSub
                    auto revarg_2_2_2_0 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                    auto revarg_2_2_2_1 = ConstantFP::get(I.getOperand(1)->getType(), "1");
                    Builder2.CreateFSub(revarg_2_2_2_0, revarg_2_2_2_1);
                  });
                  auto callval = cast<CallInst>(&I)->getCalledOperand();
                  auto FT = cast<CallInst>(&I)->getFunctionType();
                  auto cconv = cast<CallInst>(&I)->getCallingConv();
                  CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({revarg_2_2_0, revarg_2_2_1})));
                  V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                  V->setCallingConv(cconv);
                  V;
                });
                Builder2.CreateFMul(revarg_2_0, revarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = checkedMul(Builder2, (gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        if (!gutils->isConstantValue(I.getOperand(1))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing CheckedMul
              auto revarg_0 = dif;
              auto revarg_1 = ({
                // Computing FMul
                auto revarg_2_0 = ({
                  // Computing Call
                  auto revarg_2_1_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                  auto revarg_2_1_1 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                  auto callval = cast<CallInst>(&I)->getCalledOperand();
                  auto FT = cast<CallInst>(&I)->getFunctionType();
                  auto cconv = cast<CallInst>(&I)->getCallingConv();
                  CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({revarg_2_1_0, revarg_2_1_1})));
                  V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                  V->setCallingConv(cconv);
                  V;
                });
                auto revarg_2_1 = ({
                  // Computing log
                  auto revarg_2_2_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                  Builder2.CreateCall(Intrinsic::getDeclaration(mod, Intrinsic::log, std::vector<Type*>({revarg_2_2_0->getType()})), ArrayRef<Value*>({revarg_2_2_0}));
                });
                Builder2.CreateFMul(revarg_2_0, revarg_2_1);
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = checkedMul(Builder2, (gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(1)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(1), toadd, Builder2, I.getOperand(1)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::powi:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing Select
              auto fwdarg_0 = ({
                // Computing Or
                auto fwdarg_1_0 = ({
                  // Computing ICmpEQ
                  auto fwdarg_1_1_0 = gutils->getNewFromOriginal(I.getOperand(1));
                  auto fwdarg_1_1_1 = ConstantInt::getSigned(I.getOperand(1)->getType(), 0);
                  Builder2.CreateICmpEQ(fwdarg_1_1_0, fwdarg_1_1_1);
                });
                auto fwdarg_1_1 = ({
                  // Computing And
                  auto fwdarg_1_2_0 = ConstantInt::get(Type::getInt1Ty(gutils->newFunc->getContext()), EnzymeStrongZero);
                  auto fwdarg_1_2_1 = ({
                    // Computing FCmpOEQ
                    auto fwdarg_1_2_2_0 = dif;
                    auto fwdarg_1_2_2_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
                    Value *res = nullptr;
                    for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                      Value *V = Builder2.CreateFCmpOEQ((gutils->getWidth() == 1) ? fwdarg_1_2_2_0 : gutils->extractMeta(Builder2, fwdarg_1_2_2_0, idx), fwdarg_1_2_2_1);
                      if (gutils->getWidth() == 1) res = V;
                      else {
                        if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                        res = Builder2.CreateInsertValue(res, V, {idx});
                      }
                    }
                    res;
                  });
                  Value *res = nullptr;
                  for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                    Value *V = Builder2.CreateAnd(fwdarg_1_2_0, (gutils->getWidth() == 1) ? fwdarg_1_2_1 : gutils->extractMeta(Builder2, fwdarg_1_2_1, idx));
                    if (gutils->getWidth() == 1) res = V;
                    else {
                      if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                      res = Builder2.CreateInsertValue(res, V, {idx});
                    }
                  }
                  res;
                });
                Value *res = nullptr;
                for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                  Value *V = Builder2.CreateOr(fwdarg_1_0, (gutils->getWidth() == 1) ? fwdarg_1_1 : gutils->extractMeta(Builder2, fwdarg_1_1, idx));
                  if (gutils->getWidth() == 1) res = V;
                  else {
                    if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                    res = Builder2.CreateInsertValue(res, V, {idx});
                  }
                }
                res;
              });
              auto fwdarg_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
              auto fwdarg_2 = ({
                // Computing FMul
                auto fwdarg_3_0 = dif;
                auto fwdarg_3_1 = ({
                  // Computing FMul
                  auto fwdarg_3_2_0 = ({
                    // Computing SIToFP
                    auto fwdarg_3_2_1_0 = gutils->getNewFromOriginal(I.getOperand(1));
                    auto fwdarg_3_2_1_1 = I.getOperand(0)->getType();
                    Builder2.CreateSIToFP(fwdarg_3_2_1_0, fwdarg_3_2_1_1);
                  });
                  auto fwdarg_3_2_1 = ({
                    // Computing Call
                    auto fwdarg_3_2_2_0 = gutils->getNewFromOriginal(I.getOperand(0));
                    auto fwdarg_3_2_2_1 = ({
                      // Computing Sub
                      auto fwdarg_3_2_2_2_0 = gutils->getNewFromOriginal(I.getOperand(1));
                      auto fwdarg_3_2_2_2_1 = ConstantInt::getSigned(I.getOperand(1)->getType(), 1);
                      Builder2.CreateSub(fwdarg_3_2_2_2_0, fwdarg_3_2_2_2_1);
                    });
                    auto callval = cast<CallInst>(&I)->getCalledOperand();
                    auto FT = cast<CallInst>(&I)->getFunctionType();
                    auto cconv = cast<CallInst>(&I)->getCallingConv();
                    CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({fwdarg_3_2_2_0, fwdarg_3_2_2_1})));
                    V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                    V->setCallingConv(cconv);
                    V;
                  });
                  Builder2.CreateFMul(fwdarg_3_2_0, fwdarg_3_2_1);
                });
                Value *res = nullptr;
                for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                  Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? fwdarg_3_0 : gutils->extractMeta(Builder2, fwdarg_3_0, idx), fwdarg_3_1);
                  if (gutils->getWidth() == 1) res = V;
                  else {
                    if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                    res = Builder2.CreateInsertValue(res, V, {idx});
                  }
                }
                res;
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateSelect((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1, (gutils->getWidth() == 1) ? fwdarg_2 : gutils->extractMeta(Builder2, fwdarg_2, idx));
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing Select
              auto revarg_0 = ({
                // Computing Or
                auto revarg_1_0 = ({
                  // Computing ICmpEQ
                  auto revarg_1_1_0 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                  auto revarg_1_1_1 = ConstantInt::getSigned(I.getOperand(1)->getType(), 0);
                  Builder2.CreateICmpEQ(revarg_1_1_0, revarg_1_1_1);
                });
                auto revarg_1_1 = ({
                  // Computing And
                  auto revarg_1_2_0 = ConstantInt::get(Type::getInt1Ty(gutils->newFunc->getContext()), EnzymeStrongZero);
                  auto revarg_1_2_1 = ({
                    // Computing FCmpOEQ
                    auto revarg_1_2_2_0 = dif;
                    auto revarg_1_2_2_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
                    Value *res = nullptr;
                    for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                      Value *V = Builder2.CreateFCmpOEQ((gutils->getWidth() == 1) ? revarg_1_2_2_0 : gutils->extractMeta(Builder2, revarg_1_2_2_0, idx), revarg_1_2_2_1);
                      if (gutils->getWidth() == 1) res = V;
                      else {
                        if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                        res = Builder2.CreateInsertValue(res, V, {idx});
                      }
                    }
                    res;
                  });
                  Value *res = nullptr;
                  for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                    Value *V = Builder2.CreateAnd(revarg_1_2_0, (gutils->getWidth() == 1) ? revarg_1_2_1 : gutils->extractMeta(Builder2, revarg_1_2_1, idx));
                    if (gutils->getWidth() == 1) res = V;
                    else {
                      if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                      res = Builder2.CreateInsertValue(res, V, {idx});
                    }
                  }
                  res;
                });
                Value *res = nullptr;
                for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                  Value *V = Builder2.CreateOr(revarg_1_0, (gutils->getWidth() == 1) ? revarg_1_1 : gutils->extractMeta(Builder2, revarg_1_1, idx));
                  if (gutils->getWidth() == 1) res = V;
                  else {
                    if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                    res = Builder2.CreateInsertValue(res, V, {idx});
                  }
                }
                res;
              });
              auto revarg_1 = ConstantFP::get(I.getOperand(0)->getType(), "0");
              auto revarg_2 = ({
                // Computing FMul
                auto revarg_3_0 = dif;
                auto revarg_3_1 = ({
                  // Computing FMul
                  auto revarg_3_2_0 = ({
                    // Computing SIToFP
                    auto revarg_3_2_1_0 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                    auto revarg_3_2_1_1 = I.getOperand(0)->getType();
                    Builder2.CreateSIToFP(revarg_3_2_1_0, revarg_3_2_1_1);
                  });
                  auto revarg_3_2_1 = ({
                    // Computing Call
                    auto revarg_3_2_2_0 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
                    auto revarg_3_2_2_1 = ({
                      // Computing Sub
                      auto revarg_3_2_2_2_0 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
                      auto revarg_3_2_2_2_1 = ConstantInt::getSigned(I.getOperand(1)->getType(), 1);
                      Builder2.CreateSub(revarg_3_2_2_2_0, revarg_3_2_2_2_1);
                    });
                    auto callval = cast<CallInst>(&I)->getCalledOperand();
                    auto FT = cast<CallInst>(&I)->getFunctionType();
                    auto cconv = cast<CallInst>(&I)->getCallingConv();
                    CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({revarg_3_2_2_0, revarg_3_2_2_1})));
                    V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                    V->setCallingConv(cconv);
                    V;
                  });
                  Builder2.CreateFMul(revarg_3_2_0, revarg_3_2_1);
                });
                Value *res = nullptr;
                for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                  Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? revarg_3_0 : gutils->extractMeta(Builder2, revarg_3_0, idx), revarg_3_1);
                  if (gutils->getWidth() == 1) res = V;
                  else {
                    if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                    res = Builder2.CreateInsertValue(res, V, {idx});
                  }
                }
                res;
              });
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateSelect((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1, (gutils->getWidth() == 1) ? revarg_2 : gutils->extractMeta(Builder2, revarg_2, idx));
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::fma:
 case Intrinsic::fmuladd:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
        Value *res = Constant::getNullValue(gutils->getShadowType(I.getType()));
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *dif = diffe(I.getOperand(0), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FMul
              auto fwdarg_0 = dif;
              auto fwdarg_1 = gutils->getNewFromOriginal(I.getOperand(1));
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        if (!gutils->isConstantValue(I.getOperand(1))) {
          Value *dif = diffe(I.getOperand(1), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = ({
              // Computing FMul
              auto fwdarg_0 = dif;
              auto fwdarg_1 = gutils->getNewFromOriginal(I.getOperand(0));
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? fwdarg_0 : gutils->extractMeta(Builder2, fwdarg_0, idx), fwdarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        if (!gutils->isConstantValue(I.getOperand(2))) {
          Value *dif = diffe(I.getOperand(2), Builder2);
          Value *arg_diff_tmp = UndefValue::get(res->getType());
          {
            Value *itmp = dif;
            arg_diff_tmp = GradientUtils::recursiveFAdd(Builder2,res, itmp, {}, {}, arg_diff_tmp, gutils->getWidth() != 1);
          }
          res = arg_diff_tmp;
        }
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        } else if (!dif && !gutils->isConstantValue(I.getOperand(1))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        } else if (!dif && !gutils->isConstantValue(I.getOperand(2))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FMul
              auto revarg_0 = dif;
              auto revarg_1 = lookup(gutils->getNewFromOriginal(I.getOperand(1)), Builder2);
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        if (!gutils->isConstantValue(I.getOperand(1))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing FMul
              auto revarg_0 = dif;
              auto revarg_1 = lookup(gutils->getNewFromOriginal(I.getOperand(0)), Builder2);
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateFMul((gutils->getWidth() == 1) ? revarg_0 : gutils->extractMeta(Builder2, revarg_0, idx), revarg_1);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(1)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(1), toadd, Builder2, I.getOperand(1)->getType());
        }
        if (!gutils->isConstantValue(I.getOperand(2))) {
          Value *toadd = nullptr;
          {
            Value *tmp = dif;
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(2)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(2), toadd, Builder2, I.getOperand(2)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
 case Intrinsic::vector_reduce_fadd:
 {
    CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&I));
    IRBuilder<> BuilderZ(newCall);
    BuilderZ.setFastMathFlags(getFast());
    if (gutils->knownRecomputeHeuristic.find(&I) !=
        gutils->knownRecomputeHeuristic.end()) {
        if (!gutils->knownRecomputeHeuristic[&I]) {
          gutils->cacheForReverse(BuilderZ, newCall,
                                  getIndex(&I, CacheType::Self, BuilderZ));
        }
    }
    eraseIfUnused(I);
    if (gutils->isConstantInstruction(&I))
      return true;
    switch (Mode) {
      case DerivativeMode::ForwardModeSplit:
      case DerivativeMode::ForwardMode:{
        IRBuilder<> Builder2(&I);
        getForwardBuilder(Builder2);
            Value *res = ({
              // Computing Call
              auto fwdnsrarg_0 = ({
                // Computing SelectIfActive
                llvm::Value *imVal = nullptr;
                if (!gutils->isConstantValue(I.getOperand(0))) {
                  imVal = gutils->invertPointerM(I.getOperand(0), Builder2);
                } else {
                  imVal = Constant::getNullValue(I.getOperand(0)->getType());
                  llvm::Value* vec_imVal = gutils->getWidth() == 1 ? imVal : UndefValue::get(gutils->getShadowType(imVal->getType()));
                  if (gutils->getWidth() != 1)
                    for (size_t i=0; i<gutils->getWidth(); i++)
                      vec_imVal = Builder2.CreateInsertValue(vec_imVal, imVal, std::vector<unsigned>({(unsigned)i}));
                  imVal = vec_imVal;
                }
                imVal;
              });
              auto fwdnsrarg_1 = ({
                // Computing SelectIfActive
                llvm::Value *imVal = nullptr;
                if (!gutils->isConstantValue(I.getOperand(1))) {
                  imVal = gutils->invertPointerM(I.getOperand(1), Builder2);
                } else {
                  imVal = Constant::getNullValue(I.getOperand(1)->getType());
                  llvm::Value* vec_imVal = gutils->getWidth() == 1 ? imVal : UndefValue::get(gutils->getShadowType(imVal->getType()));
                  if (gutils->getWidth() != 1)
                    for (size_t i=0; i<gutils->getWidth(); i++)
                      vec_imVal = Builder2.CreateInsertValue(vec_imVal, imVal, std::vector<unsigned>({(unsigned)i}));
                  imVal = vec_imVal;
                }
                imVal;
              });
              auto callval = cast<CallInst>(&I)->getCalledOperand();
              auto FT = cast<CallInst>(&I)->getFunctionType();
              auto cconv = cast<CallInst>(&I)->getCallingConv();
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                CallInst *V = cast<CallInst>(Builder2.CreateCall(FT, callval, ArrayRef<Value*>({(gutils->getWidth() == 1) ? fwdnsrarg_0 : gutils->extractMeta(Builder2, fwdnsrarg_0, idx), (gutils->getWidth() == 1) ? fwdnsrarg_1 : gutils->extractMeta(Builder2, fwdnsrarg_1, idx)})));
                V->setDebugLoc(gutils->getNewFromOriginal(I.getDebugLoc()));
                V->setCallingConv(cconv);
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
        assert(res);
        setDiffe(&I, res, Builder2);
        break;
      }
      case DerivativeMode::ReverseModeGradient:
      case DerivativeMode::ReverseModeCombined:{
        IRBuilder<> Builder2(&I);
        getReverseBuilder(Builder2);
        Value *dif = nullptr;
        if (!dif && !gutils->isConstantValue(I.getOperand(0))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        } else if (!dif && !gutils->isConstantValue(I.getOperand(1))) {
          dif = diffe(&I, Builder2);
          setDiffe(&I, Constant::getNullValue(gutils->getShadowType(I.getType())), Builder2);
        }
        if (!gutils->isConstantValue(I.getOperand(0))) {
          Value *toadd = nullptr;
          {
            Value *tmp = dif;
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(0)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(0), toadd, Builder2, I.getOperand(0)->getType());
        }
        if (!gutils->isConstantValue(I.getOperand(1))) {
          Value *toadd = nullptr;
          {
            Value *tmp = ({
              // Computing VectorSplat
              auto revarg_0 = cast<VectorType>(I.getOperand(1)->getType())->getElementCount();
              auto revarg_1 = dif;
              Value *res = nullptr;
              for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
                Value *V = Builder2.CreateVectorSplat(revarg_0, (gutils->getWidth() == 1) ? revarg_1 : gutils->extractMeta(Builder2, revarg_1, idx));
                if (gutils->getWidth() == 1) res = V;
                else {
                  if (idx == 0) res = UndefValue::get(ArrayType::get(V->getType(), gutils->getWidth()));
                  res = Builder2.CreateInsertValue(res, V, {idx});
                }
              }
              res;
            });
            Value *out = UndefValue::get(gutils->getShadowType(I.getOperand(1)->getType()));
            for(unsigned int idx=0, W=gutils->getWidth(); idx<W; idx++) {
              Value *prev = toadd ? (gutils->getWidth() == 1 ? toadd : gutils->extractMeta(Builder2, toadd, idx)) : nullptr;
              Value *next = tmp;
              if (gutils->getWidth() > 1) next = gutils->extractMeta(Builder2, next, idx);
              if (prev) next = Builder2.CreateFAdd(prev, next);
              out = (gutils->getWidth() > 1) ? Builder2.CreateInsertValue(out, next, idx) : next;
            }
            toadd = out;
          }
          if (toadd) addToDiffe(I.getOperand(1), toadd, Builder2, I.getOperand(1)->getType());
        }
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
      case DerivativeMode::ReverseModePrimal:{
        auto found = gutils->invertedPointers.find(&(I));
        if (found != gutils->invertedPointers.end()) {
          PHINode* PN = cast<PHINode>(&*found->second);
          gutils->invertedPointers.erase(found);
          gutils->erase(PN);
        }
        break;
      }
    }
    return true;
  }
