/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Rewriters                                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

bool handleBLAS(llvm::CallInst &call, llvm::Function *called,BlasInfo blas,const std::vector<bool> &overwritten_args) {         
  using llvm::Type;                                                
  bool result = true;                                              
  if (!gutils->isConstantInstruction(&call)) {                     
    Type *fpType;                                                  
    if (blas.floatType == "d" || blas.floatType == "D") {      
      fpType = Type::getDoubleTy(call.getContext());               
    } else if (blas.floatType == "s" || blas.floatType == "S"){
      fpType = Type::getFloatTy(call.getContext());                
    } else {                                                       
      assert(false && "Unreachable");                            
    }                                                              
     if (blas.function == "axpy") {                           
      result = handle_axpy(blas, call, called, overwritten_args, fpType);                 
    } else  if (blas.function == "copy") {                           
      result = handle_copy(blas, call, called, overwritten_args, fpType);                 
    } else  if (blas.function == "dot") {                           
      result = handle_dot(blas, call, called, overwritten_args, fpType);                 
    } else  if (blas.function == "gemm") {                           
      result = handle_gemm(blas, call, called, overwritten_args, fpType);                 
    } else  if (blas.function == "gemv") {                           
      result = handle_gemv(blas, call, called, overwritten_args, fpType);                 
    } else  if (blas.function == "scal") {                           
      result = handle_scal(blas, call, called, overwritten_args, fpType);                 
    } else  if (blas.function == "spmv") {                           
      result = handle_spmv(blas, call, called, overwritten_args, fpType);                 
    } else {                                                       
      llvm::errs() << " fallback?\n";                           
      return false;                                                
    }                                                              
  } else {                                                         
    if (Mode == DerivativeMode::ReverseModeGradient) {             
      eraseIfUnused(call, /*erase*/ true, /*check*/ false);        
    } else {                                                       
      eraseIfUnused(call);                                         
    }                                                              
    if (gutils->knownRecomputeHeuristic.find(&call) !=
      gutils->knownRecomputeHeuristic.end()) {
      if (!gutils->knownRecomputeHeuristic[&call]) {
       auto newCall = gutils->getNewFromOriginal(&call);
       llvm::IRBuilder<> BuilderZ(newCall);
       gutils->cacheForReverse(BuilderZ, newCall,
       getIndex(&call, CacheType::Self, BuilderZ));
      }
    }
  }
  return result;                                                   
}                                                                  
enum cublasOperation_t {
  CUBLAS_OP_N = 0,
  CUBLAS_OP_T = 1,
  CUBLAS_OP_C = 2,
};

bool handle_axpy(BlasInfo blas, llvm::CallInst &call, llvm::Function *called,
    const std::vector<bool> &overwritten_args, llvm::Type *fpType) {
  
#ifdef __clang__
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wunused-but-set-variable"
#else
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif
  using namespace llvm;
  CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&call));
  IRBuilder<> BuilderZ(newCall);
  BuilderZ.setFastMathFlags(getFast());
  IRBuilder<> allocationBuilder(gutils->inversionAllocs);
  allocationBuilder.setFastMathFlags(getFast());
  // never cache in Fwd Mode
  const bool cacheMode = (Mode != DerivativeMode::ForwardMode);
  const bool byRef = blas.prefix == "" || blas.prefix == "cublas_";
  const bool cblas = blas.prefix == "cblas_";
  const bool cublas = blas.prefix == "cublas_" || blas.prefix == "cublas";
  Value *cacheval = nullptr;

  const int offset = (cublas ? 1 : 0);
// Next ones shall only be called in the cublas case,
// they have incorrect meaning otherwise
  const int pos_handle = 0;
  Value *orig_handle = nullptr;
  Value *arg_handle = nullptr;
  Type *type_handle = nullptr;
  bool overwritten_handle = true;
  if (cublas) {
    orig_handle = call.getArgOperand(pos_handle);
    arg_handle = gutils->getNewFromOriginal(orig_handle);
    type_handle = arg_handle->getType();
    overwritten_handle = (cacheMode ? overwritten_args[pos_handle] : false);

  }

  const int pos_n = 0 + offset;
  const auto orig_n = call.getArgOperand(pos_n);
  auto arg_n = gutils->getNewFromOriginal(orig_n);
  const auto type_n = arg_n->getType();
  const bool overwritten_n = (cacheMode ? overwritten_args[pos_n] : false);

  const int pos_alpha = 1 + offset;
  const auto orig_alpha = call.getArgOperand(pos_alpha);
  auto arg_alpha = gutils->getNewFromOriginal(orig_alpha);
  const auto type_alpha = arg_alpha->getType();
  const bool overwritten_alpha = (cacheMode ? overwritten_args[pos_alpha] : false);
  bool active_alpha = !gutils->isConstantValue(orig_alpha);
  Value *rt_inactive_alpha = nullptr;

  const int pos_x = 2 + offset;
  const auto orig_x = call.getArgOperand(pos_x);
  auto arg_x = gutils->getNewFromOriginal(orig_x);
  const auto type_x = arg_x->getType();
  const bool overwritten_x = (cacheMode ? overwritten_args[pos_x] : false);
  bool active_x = !gutils->isConstantValue(orig_x);
  Value *rt_inactive_x = nullptr;

  const int pos_incx = 3 + offset;
  const auto orig_incx = call.getArgOperand(pos_incx);
  auto arg_incx = gutils->getNewFromOriginal(orig_incx);
  const auto type_incx = arg_incx->getType();
  const bool overwritten_incx = (cacheMode ? overwritten_args[pos_incx] : false);

  const int pos_y = 4 + offset;
  const auto orig_y = call.getArgOperand(pos_y);
  auto arg_y = gutils->getNewFromOriginal(orig_y);
  const auto type_y = arg_y->getType();
  const bool overwritten_y = (cacheMode ? overwritten_args[pos_y] : false);
  bool active_y = !gutils->isConstantValue(orig_y);
  Value *rt_inactive_y = nullptr;

  const int pos_incy = 5 + offset;
  const auto orig_incy = call.getArgOperand(pos_incy);
  auto arg_incy = gutils->getNewFromOriginal(orig_incy);
  const auto type_incy = arg_incy->getType();
  const bool overwritten_incy = (cacheMode ? overwritten_args[pos_incy] : false);


  // <X> is inactive either if gutils->isConstantValue(<X>)
  // returns true, or if runtimeActivity is on and the
  // shadow points to the primal arg.
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (byRef && active_alpha) {
      auto shadow_alpha = gutils->invertPointerM(orig_alpha, BuilderZ);
      rt_inactive_alpha = BuilderZ.CreateICmpEQ(shadow_alpha, arg_alpha, "rt.tmp.inactive." "alpha");
    }
    if (active_x) {
      auto shadow_x = gutils->invertPointerM(orig_x, BuilderZ);
      rt_inactive_x = BuilderZ.CreateICmpEQ(shadow_x, arg_x, "rt.tmp.inactive." "x");
    }
    if (active_y) {
      auto shadow_y = gutils->invertPointerM(orig_y, BuilderZ);
      rt_inactive_y = BuilderZ.CreateICmpEQ(shadow_y, arg_y, "rt.tmp.inactive." "y");
    }
    Value *rt_inactive_out = nullptr;
    if (active_y) {
      rt_inactive_out = rt_inactive_y;
    } else {
      rt_inactive_out = ConstantInt::getTrue(BuilderZ.getContext());
    }
    if (byRef && active_alpha) {
      rt_inactive_alpha = BuilderZ.CreateOr(rt_inactive_alpha, rt_inactive_out, "rt.inactive." "alpha");
    }
    if (active_x) {
      rt_inactive_x = BuilderZ.CreateOr(rt_inactive_x, rt_inactive_out, "rt.inactive." "x");
    }
    if (active_y) {
      rt_inactive_y = BuilderZ.CreateOr(rt_inactive_y, rt_inactive_out, "rt.inactive." "y");
    }
  }
  Type* blasFPType = type_alpha;
  Type* blasCharType = byRef ? (Type*) getInt8PtrTy(call.getContext()) : (Type*) Type::getInt8Ty(call.getContext());
  Type* blasIntType = type_n;
  Type* cublas_retty = nullptr;
  Value* cublas_handle = nullptr;
  if (cublas) {
    cublas_retty = call.getFunctionType()->getReturnType();
    cublas_handle = call.getArgOperand(0);
  }
  const bool julia_decl = !type_x->isPointerTy();
  Type* type_vec_like = type_x;
  // fpType already given by blas type (s, d, c, z) 
  IntegerType *intType = dyn_cast<IntegerType>(type_n);
  // TODO: add Fortran testcases for Fortran ABI
  if (!intType) {
    const auto PT = cast<PointerType>(type_n);
    if (blas.is64)
      intType = IntegerType::get(PT->getContext(), 64);
    else
      intType = IntegerType::get(PT->getContext(), 32);
  }

  IntegerType *charType = IntegerType::get(intType->getContext(), 8);

  IntegerType *julia_decl_type = nullptr;
  if (julia_decl)
    julia_decl_type = intType;
  SmallVector<Type *, 2> cacheTypes;

  // len, fp, etc. must be preserved if overwritten
  bool need_n = active_x || active_alpha;
  bool need_alpha = active_x;
  bool need_x = active_alpha;
  bool need_incx = active_x || active_alpha;
  bool need_y = false;
  bool need_incy = active_x || active_alpha;
  bool cache_n = cacheMode && byRef && overwritten_n && need_n;
  bool cache_alpha = cacheMode && byRef && overwritten_alpha && need_alpha;
  bool cache_x = cacheMode && overwritten_x && need_x;
  bool cache_incx = cacheMode && byRef && overwritten_incx && need_incx;
  bool cache_y = cacheMode && overwritten_y && need_y;
  bool cache_incy = cacheMode && byRef && overwritten_incy && need_incy;
  if (cache_n)
    cacheTypes.push_back(intType);
  if (cache_alpha)
    cacheTypes.push_back(fpType);
  if (cache_incx)
    cacheTypes.push_back(intType);
  if (cache_incy)
    cacheTypes.push_back(intType);
  if (cache_x)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  if (cache_y)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  Type *cachetype = nullptr;
  switch (cacheTypes.size()) {
  case 0:
    break;
  case 1:
    cachetype = cacheTypes[0];
    break;
  default:
    cachetype = StructType::get(call.getContext(), cacheTypes);
    break;
  }

  if ((Mode == DerivativeMode::ReverseModeCombined ||
       Mode == DerivativeMode::ReverseModePrimal) && cachetype) {
    SmallVector<Value *, 2> cacheValues;
    if (byRef) {
        addValueToCache(arg_n, cache_n, intType, cacheValues, BuilderZ, "n");
        addValueToCache(arg_alpha, cache_alpha, fpType, cacheValues, BuilderZ, "alpha");
        addValueToCache(arg_incx, cache_incx, intType, cacheValues, BuilderZ, "incx");
        addValueToCache(arg_incy, cache_incy, intType, cacheValues, BuilderZ, "incy");
    }
    if (cache_x) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = arg_n;
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.x");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[2] = ValueType::Primal;
      if (byRef) valueTypes[3] = ValueType::Primal;
      if (byRef) valueTypes[0] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_x, arg_incx, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_x, arg_incx, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incx, byRef);
        Value *args[4] = {malins, arg_x, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cache_y) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = arg_n;
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.y");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[4] = ValueType::Primal;
      if (byRef) valueTypes[5] = ValueType::Primal;
      if (byRef) valueTypes[0] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_y, arg_incy, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_y, arg_incy, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incy, byRef);
        Value *args[4] = {malins, arg_y, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cacheValues.size() == 1) {
      cacheval = cacheValues[0];
    } else {
      cacheval = UndefValue::get(cachetype);
      for (auto&& tup : llvm::enumerate(cacheValues))
        cacheval = BuilderZ.CreateInsertValue(cacheval, tup.value(), tup.index());
    }
    gutils->cacheForReverse(BuilderZ, cacheval,
                            getIndex(&call, CacheType::Tape, BuilderZ));
  }
  unsigned cacheidx = 0;
  Value *true_incx = arg_incx;
  Value *free_x = nullptr;
  Value *true_incy = arg_incy;
  Value *free_y = nullptr;
  IRBuilder<> Builder2(&call);
  switch (Mode) {
    case DerivativeMode::ReverseModeCombined:
    case DerivativeMode::ReverseModeGradient:
      getReverseBuilder(Builder2);
      break;
    case DerivativeMode::ForwardMode:
    case DerivativeMode::ForwardModeSplit:
      Builder2.SetInsertPoint(BuilderZ.GetInsertBlock(),
                              BuilderZ.GetInsertPoint());
      Builder2.setFastMathFlags(getFast());
      break;
    case DerivativeMode::ReverseModePrimal:
      break;
  }

  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {

    if (cachetype) {
      if (Mode != DerivativeMode::ReverseModeCombined) {
        cacheval = BuilderZ.CreatePHI(cachetype, 0);
      }
      cacheval = gutils->cacheForReverse(
          BuilderZ, cacheval, getIndex(&call, CacheType::Tape, BuilderZ));
      if (Mode != DerivativeMode::ForwardModeSplit)
        cacheval = lookup(cacheval, Builder2);
    }

    if (byRef) {
      if (cache_n) {
        arg_n = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.n");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.n");
        Builder2.CreateStore(arg_n, alloc);
        arg_n = Builder2.CreatePointerCast(
            alloc, type_n, "cast.n");
        cacheidx++;
      }

      if (cache_alpha) {
        arg_alpha = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.alpha");
        auto alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "byref.alpha");
        Builder2.CreateStore(arg_alpha, alloc);
        arg_alpha = Builder2.CreatePointerCast(
            alloc, type_alpha, "cast.alpha");
        cacheidx++;
      }

      if (cache_incx) {
        arg_incx = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incx");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incx");
        Builder2.CreateStore(arg_incx, alloc);
        arg_incx = Builder2.CreatePointerCast(
            alloc, type_incx, "cast.incx");
        cacheidx++;
      }

      if (cache_incy) {
        arg_incy = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incy");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incy");
        Builder2.CreateStore(arg_incy, alloc);
        arg_incy = Builder2.CreatePointerCast(
            alloc, type_incy, "cast.incy");
        cacheidx++;
      }

    }
    if (cache_x) {
      arg_x = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.x");
      free_x = arg_x;
      if (type_x->isIntegerTy()) {
        arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
      } else if (arg_x->getType() != type_x){
        arg_x = Builder2.CreatePointerCast(arg_x, type_x);
      }
      cacheidx++;
    }
    if (cache_y) {
      arg_y = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.y");
      free_y = arg_y;
      if (type_y->isIntegerTy()) {
        arg_y = Builder2.CreatePtrToInt(arg_y, type_y);
      } else if (arg_y->getType() != type_y){
        arg_y = Builder2.CreatePointerCast(arg_y, type_y);
      }
      cacheidx++;
    }
  } else {

    if (type_x->isIntegerTy())
      arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
    if (type_y->isIntegerTy())
      arg_y = Builder2.CreatePtrToInt(arg_y, type_y);
  }
  /* fwd-rewrite */                                 
  if (Mode == DerivativeMode::ForwardMode ||        
      Mode == DerivativeMode::ForwardModeSplit) {   
                                                    
    auto callval = call.getCalledOperand();       

  if (EnzymeRuntimeActivityCheck) {
    std::string s;
    llvm::raw_string_ostream ss(s);
    ss << "axpy" << "\n";
    ss << call.getDebugLoc() << "\n";
    ss << "Runtime Activity not supported for BLAS calls" << "\n";
    if (CustomErrorHandler) {
      IRBuilder<> Builder2(&call);
      getForwardBuilder(BuilderZ);
      CustomErrorHandler(ss.str().c_str(), wrap(&call), ErrorType::NoDerivative,
                         gutils, nullptr, wrap(&BuilderZ));
      return false;
    } else {
      EmitFailure("Unsupported Mode", call.getDebugLoc(), &call, ss.str());
      return false;
    }
  }
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
    Value *d_x = active_x
     ? gutils->invertPointerM(orig_x, Builder2)
     : nullptr;
    Value *d_y = active_y
     ? gutils->invertPointerM(orig_y, Builder2)
     : nullptr;
    Value *d_alpha = Constant::getNullValue(gutils->getShadowType(fpType));
    Value *dres = applyChainRule(
        call.getType(), Builder2,
        [&](Value *d_alpha, Value *d_x, Value *d_y  ) {
      Value *dres = nullptr;
      if(active_alpha) {
        Value *args1[6] = {arg_n, d_alpha, arg_x, (cache_x ? const_one : arg_incx), arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          dres = Builder2.CreateCall(call.getFunctionType(), callval, args1, Defs);
      }
      if(active_x) {
        Value *args1[6] = {arg_n, arg_alpha, d_x, arg_incx, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      if(active_y) {
        Value *args1[6] = {arg_n, arg_alpha, arg_x, (cache_x ? const_one : arg_incx), d_y, arg_incy};
        auto Defs = gutils->getInvertedBundles(
          &call, {cache_alpha ? ValueType::Both : ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      return dres;
    },
    d_alpha, d_x, d_y);
    setDiffe(&call, dres, Builder2);
  }
  /* rev-rewrite */                                 
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient) {
    Value *alloc = nullptr;
    if (byRef && !cublas) {
      alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "ret");
    }

    Value *d_alpha = UndefValue::get(fpType);
    Value *d_x = active_x
     ? lookup(gutils->invertPointerM(orig_x, Builder2), Builder2)
     : nullptr;
    Value *d_y = active_y
     ? lookup(gutils->invertPointerM(orig_y, Builder2), Builder2)
     : nullptr;
    if (!cache_n && need_n)
      arg_n = lookup(arg_n, Builder2);
    if (!cache_alpha && need_alpha)
      arg_alpha = lookup(arg_alpha, Builder2);
    if (!cache_x && need_x)
      arg_x = lookup(arg_x, Builder2);
    if (!cache_incx && need_incx)
      arg_incx = lookup(arg_incx, Builder2);
    if (!cache_y && need_y)
      arg_y = lookup(arg_y, Builder2);
    if (!cache_incy && need_incy)
      arg_incy = lookup(arg_incy, Builder2);
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (byRef && active_alpha) {
      rt_inactive_alpha = lookup(rt_inactive_alpha, Builder2);
    }
    if (active_x) {
      rt_inactive_x = lookup(rt_inactive_x, Builder2);
    }
    if (active_y) {
      rt_inactive_y = lookup(rt_inactive_y, Builder2);
    }
  }
    applyChainRule(
      Builder2,
      [&](Value *d_x, Value *d_y) {
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
      auto bb_name = Builder2.GetInsertBlock()->getName();
      if (active_alpha && d_y) {
        BasicBlock *nextBlock_alpha = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode && byRef) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".alpha.active");
          nextBlock_alpha = gutils->addReverseBlock(activeBlock, bb_name + ".alpha.done");
          Builder2.CreateCondBr(rt_inactive_alpha, nextBlock_alpha, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        for (auto item : {arg_x, (cache_x ? const_one : arg_incx)}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
      if (!cublas) {
{
      SmallVector<Type*, 1> tys; for (auto arg : ArrayRef<Value *>(args1)) tys.push_back(arg->getType());
    llvm::FunctionType *FTdot = FunctionType::get(fpType, tys, false);
    auto derivcall_dot = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "dot" + blas.suffix, FTdot);
    if (auto F = dyn_cast<Function>(derivcall_dot.getCallee()))
    {
      attribute_dot(blas, F);
    }

        CallInst *cubcall = cast<CallInst>(Builder2.CreateCall(derivcall_dot, ArrayRef<Value *>(args1), Defs));
        if (byRef) {
          ((DiffeGradientUtils *)gutils)->addToInvertedPtrDiffe(&call, nullptr, fpType, 0, (called->getParent()->getDataLayout().getTypeSizeInBits(fpType)/8), orig_alpha, cubcall, Builder2);
        } else {
          addToDiffe(orig_alpha, cubcall, Builder2, fpType);
        }
}
      } else {
      }
        if (nextBlock_alpha && byRef) {
          Builder2.CreateBr(nextBlock_alpha);
          Builder2.SetInsertPoint(nextBlock_alpha);
        }
      }
      if (active_x && d_x && d_y) {
        BasicBlock *nextBlock_x = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".x.active");
          nextBlock_x = gutils->addReverseBlock(activeBlock, bb_name + ".x.done");
          Builder2.CreateCondBr(rt_inactive_x, nextBlock_x, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {arg_alpha}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        for (auto item : {d_x, arg_incx}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTaxpy;
    if (cublas) {
      FTaxpy = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTaxpy = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_axpy = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "axpy" + blas.suffix, FTaxpy);
    if (auto F = dyn_cast<Function>(derivcall_axpy.getCallee()))
    {
      attribute_axpy(blas, F);
    }

        Builder2.CreateCall(derivcall_axpy, args1, Defs);
        if (nextBlock_x) {
          Builder2.CreateBr(nextBlock_x);
          Builder2.SetInsertPoint(nextBlock_x);
        }
      }
    },
    d_x, d_y  );
  }
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {
    if (shouldFree()) {
      if (cache_x) {
        CreateDealloc(Builder2, free_x);
      }
      if (cache_y) {
        CreateDealloc(Builder2, free_y);
      }
    }
  }
                                                                   
  if (Mode == DerivativeMode::ReverseModeGradient) {               
    eraseIfUnused(call, /*erase*/ true, /*check*/ false);          
  } else {                                                         
    eraseIfUnused(call);                                           
  }                                                                
  if (gutils->knownRecomputeHeuristic.find(&call) !=
    gutils->knownRecomputeHeuristic.end()) {
    if (!gutils->knownRecomputeHeuristic[&call]) {
     auto cv = gutils->cacheForReverse(BuilderZ, newCall,
     getIndex(&call, CacheType::Self, BuilderZ));
    }
  }
  return true;
#ifdef __clang__
#pragma clang diagnostic pop
#else
#pragma GCC diagnostic pop
#endif
}


bool handle_copy(BlasInfo blas, llvm::CallInst &call, llvm::Function *called,
    const std::vector<bool> &overwritten_args, llvm::Type *fpType) {
  
#ifdef __clang__
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wunused-but-set-variable"
#else
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif
  using namespace llvm;
  CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&call));
  IRBuilder<> BuilderZ(newCall);
  BuilderZ.setFastMathFlags(getFast());
  IRBuilder<> allocationBuilder(gutils->inversionAllocs);
  allocationBuilder.setFastMathFlags(getFast());
  // never cache in Fwd Mode
  const bool cacheMode = (Mode != DerivativeMode::ForwardMode);
  const bool byRef = blas.prefix == "" || blas.prefix == "cublas_";
  const bool cblas = blas.prefix == "cblas_";
  const bool cublas = blas.prefix == "cublas_" || blas.prefix == "cublas";
  Value *cacheval = nullptr;

  const int offset = (cublas ? 1 : 0);
// Next ones shall only be called in the cublas case,
// they have incorrect meaning otherwise
  const int pos_handle = 0;
  Value *orig_handle = nullptr;
  Value *arg_handle = nullptr;
  Type *type_handle = nullptr;
  bool overwritten_handle = true;
  if (cublas) {
    orig_handle = call.getArgOperand(pos_handle);
    arg_handle = gutils->getNewFromOriginal(orig_handle);
    type_handle = arg_handle->getType();
    overwritten_handle = (cacheMode ? overwritten_args[pos_handle] : false);

  }

  const int pos_n = 0 + offset;
  const auto orig_n = call.getArgOperand(pos_n);
  auto arg_n = gutils->getNewFromOriginal(orig_n);
  const auto type_n = arg_n->getType();
  const bool overwritten_n = (cacheMode ? overwritten_args[pos_n] : false);

  const int pos_x = 1 + offset;
  const auto orig_x = call.getArgOperand(pos_x);
  auto arg_x = gutils->getNewFromOriginal(orig_x);
  const auto type_x = arg_x->getType();
  const bool overwritten_x = (cacheMode ? overwritten_args[pos_x] : false);
  bool active_x = !gutils->isConstantValue(orig_x);
  Value *rt_inactive_x = nullptr;

  const int pos_incx = 2 + offset;
  const auto orig_incx = call.getArgOperand(pos_incx);
  auto arg_incx = gutils->getNewFromOriginal(orig_incx);
  const auto type_incx = arg_incx->getType();
  const bool overwritten_incx = (cacheMode ? overwritten_args[pos_incx] : false);

  const int pos_y = 3 + offset;
  const auto orig_y = call.getArgOperand(pos_y);
  auto arg_y = gutils->getNewFromOriginal(orig_y);
  const auto type_y = arg_y->getType();
  const bool overwritten_y = (cacheMode ? overwritten_args[pos_y] : false);
  bool active_y = !gutils->isConstantValue(orig_y);
  Value *rt_inactive_y = nullptr;

  const int pos_incy = 4 + offset;
  const auto orig_incy = call.getArgOperand(pos_incy);
  auto arg_incy = gutils->getNewFromOriginal(orig_incy);
  const auto type_incy = arg_incy->getType();
  const bool overwritten_incy = (cacheMode ? overwritten_args[pos_incy] : false);


  // <X> is inactive either if gutils->isConstantValue(<X>)
  // returns true, or if runtimeActivity is on and the
  // shadow points to the primal arg.
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (active_x) {
      auto shadow_x = gutils->invertPointerM(orig_x, BuilderZ);
      rt_inactive_x = BuilderZ.CreateICmpEQ(shadow_x, arg_x, "rt.tmp.inactive." "x");
    }
    if (active_y) {
      auto shadow_y = gutils->invertPointerM(orig_y, BuilderZ);
      rt_inactive_y = BuilderZ.CreateICmpEQ(shadow_y, arg_y, "rt.tmp.inactive." "y");
    }
    Value *rt_inactive_out = nullptr;
    if (active_y) {
      rt_inactive_out = rt_inactive_y;
    } else {
      rt_inactive_out = ConstantInt::getTrue(BuilderZ.getContext());
    }
    if (active_x) {
      rt_inactive_x = BuilderZ.CreateOr(rt_inactive_x, rt_inactive_out, "rt.inactive." "x");
    }
    if (active_y) {
      rt_inactive_y = BuilderZ.CreateOr(rt_inactive_y, rt_inactive_out, "rt.inactive." "y");
    }
  }
  Type* blasFPType = byRef ? (Type*)PointerType::getUnqual(fpType) : (Type*)fpType;
  Type* blasCharType = byRef ? (Type*) getInt8PtrTy(call.getContext()) : (Type*) Type::getInt8Ty(call.getContext());
  Type* blasIntType = type_n;
  Type* cublas_retty = nullptr;
  Value* cublas_handle = nullptr;
  if (cublas) {
    cublas_retty = call.getFunctionType()->getReturnType();
    cublas_handle = call.getArgOperand(0);
  }
  const bool julia_decl = !type_x->isPointerTy();
  Type* type_vec_like = type_x;
  // fpType already given by blas type (s, d, c, z) 
  IntegerType *intType = dyn_cast<IntegerType>(type_n);
  // TODO: add Fortran testcases for Fortran ABI
  if (!intType) {
    const auto PT = cast<PointerType>(type_n);
    if (blas.is64)
      intType = IntegerType::get(PT->getContext(), 64);
    else
      intType = IntegerType::get(PT->getContext(), 32);
  }

  IntegerType *charType = IntegerType::get(intType->getContext(), 8);

  IntegerType *julia_decl_type = nullptr;
  if (julia_decl)
    julia_decl_type = intType;
  SmallVector<Type *, 2> cacheTypes;

  // len, fp, etc. must be preserved if overwritten
  bool need_n = active_y;
  bool need_x = false;
  bool need_incx = active_y;
  bool need_y = false;
  bool need_incy = active_y;
  bool cache_n = cacheMode && byRef && overwritten_n && need_n;
  bool cache_x = cacheMode && overwritten_x && need_x;
  bool cache_incx = cacheMode && byRef && overwritten_incx && need_incx;
  bool cache_y = cacheMode && overwritten_y && need_y;
  bool cache_incy = cacheMode && byRef && overwritten_incy && need_incy;
  if (cache_n)
    cacheTypes.push_back(intType);
  if (cache_incx)
    cacheTypes.push_back(intType);
  if (cache_incy)
    cacheTypes.push_back(intType);
  if (cache_x)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  if (cache_y)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  Type *cachetype = nullptr;
  switch (cacheTypes.size()) {
  case 0:
    break;
  case 1:
    cachetype = cacheTypes[0];
    break;
  default:
    cachetype = StructType::get(call.getContext(), cacheTypes);
    break;
  }

  if ((Mode == DerivativeMode::ReverseModeCombined ||
       Mode == DerivativeMode::ReverseModePrimal) && cachetype) {
    SmallVector<Value *, 2> cacheValues;
    if (byRef) {
        addValueToCache(arg_n, cache_n, intType, cacheValues, BuilderZ, "n");
        addValueToCache(arg_incx, cache_incx, intType, cacheValues, BuilderZ, "incx");
        addValueToCache(arg_incy, cache_incy, intType, cacheValues, BuilderZ, "incy");
    }
    if (cache_x) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = arg_n;
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.x");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[1] = ValueType::Primal;
      if (byRef) valueTypes[2] = ValueType::Primal;
      if (byRef) valueTypes[0] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_x, arg_incx, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_x, arg_incx, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incx, byRef);
        Value *args[4] = {malins, arg_x, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cache_y) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = arg_n;
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.y");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[3] = ValueType::Primal;
      if (byRef) valueTypes[4] = ValueType::Primal;
      if (byRef) valueTypes[0] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_y, arg_incy, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_y, arg_incy, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incy, byRef);
        Value *args[4] = {malins, arg_y, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cacheValues.size() == 1) {
      cacheval = cacheValues[0];
    } else {
      cacheval = UndefValue::get(cachetype);
      for (auto&& tup : llvm::enumerate(cacheValues))
        cacheval = BuilderZ.CreateInsertValue(cacheval, tup.value(), tup.index());
    }
    gutils->cacheForReverse(BuilderZ, cacheval,
                            getIndex(&call, CacheType::Tape, BuilderZ));
  }
  unsigned cacheidx = 0;
  Value *true_incx = arg_incx;
  Value *free_x = nullptr;
  Value *true_incy = arg_incy;
  Value *free_y = nullptr;
  IRBuilder<> Builder2(&call);
  switch (Mode) {
    case DerivativeMode::ReverseModeCombined:
    case DerivativeMode::ReverseModeGradient:
      getReverseBuilder(Builder2);
      break;
    case DerivativeMode::ForwardMode:
    case DerivativeMode::ForwardModeSplit:
      Builder2.SetInsertPoint(BuilderZ.GetInsertBlock(),
                              BuilderZ.GetInsertPoint());
      Builder2.setFastMathFlags(getFast());
      break;
    case DerivativeMode::ReverseModePrimal:
      break;
  }

  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {

    if (cachetype) {
      if (Mode != DerivativeMode::ReverseModeCombined) {
        cacheval = BuilderZ.CreatePHI(cachetype, 0);
      }
      cacheval = gutils->cacheForReverse(
          BuilderZ, cacheval, getIndex(&call, CacheType::Tape, BuilderZ));
      if (Mode != DerivativeMode::ForwardModeSplit)
        cacheval = lookup(cacheval, Builder2);
    }

    if (byRef) {
      if (cache_n) {
        arg_n = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.n");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.n");
        Builder2.CreateStore(arg_n, alloc);
        arg_n = Builder2.CreatePointerCast(
            alloc, type_n, "cast.n");
        cacheidx++;
      }

      if (cache_incx) {
        arg_incx = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incx");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incx");
        Builder2.CreateStore(arg_incx, alloc);
        arg_incx = Builder2.CreatePointerCast(
            alloc, type_incx, "cast.incx");
        cacheidx++;
      }

      if (cache_incy) {
        arg_incy = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incy");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incy");
        Builder2.CreateStore(arg_incy, alloc);
        arg_incy = Builder2.CreatePointerCast(
            alloc, type_incy, "cast.incy");
        cacheidx++;
      }

    }
    if (cache_x) {
      arg_x = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.x");
      free_x = arg_x;
      if (type_x->isIntegerTy()) {
        arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
      } else if (arg_x->getType() != type_x){
        arg_x = Builder2.CreatePointerCast(arg_x, type_x);
      }
      cacheidx++;
    }
    if (cache_y) {
      arg_y = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.y");
      free_y = arg_y;
      if (type_y->isIntegerTy()) {
        arg_y = Builder2.CreatePtrToInt(arg_y, type_y);
      } else if (arg_y->getType() != type_y){
        arg_y = Builder2.CreatePointerCast(arg_y, type_y);
      }
      cacheidx++;
    }
  } else {

    if (type_x->isIntegerTy())
      arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
    if (type_y->isIntegerTy())
      arg_y = Builder2.CreatePtrToInt(arg_y, type_y);
  }
  /* fwd-rewrite */                                 
  if (Mode == DerivativeMode::ForwardMode ||        
      Mode == DerivativeMode::ForwardModeSplit) {   
                                                    
    auto callval = call.getCalledOperand();       

  if (EnzymeRuntimeActivityCheck) {
    std::string s;
    llvm::raw_string_ostream ss(s);
    ss << "copy" << "\n";
    ss << call.getDebugLoc() << "\n";
    ss << "Runtime Activity not supported for BLAS calls" << "\n";
    if (CustomErrorHandler) {
      IRBuilder<> Builder2(&call);
      getForwardBuilder(BuilderZ);
      CustomErrorHandler(ss.str().c_str(), wrap(&call), ErrorType::NoDerivative,
                         gutils, nullptr, wrap(&BuilderZ));
      return false;
    } else {
      EmitFailure("Unsupported Mode", call.getDebugLoc(), &call, ss.str());
      return false;
    }
  }
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
    Value *d_x = active_x
     ? gutils->invertPointerM(orig_x, Builder2)
     : nullptr;
    Value *d_y = active_y
     ? gutils->invertPointerM(orig_y, Builder2)
     : nullptr;
    Value *dres = applyChainRule(
        call.getType(), Builder2,
        [&](Value *d_x, Value *d_y  ) {
      Value *dres = nullptr;
      if(active_x) {
        Value *args1[5] = {arg_n, d_x, arg_incx, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          dres = Builder2.CreateCall(call.getFunctionType(), callval, args1, Defs);
      }
      if(active_y) {
        Value *args1[5] = {arg_n, arg_x, (cache_x ? const_one : arg_incx), d_y, arg_incy};
        auto Defs = gutils->getInvertedBundles(
          &call, {cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      return dres;
    },
    d_x, d_y);
    setDiffe(&call, dres, Builder2);
  }
  /* rev-rewrite */                                 
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient) {
    Value *alloc = nullptr;
    if (byRef && !cublas) {
      alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "ret");
    }

    Value *d_x = active_x
     ? lookup(gutils->invertPointerM(orig_x, Builder2), Builder2)
     : nullptr;
    Value *d_y = active_y
     ? lookup(gutils->invertPointerM(orig_y, Builder2), Builder2)
     : nullptr;
    if (!cache_n && need_n)
      arg_n = lookup(arg_n, Builder2);
    if (!cache_x && need_x)
      arg_x = lookup(arg_x, Builder2);
    if (!cache_incx && need_incx)
      arg_incx = lookup(arg_incx, Builder2);
    if (!cache_y && need_y)
      arg_y = lookup(arg_y, Builder2);
    if (!cache_incy && need_incy)
      arg_incy = lookup(arg_incy, Builder2);
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (active_x) {
      rt_inactive_x = lookup(rt_inactive_x, Builder2);
    }
    if (active_y) {
      rt_inactive_y = lookup(rt_inactive_y, Builder2);
    }
  }
    applyChainRule(
      Builder2,
      [&](Value *d_x, Value *d_y) {
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
      auto bb_name = Builder2.GetInsertBlock()->getName();
      if (active_y && d_x && d_y) {
        BasicBlock *nextBlock_y = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".y.active");
          nextBlock_y = gutils->addReverseBlock(activeBlock, bb_name + ".y.done");
          Builder2.CreateCondBr(rt_inactive_y, nextBlock_y, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 1.0), byRef, blasFPType, allocationBuilder, "constant.fp.1.0")}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        for (auto item : {d_x, arg_incx}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTaxpy;
    if (cublas) {
      FTaxpy = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTaxpy = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_axpy = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "axpy" + blas.suffix, FTaxpy);
    if (auto F = dyn_cast<Function>(derivcall_axpy.getCallee()))
    {
      attribute_axpy(blas, F);
    }

        Builder2.CreateCall(derivcall_axpy, args1, Defs);
        if (nextBlock_y) {
          Builder2.CreateBr(nextBlock_y);
          Builder2.SetInsertPoint(nextBlock_y);
        }
      }
    },
    d_x, d_y  );
  }
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {
    if (shouldFree()) {
      if (cache_x) {
        CreateDealloc(Builder2, free_x);
      }
      if (cache_y) {
        CreateDealloc(Builder2, free_y);
      }
    }
  }
                                                                   
  if (Mode == DerivativeMode::ReverseModeGradient) {               
    eraseIfUnused(call, /*erase*/ true, /*check*/ false);          
  } else {                                                         
    eraseIfUnused(call);                                           
  }                                                                
  if (gutils->knownRecomputeHeuristic.find(&call) !=
    gutils->knownRecomputeHeuristic.end()) {
    if (!gutils->knownRecomputeHeuristic[&call]) {
     auto cv = gutils->cacheForReverse(BuilderZ, newCall,
     getIndex(&call, CacheType::Self, BuilderZ));
    }
  }
  return true;
#ifdef __clang__
#pragma clang diagnostic pop
#else
#pragma GCC diagnostic pop
#endif
}


bool handle_dot(BlasInfo blas, llvm::CallInst &call, llvm::Function *called,
    const std::vector<bool> &overwritten_args, llvm::Type *fpType) {
  
#ifdef __clang__
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wunused-but-set-variable"
#else
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif
  using namespace llvm;
  CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&call));
  IRBuilder<> BuilderZ(newCall);
  BuilderZ.setFastMathFlags(getFast());
  IRBuilder<> allocationBuilder(gutils->inversionAllocs);
  allocationBuilder.setFastMathFlags(getFast());
  // never cache in Fwd Mode
  const bool cacheMode = (Mode != DerivativeMode::ForwardMode);
  const bool byRef = blas.prefix == "" || blas.prefix == "cublas_";
  const bool cblas = blas.prefix == "cblas_";
  const bool cublas = blas.prefix == "cublas_" || blas.prefix == "cublas";
  Value *cacheval = nullptr;

  const int offset = (cublas ? 1 : 0);
// Next ones shall only be called in the cublas case,
// they have incorrect meaning otherwise
  const int pos_handle = 0;
  Value *orig_handle = nullptr;
  Value *arg_handle = nullptr;
  Type *type_handle = nullptr;
  bool overwritten_handle = true;
  if (cublas) {
    orig_handle = call.getArgOperand(pos_handle);
    arg_handle = gutils->getNewFromOriginal(orig_handle);
    type_handle = arg_handle->getType();
    overwritten_handle = (cacheMode ? overwritten_args[pos_handle] : false);

  }

  const int pos_n = 0 + offset;
  const auto orig_n = call.getArgOperand(pos_n);
  auto arg_n = gutils->getNewFromOriginal(orig_n);
  const auto type_n = arg_n->getType();
  const bool overwritten_n = (cacheMode ? overwritten_args[pos_n] : false);

  const int pos_x = 1 + offset;
  const auto orig_x = call.getArgOperand(pos_x);
  auto arg_x = gutils->getNewFromOriginal(orig_x);
  const auto type_x = arg_x->getType();
  const bool overwritten_x = (cacheMode ? overwritten_args[pos_x] : false);
  bool active_x = !gutils->isConstantValue(orig_x);
  Value *rt_inactive_x = nullptr;

  const int pos_incx = 2 + offset;
  const auto orig_incx = call.getArgOperand(pos_incx);
  auto arg_incx = gutils->getNewFromOriginal(orig_incx);
  const auto type_incx = arg_incx->getType();
  const bool overwritten_incx = (cacheMode ? overwritten_args[pos_incx] : false);

  const int pos_y = 3 + offset;
  const auto orig_y = call.getArgOperand(pos_y);
  auto arg_y = gutils->getNewFromOriginal(orig_y);
  const auto type_y = arg_y->getType();
  const bool overwritten_y = (cacheMode ? overwritten_args[pos_y] : false);
  bool active_y = !gutils->isConstantValue(orig_y);
  Value *rt_inactive_y = nullptr;

  const int pos_incy = 4 + offset;
  const auto orig_incy = call.getArgOperand(pos_incy);
  auto arg_incy = gutils->getNewFromOriginal(orig_incy);
  const auto type_incy = arg_incy->getType();
  const bool overwritten_incy = (cacheMode ? overwritten_args[pos_incy] : false);

  if (cublas) {
    const int pos_ret = 5;
    const auto orig_ret = call.getArgOperand(pos_ret);
    auto arg_ret = gutils->getNewFromOriginal(orig_ret);
    const auto type_ret = arg_ret->getType();
    const bool overwritten_ret = (cacheMode ? overwritten_args[pos_ret] : false);
    bool active_ret = !gutils->isConstantValue(orig_ret);
    Value *rt_inactive_ret = nullptr;
  }


  // <X> is inactive either if gutils->isConstantValue(<X>)
  // returns true, or if runtimeActivity is on and the
  // shadow points to the primal arg.
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (active_x) {
      auto shadow_x = gutils->invertPointerM(orig_x, BuilderZ);
      rt_inactive_x = BuilderZ.CreateICmpEQ(shadow_x, arg_x, "rt.tmp.inactive." "x");
    }
    if (active_y) {
      auto shadow_y = gutils->invertPointerM(orig_y, BuilderZ);
      rt_inactive_y = BuilderZ.CreateICmpEQ(shadow_y, arg_y, "rt.tmp.inactive." "y");
    }
  }
  Type* blasFPType = byRef ? (Type*)PointerType::getUnqual(fpType) : (Type*)fpType;
  Type* blasCharType = byRef ? (Type*) getInt8PtrTy(call.getContext()) : (Type*) Type::getInt8Ty(call.getContext());
  Type* blasIntType = type_n;
  Type* cublas_retty = nullptr;
  Value* cublas_handle = nullptr;
  if (cublas) {
    cublas_retty = call.getFunctionType()->getReturnType();
    cublas_handle = call.getArgOperand(0);
  }
  const bool julia_decl = !type_x->isPointerTy();
  Type* type_vec_like = type_x;
  // fpType already given by blas type (s, d, c, z) 
  IntegerType *intType = dyn_cast<IntegerType>(type_n);
  // TODO: add Fortran testcases for Fortran ABI
  if (!intType) {
    const auto PT = cast<PointerType>(type_n);
    if (blas.is64)
      intType = IntegerType::get(PT->getContext(), 64);
    else
      intType = IntegerType::get(PT->getContext(), 32);
  }

  IntegerType *charType = IntegerType::get(intType->getContext(), 8);

  IntegerType *julia_decl_type = nullptr;
  if (julia_decl)
    julia_decl_type = intType;
  SmallVector<Type *, 2> cacheTypes;

  // len, fp, etc. must be preserved if overwritten
  bool need_n = active_x || active_y;
  bool need_x = active_y;
  bool need_incx = active_x || active_y;
  bool need_y = active_x;
  bool need_incy = active_x || active_y;
  bool cache_n = cacheMode && byRef && overwritten_n && need_n;
  bool cache_x = cacheMode && overwritten_x && need_x;
  bool cache_incx = cacheMode && byRef && overwritten_incx && need_incx;
  bool cache_y = cacheMode && overwritten_y && need_y;
  bool cache_incy = cacheMode && byRef && overwritten_incy && need_incy;
  if (cache_n)
    cacheTypes.push_back(intType);
  if (cache_incx)
    cacheTypes.push_back(intType);
  if (cache_incy)
    cacheTypes.push_back(intType);
  if (cache_x)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  if (cache_y)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  Type *cachetype = nullptr;
  switch (cacheTypes.size()) {
  case 0:
    break;
  case 1:
    cachetype = cacheTypes[0];
    break;
  default:
    cachetype = StructType::get(call.getContext(), cacheTypes);
    break;
  }

  if ((Mode == DerivativeMode::ReverseModeCombined ||
       Mode == DerivativeMode::ReverseModePrimal) && cachetype) {
    SmallVector<Value *, 2> cacheValues;
    if (byRef) {
        addValueToCache(arg_n, cache_n, intType, cacheValues, BuilderZ, "n");
        addValueToCache(arg_incx, cache_incx, intType, cacheValues, BuilderZ, "incx");
        addValueToCache(arg_incy, cache_incy, intType, cacheValues, BuilderZ, "incy");
    }
    if (cache_x) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = arg_n;
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.x");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[1] = ValueType::Primal;
      if (byRef) valueTypes[2] = ValueType::Primal;
      if (byRef) valueTypes[0] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_x, arg_incx, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_x, arg_incx, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incx, byRef);
        Value *args[4] = {malins, arg_x, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cache_y) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = arg_n;
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.y");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[3] = ValueType::Primal;
      if (byRef) valueTypes[4] = ValueType::Primal;
      if (byRef) valueTypes[0] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_y, arg_incy, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_y, arg_incy, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incy, byRef);
        Value *args[4] = {malins, arg_y, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cacheValues.size() == 1) {
      cacheval = cacheValues[0];
    } else {
      cacheval = UndefValue::get(cachetype);
      for (auto&& tup : llvm::enumerate(cacheValues))
        cacheval = BuilderZ.CreateInsertValue(cacheval, tup.value(), tup.index());
    }
    gutils->cacheForReverse(BuilderZ, cacheval,
                            getIndex(&call, CacheType::Tape, BuilderZ));
  }
  unsigned cacheidx = 0;
  Value *true_incx = arg_incx;
  Value *free_x = nullptr;
  Value *true_incy = arg_incy;
  Value *free_y = nullptr;
  IRBuilder<> Builder2(&call);
  switch (Mode) {
    case DerivativeMode::ReverseModeCombined:
    case DerivativeMode::ReverseModeGradient:
      getReverseBuilder(Builder2);
      break;
    case DerivativeMode::ForwardMode:
    case DerivativeMode::ForwardModeSplit:
      Builder2.SetInsertPoint(BuilderZ.GetInsertBlock(),
                              BuilderZ.GetInsertPoint());
      Builder2.setFastMathFlags(getFast());
      break;
    case DerivativeMode::ReverseModePrimal:
      break;
  }

  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {

    if (cachetype) {
      if (Mode != DerivativeMode::ReverseModeCombined) {
        cacheval = BuilderZ.CreatePHI(cachetype, 0);
      }
      cacheval = gutils->cacheForReverse(
          BuilderZ, cacheval, getIndex(&call, CacheType::Tape, BuilderZ));
      if (Mode != DerivativeMode::ForwardModeSplit)
        cacheval = lookup(cacheval, Builder2);
    }

    if (byRef) {
      if (cache_n) {
        arg_n = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.n");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.n");
        Builder2.CreateStore(arg_n, alloc);
        arg_n = Builder2.CreatePointerCast(
            alloc, type_n, "cast.n");
        cacheidx++;
      }

      if (cache_incx) {
        arg_incx = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incx");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incx");
        Builder2.CreateStore(arg_incx, alloc);
        arg_incx = Builder2.CreatePointerCast(
            alloc, type_incx, "cast.incx");
        cacheidx++;
      }

      if (cache_incy) {
        arg_incy = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incy");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incy");
        Builder2.CreateStore(arg_incy, alloc);
        arg_incy = Builder2.CreatePointerCast(
            alloc, type_incy, "cast.incy");
        cacheidx++;
      }

    }
    if (cache_x) {
      arg_x = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.x");
      free_x = arg_x;
      if (type_x->isIntegerTy()) {
        arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
      } else if (arg_x->getType() != type_x){
        arg_x = Builder2.CreatePointerCast(arg_x, type_x);
      }
      cacheidx++;
    }
    if (cache_y) {
      arg_y = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.y");
      free_y = arg_y;
      if (type_y->isIntegerTy()) {
        arg_y = Builder2.CreatePtrToInt(arg_y, type_y);
      } else if (arg_y->getType() != type_y){
        arg_y = Builder2.CreatePointerCast(arg_y, type_y);
      }
      cacheidx++;
    }
  } else {

    if (type_x->isIntegerTy())
      arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
    if (type_y->isIntegerTy())
      arg_y = Builder2.CreatePtrToInt(arg_y, type_y);
  }
  /* fwd-rewrite */                                 
  if (Mode == DerivativeMode::ForwardMode ||        
      Mode == DerivativeMode::ForwardModeSplit) {   
                                                    
    auto callval = call.getCalledOperand();       

  if (EnzymeRuntimeActivityCheck) {
    std::string s;
    llvm::raw_string_ostream ss(s);
    ss << "dot" << "\n";
    ss << call.getDebugLoc() << "\n";
    ss << "Runtime Activity not supported for BLAS calls" << "\n";
    if (CustomErrorHandler) {
      IRBuilder<> Builder2(&call);
      getForwardBuilder(BuilderZ);
      CustomErrorHandler(ss.str().c_str(), wrap(&call), ErrorType::NoDerivative,
                         gutils, nullptr, wrap(&BuilderZ));
      return false;
    } else {
      EmitFailure("Unsupported Mode", call.getDebugLoc(), &call, ss.str());
      return false;
    }
  }
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
    Value *d_x = active_x
     ? gutils->invertPointerM(orig_x, Builder2)
     : nullptr;
    Value *d_y = active_y
     ? gutils->invertPointerM(orig_y, Builder2)
     : nullptr;
    Value *dres = applyChainRule(
        call.getType(), Builder2,
        [&](Value *d_x, Value *d_y  ) {
      Value *dres = nullptr;
      if(active_x) {
        Value *args1[5] = {arg_n, d_x, arg_incx, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          dres = Builder2.CreateCall(call.getFunctionType(), callval, args1, Defs);
      }
      if(active_y) {
        Value *args1[5] = {arg_n, arg_x, (cache_x ? const_one : arg_incx), d_y, arg_incy};
        auto Defs = gutils->getInvertedBundles(
          &call, {cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      return dres;
    },
    d_x, d_y);
    setDiffe(&call, dres, Builder2);
  }
  /* rev-rewrite */                                 
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient) {
    Value *alloc = nullptr;
    if (byRef && !cublas) {
      alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "ret");
    }

    Value *dif = cublas ? gutils->invertPointerM(call.getArgOperand(5 + offset), Builder2) : diffe(&call, Builder2);
    Value *d_x = active_x
     ? lookup(gutils->invertPointerM(orig_x, Builder2), Builder2)
     : nullptr;
    Value *d_y = active_y
     ? lookup(gutils->invertPointerM(orig_y, Builder2), Builder2)
     : nullptr;
    if (!cache_n && need_n)
      arg_n = lookup(arg_n, Builder2);
    if (!cache_x && need_x)
      arg_x = lookup(arg_x, Builder2);
    if (!cache_incx && need_incx)
      arg_incx = lookup(arg_incx, Builder2);
    if (!cache_y && need_y)
      arg_y = lookup(arg_y, Builder2);
    if (!cache_incy && need_incy)
      arg_incy = lookup(arg_incy, Builder2);
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (active_x) {
      rt_inactive_x = lookup(rt_inactive_x, Builder2);
    }
    if (active_y) {
      rt_inactive_y = lookup(rt_inactive_y, Builder2);
    }
  }
    applyChainRule(
      Builder2,
      [&](Value *d_x, Value *d_y, Value *dif) {
        if (byRef && !cublas) {
          Builder2.CreateStore(dif, alloc);
          dif = alloc;
        }
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
      auto bb_name = Builder2.GetInsertBlock()->getName();
      if (active_x && d_x) {
        BasicBlock *nextBlock_x = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".x.active");
          nextBlock_x = gutils->addReverseBlock(activeBlock, bb_name + ".x.done");
          Builder2.CreateCondBr(rt_inactive_x, nextBlock_x, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {dif}) args1.push_back(item);
        for (auto item : {arg_y, (cache_y ? const_one : arg_incy)}) args1.push_back(item);
        for (auto item : {d_x, arg_incx}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTaxpy;
    if (cublas) {
      FTaxpy = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTaxpy = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_axpy = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "axpy" + blas.suffix, FTaxpy);
    if (auto F = dyn_cast<Function>(derivcall_axpy.getCallee()))
    {
      attribute_axpy(blas, F);
    }

        Builder2.CreateCall(derivcall_axpy, args1, Defs);
        if (nextBlock_x) {
          Builder2.CreateBr(nextBlock_x);
          Builder2.SetInsertPoint(nextBlock_x);
        }
      }
      if (active_y && d_y) {
        BasicBlock *nextBlock_y = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".y.active");
          nextBlock_y = gutils->addReverseBlock(activeBlock, bb_name + ".y.done");
          Builder2.CreateCondBr(rt_inactive_y, nextBlock_y, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {dif}) args1.push_back(item);
        for (auto item : {arg_x, (cache_x ? const_one : arg_incx)}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTaxpy;
    if (cublas) {
      FTaxpy = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTaxpy = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_axpy = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "axpy" + blas.suffix, FTaxpy);
    if (auto F = dyn_cast<Function>(derivcall_axpy.getCallee()))
    {
      attribute_axpy(blas, F);
    }

        Builder2.CreateCall(derivcall_axpy, args1, Defs);
        if (nextBlock_y) {
          Builder2.CreateBr(nextBlock_y);
          Builder2.SetInsertPoint(nextBlock_y);
        }
      }
    if (cublas)
      Builder2.CreateStore(Constant::getNullValue(fpType), dif);
    },
    d_x, d_y, dif);
  if (!cublas)
    setDiffe(
      &call,
      Constant::getNullValue(gutils->getShadowType(call.getType())),
      Builder2);
  }
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {
    if (shouldFree()) {
      if (cache_x) {
        CreateDealloc(Builder2, free_x);
      }
      if (cache_y) {
        CreateDealloc(Builder2, free_y);
      }
    }
  }
                                                                   
  if (Mode == DerivativeMode::ReverseModeGradient) {               
    eraseIfUnused(call, /*erase*/ true, /*check*/ false);          
  } else {                                                         
    eraseIfUnused(call);                                           
  }                                                                
  if (gutils->knownRecomputeHeuristic.find(&call) !=
    gutils->knownRecomputeHeuristic.end()) {
    if (!gutils->knownRecomputeHeuristic[&call]) {
     auto cv = gutils->cacheForReverse(BuilderZ, newCall,
     getIndex(&call, CacheType::Self, BuilderZ));
    }
  }
  return true;
#ifdef __clang__
#pragma clang diagnostic pop
#else
#pragma GCC diagnostic pop
#endif
}


bool handle_gemm(BlasInfo blas, llvm::CallInst &call, llvm::Function *called,
    const std::vector<bool> &overwritten_args, llvm::Type *fpType) {
  
#ifdef __clang__
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wunused-but-set-variable"
#else
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif
  using namespace llvm;
  CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&call));
  IRBuilder<> BuilderZ(newCall);
  BuilderZ.setFastMathFlags(getFast());
  IRBuilder<> allocationBuilder(gutils->inversionAllocs);
  allocationBuilder.setFastMathFlags(getFast());
  // never cache in Fwd Mode
  const bool cacheMode = (Mode != DerivativeMode::ForwardMode);
  const bool byRef = blas.prefix == "" || blas.prefix == "cublas_";
  const bool cblas = blas.prefix == "cblas_";
  const bool cublas = blas.prefix == "cublas_" || blas.prefix == "cublas";
  Value *cacheval = nullptr;

  const int offset = ((cblas || cublas) ? 1 : 0);
// Next ones shall only be called in the cublas case,
// they have incorrect meaning otherwise
  const int pos_handle = 0;
  Value *orig_handle = nullptr;
  Value *arg_handle = nullptr;
  Type *type_handle = nullptr;
  bool overwritten_handle = true;
  if (cublas) {
    orig_handle = call.getArgOperand(pos_handle);
    arg_handle = gutils->getNewFromOriginal(orig_handle);
    type_handle = arg_handle->getType();
    overwritten_handle = (cacheMode ? overwritten_args[pos_handle] : false);

  }

// Next ones shall only be called in the cblas case,
// they have incorrect meaning otherwise
  const int pos_layout = 0;
  const auto orig_layout = call.getArgOperand(pos_layout);
  auto arg_layout = gutils->getNewFromOriginal(orig_layout);
  const auto type_layout = arg_layout->getType();
  const bool overwritten_layout = (cacheMode ? overwritten_args[pos_layout] : false);

  const int pos_transa = 0 + offset;
  const auto orig_transa = call.getArgOperand(pos_transa);
  auto arg_transa = gutils->getNewFromOriginal(orig_transa);
  const auto type_transa = arg_transa->getType();
  const bool overwritten_transa = (cacheMode ? overwritten_args[pos_transa] : false);

  const int pos_transb = 1 + offset;
  const auto orig_transb = call.getArgOperand(pos_transb);
  auto arg_transb = gutils->getNewFromOriginal(orig_transb);
  const auto type_transb = arg_transb->getType();
  const bool overwritten_transb = (cacheMode ? overwritten_args[pos_transb] : false);

  const int pos_m = 2 + offset;
  const auto orig_m = call.getArgOperand(pos_m);
  auto arg_m = gutils->getNewFromOriginal(orig_m);
  const auto type_m = arg_m->getType();
  const bool overwritten_m = (cacheMode ? overwritten_args[pos_m] : false);

  const int pos_n = 3 + offset;
  const auto orig_n = call.getArgOperand(pos_n);
  auto arg_n = gutils->getNewFromOriginal(orig_n);
  const auto type_n = arg_n->getType();
  const bool overwritten_n = (cacheMode ? overwritten_args[pos_n] : false);

  const int pos_k = 4 + offset;
  const auto orig_k = call.getArgOperand(pos_k);
  auto arg_k = gutils->getNewFromOriginal(orig_k);
  const auto type_k = arg_k->getType();
  const bool overwritten_k = (cacheMode ? overwritten_args[pos_k] : false);

  const int pos_alpha = 5 + offset;
  const auto orig_alpha = call.getArgOperand(pos_alpha);
  auto arg_alpha = gutils->getNewFromOriginal(orig_alpha);
  const auto type_alpha = arg_alpha->getType();
  const bool overwritten_alpha = (cacheMode ? overwritten_args[pos_alpha] : false);
  bool active_alpha = !gutils->isConstantValue(orig_alpha);
  Value *rt_inactive_alpha = nullptr;

  const int pos_A = 6 + offset;
  const auto orig_A = call.getArgOperand(pos_A);
  auto arg_A = gutils->getNewFromOriginal(orig_A);
  const auto type_A = arg_A->getType();
  const bool overwritten_A = (cacheMode ? overwritten_args[pos_A] : false);
  bool active_A = !gutils->isConstantValue(orig_A);
  Value *rt_inactive_A = nullptr;

  const int pos_lda = 7 + offset;
  const auto orig_lda = call.getArgOperand(pos_lda);
  auto arg_lda = gutils->getNewFromOriginal(orig_lda);
  const auto type_lda = arg_lda->getType();
  const bool overwritten_lda = (cacheMode ? overwritten_args[pos_lda] : false);

  const int pos_B = 8 + offset;
  const auto orig_B = call.getArgOperand(pos_B);
  auto arg_B = gutils->getNewFromOriginal(orig_B);
  const auto type_B = arg_B->getType();
  const bool overwritten_B = (cacheMode ? overwritten_args[pos_B] : false);
  bool active_B = !gutils->isConstantValue(orig_B);
  Value *rt_inactive_B = nullptr;

  const int pos_ldb = 9 + offset;
  const auto orig_ldb = call.getArgOperand(pos_ldb);
  auto arg_ldb = gutils->getNewFromOriginal(orig_ldb);
  const auto type_ldb = arg_ldb->getType();
  const bool overwritten_ldb = (cacheMode ? overwritten_args[pos_ldb] : false);

  const int pos_beta = 10 + offset;
  const auto orig_beta = call.getArgOperand(pos_beta);
  auto arg_beta = gutils->getNewFromOriginal(orig_beta);
  const auto type_beta = arg_beta->getType();
  const bool overwritten_beta = (cacheMode ? overwritten_args[pos_beta] : false);
  bool active_beta = !gutils->isConstantValue(orig_beta);
  Value *rt_inactive_beta = nullptr;

  const int pos_C = 11 + offset;
  const auto orig_C = call.getArgOperand(pos_C);
  auto arg_C = gutils->getNewFromOriginal(orig_C);
  const auto type_C = arg_C->getType();
  const bool overwritten_C = (cacheMode ? overwritten_args[pos_C] : false);
  bool active_C = !gutils->isConstantValue(orig_C);
  Value *rt_inactive_C = nullptr;

  const int pos_ldc = 12 + offset;
  const auto orig_ldc = call.getArgOperand(pos_ldc);
  auto arg_ldc = gutils->getNewFromOriginal(orig_ldc);
  const auto type_ldc = arg_ldc->getType();
  const bool overwritten_ldc = (cacheMode ? overwritten_args[pos_ldc] : false);


  // <X> is inactive either if gutils->isConstantValue(<X>)
  // returns true, or if runtimeActivity is on and the
  // shadow points to the primal arg.
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (byRef && active_alpha) {
      auto shadow_alpha = gutils->invertPointerM(orig_alpha, BuilderZ);
      rt_inactive_alpha = BuilderZ.CreateICmpEQ(shadow_alpha, arg_alpha, "rt.tmp.inactive." "alpha");
    }
    if (active_A) {
      auto shadow_A = gutils->invertPointerM(orig_A, BuilderZ);
      rt_inactive_A = BuilderZ.CreateICmpEQ(shadow_A, arg_A, "rt.tmp.inactive." "A");
    }
    if (active_B) {
      auto shadow_B = gutils->invertPointerM(orig_B, BuilderZ);
      rt_inactive_B = BuilderZ.CreateICmpEQ(shadow_B, arg_B, "rt.tmp.inactive." "B");
    }
    if (byRef && active_beta) {
      auto shadow_beta = gutils->invertPointerM(orig_beta, BuilderZ);
      rt_inactive_beta = BuilderZ.CreateICmpEQ(shadow_beta, arg_beta, "rt.tmp.inactive." "beta");
    }
    if (active_C) {
      auto shadow_C = gutils->invertPointerM(orig_C, BuilderZ);
      rt_inactive_C = BuilderZ.CreateICmpEQ(shadow_C, arg_C, "rt.tmp.inactive." "C");
    }
    Value *rt_inactive_out = nullptr;
    if (active_C) {
      rt_inactive_out = rt_inactive_C;
    } else {
      rt_inactive_out = ConstantInt::getTrue(BuilderZ.getContext());
    }
    if (byRef && active_alpha) {
      rt_inactive_alpha = BuilderZ.CreateOr(rt_inactive_alpha, rt_inactive_out, "rt.inactive." "alpha");
    }
    if (active_A) {
      rt_inactive_A = BuilderZ.CreateOr(rt_inactive_A, rt_inactive_out, "rt.inactive." "A");
    }
    if (active_B) {
      rt_inactive_B = BuilderZ.CreateOr(rt_inactive_B, rt_inactive_out, "rt.inactive." "B");
    }
    if (byRef && active_beta) {
      rt_inactive_beta = BuilderZ.CreateOr(rt_inactive_beta, rt_inactive_out, "rt.inactive." "beta");
    }
    if (active_C) {
      rt_inactive_C = BuilderZ.CreateOr(rt_inactive_C, rt_inactive_out, "rt.inactive." "C");
    }
  }
  Type* blasFPType = type_alpha;
  Type* blasCharType = type_transa;
  Type *cublasEnumType = nullptr;
  if (cublas) cublasEnumType = type_transa;
  Type* blasIntType = type_m;
  Type* cublas_retty = nullptr;
  Value* cublas_handle = nullptr;
  if (cublas) {
    cublas_retty = call.getFunctionType()->getReturnType();
    cublas_handle = call.getArgOperand(0);
  }
  const bool julia_decl = !type_A->isPointerTy();
  Type* type_vec_like = type_A;
  // fpType already given by blas type (s, d, c, z) 
  IntegerType *intType = dyn_cast<IntegerType>(type_n);
  // TODO: add Fortran testcases for Fortran ABI
  if (!intType) {
    const auto PT = cast<PointerType>(type_n);
    if (blas.is64)
      intType = IntegerType::get(PT->getContext(), 64);
    else
      intType = IntegerType::get(PT->getContext(), 32);
  }

  IntegerType *charType = IntegerType::get(intType->getContext(), 8);

  IntegerType *julia_decl_type = nullptr;
  if (julia_decl)
    julia_decl_type = intType;
  Value *valueN = nullptr;
  Value *valueT = nullptr;
  Value *valueG = nullptr;
  if (cublas) {
    valueN = ConstantInt::get(cublasEnumType, cublasOperation_t::CUBLAS_OP_N);
    valueT = ConstantInt::get(cublasEnumType, cublasOperation_t::CUBLAS_OP_T);
    // TODO lascl not available in cublas, nor op G
    valueG = ConstantInt::get(cublasEnumType, 'G');
  } else {
    valueN = ConstantInt::get(charType, 'N');
    valueT = ConstantInt::get(charType, 'T');
    valueG = ConstantInt::get(charType, 'G');
  }

  SmallVector<Type *, 2> cacheTypes;

  // len, fp, etc. must be preserved if overwritten
  bool need_transa = active_A || active_B || active_alpha;
  bool need_transb = active_A || active_B || active_alpha;
  bool need_m = active_A || active_B || active_beta || active_alpha || active_C;
  bool need_n = active_A || active_B || active_beta || active_alpha || active_C;
  bool need_k = active_A || active_B || active_alpha;
  bool need_alpha = active_A || active_B;
  bool need_A = active_B || active_alpha;
  bool need_lda = active_A || active_B || active_alpha;
  bool need_B = active_A || active_alpha;
  bool need_ldb = active_A || active_B || active_alpha;
  bool need_beta = active_C;
  bool need_C = false;
  bool need_ldc = active_A || active_B || active_beta || active_alpha || active_C;
  bool cache_transa = cacheMode && byRef && overwritten_transa && need_transa;
  bool cache_transb = cacheMode && byRef && overwritten_transb && need_transb;
  bool cache_m = cacheMode && byRef && overwritten_m && need_m;
  bool cache_n = cacheMode && byRef && overwritten_n && need_n;
  bool cache_k = cacheMode && byRef && overwritten_k && need_k;
  bool cache_alpha = cacheMode && byRef && overwritten_alpha && need_alpha;
  bool cache_A = cacheMode && overwritten_A && need_A;
  bool cache_lda = cacheMode && byRef && overwritten_lda && need_lda;
  bool cache_B = cacheMode && overwritten_B && need_B;
  bool cache_ldb = cacheMode && byRef && overwritten_ldb && need_ldb;
  bool cache_beta = cacheMode && byRef && overwritten_beta && need_beta;
  bool cache_C = cacheMode && overwritten_C && need_C;
  bool cache_ldc = cacheMode && byRef && overwritten_ldc && need_ldc;
  // we cache the following matrix,
  // since one rule uses input<C>
  if (active_beta) {
    need_C = true;
    cache_C = true;
  }
  if (cache_transa)
    cacheTypes.push_back(charType);
  if (cache_transb)
    cacheTypes.push_back(charType);
  if (cache_m)
    cacheTypes.push_back(intType);
  if (cache_n)
    cacheTypes.push_back(intType);
  if (cache_k)
    cacheTypes.push_back(intType);
  if (cache_alpha)
    cacheTypes.push_back(fpType);
  if (cache_lda)
    cacheTypes.push_back(intType);
  if (cache_ldb)
    cacheTypes.push_back(intType);
  if (cache_beta)
    cacheTypes.push_back(fpType);
  if (cache_ldc)
    cacheTypes.push_back(intType);
  if (cache_A)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  if (cache_B)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  if (cache_C)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  Type *cachetype = nullptr;
  switch (cacheTypes.size()) {
  case 0:
    break;
  case 1:
    cachetype = cacheTypes[0];
    break;
  default:
    cachetype = StructType::get(call.getContext(), cacheTypes);
    break;
  }

  if ((Mode == DerivativeMode::ReverseModeCombined ||
       Mode == DerivativeMode::ReverseModePrimal) && cachetype) {
    SmallVector<Value *, 2> cacheValues;
    if (byRef) {
        addValueToCache(arg_transa, cache_transa, charType, cacheValues, BuilderZ, "transa");
        addValueToCache(arg_transb, cache_transb, charType, cacheValues, BuilderZ, "transb");
        addValueToCache(arg_m, cache_m, intType, cacheValues, BuilderZ, "m");
        addValueToCache(arg_n, cache_n, intType, cacheValues, BuilderZ, "n");
        addValueToCache(arg_k, cache_k, intType, cacheValues, BuilderZ, "k");
        addValueToCache(arg_alpha, cache_alpha, fpType, cacheValues, BuilderZ, "alpha");
        addValueToCache(arg_lda, cache_lda, intType, cacheValues, BuilderZ, "lda");
        addValueToCache(arg_ldb, cache_ldb, intType, cacheValues, BuilderZ, "ldb");
        addValueToCache(arg_beta, cache_beta, fpType, cacheValues, BuilderZ, "beta");
        addValueToCache(arg_ldc, cache_ldc, intType, cacheValues, BuilderZ, "ldc");
    }
    if (cache_A) {
      auto charTy = IntegerType::get(intType->getContext(), 8);
      Value *M, *N;
      Value *normal = is_normal(BuilderZ, arg_transa, byRef, cublas);
      M = BuilderZ.CreateSelect(normal, arg_m, arg_k);
      N = BuilderZ.CreateSelect(normal, arg_k, arg_m);
      auto *len1 = load_if_ref(BuilderZ, intType, M, byRef);
      auto *len2 = load_if_ref(BuilderZ, intType, N, byRef);
      auto *matSize = BuilderZ.CreateMul(len1, len2);
      auto malins = CreateAllocation(BuilderZ, fpType, matSize, "cache.A");
      SmallVector<ValueType, 7> valueTypes = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
       valueTypes[7] = ValueType::Primal;
      if (byRef) valueTypes[8] = ValueType::Primal;
      if (byRef) valueTypes[1] = ValueType::Primal;
      if (byRef) valueTypes[3] = ValueType::Primal;
      if (byRef) valueTypes[5] = ValueType::Primal;
      if (EnzymeLapackCopy) {
        Value *uplo = llvm::ConstantInt::get(charTy, 0);
        uplo = to_blas_callconv(BuilderZ, uplo, byRef, cublas, nullptr, allocationBuilder, "copy.garbage");
        SmallVector<Value *, 7> args = {uplo, M, N, arg_A, arg_lda, malins, M};
        if (!byRef) {
           args.insert(args.begin(), arg_layout); valueTypes.insert(valueTypes.begin(), ValueType::Primal); }
        callMemcpyStridedLapack(BuilderZ, *gutils->oldFunc->getParent(), blas, args, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
        auto dmemcpy = getOrInsertMemcpyMat(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *len_lda = load_if_ref(BuilderZ, intType, arg_lda, byRef);
        Value *args[5] = {malins, arg_A, len1, len2, len_lda};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cache_B) {
      auto charTy = IntegerType::get(intType->getContext(), 8);
      Value *M, *N;
      Value *normal = is_normal(BuilderZ, arg_transb, byRef, cublas);
      M = BuilderZ.CreateSelect(normal, arg_k, arg_n);
      N = BuilderZ.CreateSelect(normal, arg_n, arg_k);
      auto *len1 = load_if_ref(BuilderZ, intType, M, byRef);
      auto *len2 = load_if_ref(BuilderZ, intType, N, byRef);
      auto *matSize = BuilderZ.CreateMul(len1, len2);
      auto malins = CreateAllocation(BuilderZ, fpType, matSize, "cache.B");
      SmallVector<ValueType, 7> valueTypes = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
       valueTypes[9] = ValueType::Primal;
      if (byRef) valueTypes[10] = ValueType::Primal;
      if (byRef) valueTypes[2] = ValueType::Primal;
      if (byRef) valueTypes[5] = ValueType::Primal;
      if (byRef) valueTypes[4] = ValueType::Primal;
      if (EnzymeLapackCopy) {
        Value *uplo = llvm::ConstantInt::get(charTy, 0);
        uplo = to_blas_callconv(BuilderZ, uplo, byRef, cublas, nullptr, allocationBuilder, "copy.garbage");
        SmallVector<Value *, 7> args = {uplo, M, N, arg_B, arg_ldb, malins, M};
        if (!byRef) {
           args.insert(args.begin(), arg_layout); valueTypes.insert(valueTypes.begin(), ValueType::Primal); }
        callMemcpyStridedLapack(BuilderZ, *gutils->oldFunc->getParent(), blas, args, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
        auto dmemcpy = getOrInsertMemcpyMat(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *len_lda = load_if_ref(BuilderZ, intType, arg_ldb, byRef);
        Value *args[5] = {malins, arg_B, len1, len2, len_lda};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cache_C) {
      auto charTy = IntegerType::get(intType->getContext(), 8);
      Value *M, *N;
      M = arg_m;
      N = arg_n;
      auto *len1 = load_if_ref(BuilderZ, intType, M, byRef);
      auto *len2 = load_if_ref(BuilderZ, intType, N, byRef);
      auto *matSize = BuilderZ.CreateMul(len1, len2);
      auto malins = CreateAllocation(BuilderZ, fpType, matSize, "cache.C");
      SmallVector<ValueType, 7> valueTypes = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
       valueTypes[12] = ValueType::Primal;
      if (byRef) valueTypes[13] = ValueType::Primal;
      if (byRef) valueTypes[3] = ValueType::Primal;
      if (byRef) valueTypes[4] = ValueType::Primal;
      if (EnzymeLapackCopy) {
        Value *uplo = llvm::ConstantInt::get(charTy, 0);
        uplo = to_blas_callconv(BuilderZ, uplo, byRef, cublas, nullptr, allocationBuilder, "copy.garbage");
        SmallVector<Value *, 7> args = {uplo, M, N, arg_C, arg_ldc, malins, M};
        if (!byRef) {
           args.insert(args.begin(), arg_layout); valueTypes.insert(valueTypes.begin(), ValueType::Primal); }
        callMemcpyStridedLapack(BuilderZ, *gutils->oldFunc->getParent(), blas, args, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
        auto dmemcpy = getOrInsertMemcpyMat(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *len_lda = load_if_ref(BuilderZ, intType, arg_ldc, byRef);
        Value *args[5] = {malins, arg_C, len1, len2, len_lda};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cacheValues.size() == 1) {
      cacheval = cacheValues[0];
    } else {
      cacheval = UndefValue::get(cachetype);
      for (auto&& tup : llvm::enumerate(cacheValues))
        cacheval = BuilderZ.CreateInsertValue(cacheval, tup.value(), tup.index());
    }
    gutils->cacheForReverse(BuilderZ, cacheval,
                            getIndex(&call, CacheType::Tape, BuilderZ));
  }
  unsigned cacheidx = 0;
  Value *true_lda = arg_lda;
  Value *lda = true_lda;
  Value *free_A = nullptr;
  Value *true_ldb = arg_ldb;
  Value *ldb = true_ldb;
  Value *free_B = nullptr;
  Value *input_C = nullptr;
  Value *free_input_C = nullptr;
  Value *true_ldc = arg_ldc;
  Value *ldc = true_ldc;
  Value *free_C = nullptr;
  IRBuilder<> Builder2(&call);
  switch (Mode) {
    case DerivativeMode::ReverseModeCombined:
    case DerivativeMode::ReverseModeGradient:
      getReverseBuilder(Builder2);
      break;
    case DerivativeMode::ForwardMode:
    case DerivativeMode::ForwardModeSplit:
      Builder2.SetInsertPoint(BuilderZ.GetInsertBlock(),
                              BuilderZ.GetInsertPoint());
      Builder2.setFastMathFlags(getFast());
      break;
    case DerivativeMode::ReverseModePrimal:
      break;
  }

  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {

    if (cachetype) {
      if (Mode != DerivativeMode::ReverseModeCombined) {
        cacheval = BuilderZ.CreatePHI(cachetype, 0);
      }
      cacheval = gutils->cacheForReverse(
          BuilderZ, cacheval, getIndex(&call, CacheType::Tape, BuilderZ));
      if (Mode != DerivativeMode::ForwardModeSplit)
        cacheval = lookup(cacheval, Builder2);
    }

    if (byRef) {
      if (cache_transa) {
        arg_transa = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.transa");
        auto alloc = allocationBuilder.CreateAlloca(charType, nullptr, "byref.transa");
        Builder2.CreateStore(arg_transa, alloc);
        arg_transa = Builder2.CreatePointerCast(
            alloc, type_transa, "cast.transa");
        cacheidx++;
      }

      if (cache_transb) {
        arg_transb = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.transb");
        auto alloc = allocationBuilder.CreateAlloca(charType, nullptr, "byref.transb");
        Builder2.CreateStore(arg_transb, alloc);
        arg_transb = Builder2.CreatePointerCast(
            alloc, type_transb, "cast.transb");
        cacheidx++;
      }

      if (cache_m) {
        arg_m = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.m");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.m");
        Builder2.CreateStore(arg_m, alloc);
        arg_m = Builder2.CreatePointerCast(
            alloc, type_m, "cast.m");
        cacheidx++;
      }

      if (cache_n) {
        arg_n = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.n");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.n");
        Builder2.CreateStore(arg_n, alloc);
        arg_n = Builder2.CreatePointerCast(
            alloc, type_n, "cast.n");
        cacheidx++;
      }

      if (cache_k) {
        arg_k = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.k");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.k");
        Builder2.CreateStore(arg_k, alloc);
        arg_k = Builder2.CreatePointerCast(
            alloc, type_k, "cast.k");
        cacheidx++;
      }

      if (cache_alpha) {
        arg_alpha = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.alpha");
        auto alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "byref.alpha");
        Builder2.CreateStore(arg_alpha, alloc);
        arg_alpha = Builder2.CreatePointerCast(
            alloc, type_alpha, "cast.alpha");
        cacheidx++;
      }

      if (cache_lda) {
        arg_lda = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.lda");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.lda");
        Builder2.CreateStore(arg_lda, alloc);
        arg_lda = Builder2.CreatePointerCast(
            alloc, type_lda, "cast.lda");
        cacheidx++;
      }

      if (cache_ldb) {
        arg_ldb = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.ldb");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.ldb");
        Builder2.CreateStore(arg_ldb, alloc);
        arg_ldb = Builder2.CreatePointerCast(
            alloc, type_ldb, "cast.ldb");
        cacheidx++;
      }

      if (cache_beta) {
        arg_beta = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.beta");
        auto alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "byref.beta");
        Builder2.CreateStore(arg_beta, alloc);
        arg_beta = Builder2.CreatePointerCast(
            alloc, type_beta, "cast.beta");
        cacheidx++;
      }

      if (cache_ldc) {
        arg_ldc = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.ldc");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.ldc");
        Builder2.CreateStore(arg_ldc, alloc);
        arg_ldc = Builder2.CreatePointerCast(
            alloc, type_ldc, "cast.ldc");
        cacheidx++;
      }

    }
    if (cache_A) {
      arg_A = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.A");
      free_A = arg_A;
      if (type_A->isIntegerTy()) {
        arg_A = Builder2.CreatePtrToInt(arg_A, type_A);
      } else if (arg_A->getType() != type_A){
        arg_A = Builder2.CreatePointerCast(arg_A, type_A);
      }
      cacheidx++;
    }
    if (cache_B) {
      arg_B = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.B");
      free_B = arg_B;
      if (type_B->isIntegerTy()) {
        arg_B = Builder2.CreatePtrToInt(arg_B, type_B);
      } else if (arg_B->getType() != type_B){
        arg_B = Builder2.CreatePointerCast(arg_B, type_B);
      }
      cacheidx++;
    }
    if (active_beta) {
      input_C = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.C");
      free_input_C = input_C;
      if (type_C->isIntegerTy()) {
        input_C = Builder2.CreatePtrToInt(input_C, type_C);
      } else if (input_C->getType() != type_C){
        input_C = Builder2.CreatePointerCast(input_C, type_C);
      }
    }
    if (cache_C) {
      arg_C = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.C");
      free_C = arg_C;
      if (type_C->isIntegerTy()) {
        arg_C = Builder2.CreatePtrToInt(arg_C, type_C);
      } else if (arg_C->getType() != type_C){
        arg_C = Builder2.CreatePointerCast(arg_C, type_C);
      }
      cacheidx++;
    }
  } else {

  }
  /* fwd-rewrite */                                 
  if (Mode == DerivativeMode::ForwardMode ||        
      Mode == DerivativeMode::ForwardModeSplit) {   
                                                    
    auto callval = call.getCalledOperand();       

  if (EnzymeRuntimeActivityCheck) {
    std::string s;
    llvm::raw_string_ostream ss(s);
    ss << "gemm" << "\n";
    ss << call.getDebugLoc() << "\n";
    ss << "Runtime Activity not supported for BLAS calls" << "\n";
    if (CustomErrorHandler) {
      IRBuilder<> Builder2(&call);
      getForwardBuilder(BuilderZ);
      CustomErrorHandler(ss.str().c_str(), wrap(&call), ErrorType::NoDerivative,
                         gutils, nullptr, wrap(&BuilderZ));
      return false;
    } else {
      EmitFailure("Unsupported Mode", call.getDebugLoc(), &call, ss.str());
      return false;
    }
  }
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
    Value *d_A = active_A
     ? gutils->invertPointerM(orig_A, Builder2)
     : nullptr;
    Value *d_B = active_B
     ? gutils->invertPointerM(orig_B, Builder2)
     : nullptr;
    Value *d_beta = Constant::getNullValue(gutils->getShadowType(fpType));
    Value *d_alpha = Constant::getNullValue(gutils->getShadowType(fpType));
    Value *d_C = active_C
     ? gutils->invertPointerM(orig_C, Builder2)
     : nullptr;
    Value *dres = applyChainRule(
        call.getType(), Builder2,
        [&](Value *d_alpha, Value *d_A, Value *d_B, Value *d_beta, Value *d_C  ) {
      Value *dres = nullptr;
      if(active_alpha) {
        Value *args1_cblas[14] =  {arg_layout, arg_transa, arg_transb, arg_m, arg_n, arg_k, d_alpha, arg_A, arg_lda, arg_B, arg_ldb, arg_beta, arg_C, arg_ldc};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[13] = {arg_transa, arg_transb, arg_m, arg_n, arg_k, d_alpha, arg_A, arg_lda, arg_B, arg_ldb, arg_beta, arg_C, arg_ldc};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          if (byRef) {
          dres = Builder2.CreateCall(call.getFunctionType(), callval, args1, Defs);
          } else /*cblas*/ {
          dres = Builder2.CreateCall(call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          };
      }
      if(active_A) {
        Value *args1_cblas[14] =  {arg_layout, arg_transa, arg_transb, arg_m, arg_n, arg_k, arg_alpha, d_A, true_lda, arg_B, arg_ldb, arg_beta, arg_C, arg_ldc};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[13] = {arg_transa, arg_transb, arg_m, arg_n, arg_k, arg_alpha, d_A, true_lda, arg_B, arg_ldb, arg_beta, arg_C, arg_ldc};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      if(active_B) {
        Value *args1_cblas[14] =  {arg_layout, arg_transa, arg_transb, arg_m, arg_n, arg_k, arg_alpha, arg_A, arg_lda, d_B, true_ldb, arg_beta, arg_C, arg_ldc};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[13] = {arg_transa, arg_transb, arg_m, arg_n, arg_k, arg_alpha, arg_A, arg_lda, d_B, true_ldb, arg_beta, arg_C, arg_ldc};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      if(active_beta) {
        Value *args1_cblas[14] =  {arg_layout, arg_transa, arg_transb, arg_m, arg_n, arg_k, arg_alpha, arg_A, arg_lda, arg_B, arg_ldb, d_beta, arg_C, arg_ldc};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[13] = {arg_transa, arg_transb, arg_m, arg_n, arg_k, arg_alpha, arg_A, arg_lda, arg_B, arg_ldb, d_beta, arg_C, arg_ldc};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      if(active_C) {
        Value *args1_cblas[14] =  {arg_layout, arg_transa, arg_transb, arg_m, arg_n, arg_k, arg_alpha, arg_A, arg_lda, arg_B, arg_ldb, arg_beta, d_C, true_ldc};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[13] = {arg_transa, arg_transb, arg_m, arg_n, arg_k, arg_alpha, arg_A, arg_lda, arg_B, arg_ldb, arg_beta, d_C, true_ldc};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      return dres;
    },
    d_alpha, d_A, d_B, d_beta, d_C);
    setDiffe(&call, dres, Builder2);
  }
  /* rev-rewrite */                                 
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient) {
    Value *alloc = nullptr;
    if (byRef && !cublas) {
      alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "ret");
    }

    //handling nested blas: 0
    //handled nested blas: 0
    Value *d_alpha = UndefValue::get(fpType);
    Value *d_A = active_A
     ? lookup(gutils->invertPointerM(orig_A, Builder2), Builder2)
     : nullptr;
    Value *d_B = active_B
     ? lookup(gutils->invertPointerM(orig_B, Builder2), Builder2)
     : nullptr;
    Value *d_beta = UndefValue::get(fpType);
    Value *d_C = active_C
     ? lookup(gutils->invertPointerM(orig_C, Builder2), Builder2)
     : nullptr;
    if (!cache_transa && need_transa)
      arg_transa = lookup(arg_transa, Builder2);
    if (!cache_transb && need_transb)
      arg_transb = lookup(arg_transb, Builder2);
    if (!cache_m && need_m)
      arg_m = lookup(arg_m, Builder2);
    if (!cache_n && need_n)
      arg_n = lookup(arg_n, Builder2);
    if (!cache_k && need_k)
      arg_k = lookup(arg_k, Builder2);
    if (!cache_alpha && need_alpha)
      arg_alpha = lookup(arg_alpha, Builder2);
    if (!cache_A && need_A)
      arg_A = lookup(arg_A, Builder2);
    if (!cache_lda && need_lda)
      arg_lda = lookup(arg_lda, Builder2);
    if (!cache_B && need_B)
      arg_B = lookup(arg_B, Builder2);
    if (!cache_ldb && need_ldb)
      arg_ldb = lookup(arg_ldb, Builder2);
    if (!cache_beta && need_beta)
      arg_beta = lookup(arg_beta, Builder2);
    if (!cache_C && need_C)
      arg_C = lookup(arg_C, Builder2);
    if (!cache_ldc && need_ldc)
      arg_ldc = lookup(arg_ldc, Builder2);
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (byRef && active_alpha) {
      rt_inactive_alpha = lookup(rt_inactive_alpha, Builder2);
    }
    if (active_A) {
      rt_inactive_A = lookup(rt_inactive_A, Builder2);
    }
    if (active_B) {
      rt_inactive_B = lookup(rt_inactive_B, Builder2);
    }
    if (byRef && active_beta) {
      rt_inactive_beta = lookup(rt_inactive_beta, Builder2);
    }
    if (active_C) {
      rt_inactive_C = lookup(rt_inactive_C, Builder2);
    }
  }
    llvm::Value* arg_transposed_transa = nullptr;
    llvm::Value* arg_transposed_transb = nullptr;
    applyChainRule(
      Builder2,
      [&](Value *d_A, Value *d_B, Value *d_C) {
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
      auto bb_name = Builder2.GetInsertBlock()->getName();
      // Seq
      if (active_alpha && d_C) {
        BasicBlock *nextBlock_alpha = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode && byRef) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".alpha.active");
          nextBlock_alpha = gutils->addReverseBlock(activeBlock, bb_name + ".alpha.done");
          Builder2.CreateCondBr(rt_inactive_alpha, nextBlock_alpha, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
    Value *len1 = load_if_ref(Builder2, intType,arg_m, byRef);
    Value *len2 = load_if_ref(Builder2, intType,arg_n, byRef);
    Value *size_AB = Builder2.CreateNUWMul(len1, len2, "size_AB");
    Value * true_mat_AB = CreateAllocation(Builder2, fpType, size_AB, "mat_AB");
    Value * mat_AB = true_mat_AB;
    if (type_vec_like->isIntegerTy()) {
      mat_AB = Builder2.CreatePtrToInt(mat_AB, type_vec_like);
    } else if (mat_AB->getType() != type_vec_like){
      mat_AB = Builder2.CreatePointerCast(mat_AB, type_vec_like);
    }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
        std::vector<Value *>args0;
        if (cblas) args0.push_back(arg_layout);
        if (cublas) args0.push_back(arg_handle);
        for (auto item : {arg_transa}) args0.push_back(item);
        for (auto item : {arg_transb}) args0.push_back(item);
        for (auto item : {arg_m}) args0.push_back(item);
        for (auto item : {arg_n}) args0.push_back(item);
        for (auto item : {arg_k}) args0.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 1.0), byRef, blasFPType, allocationBuilder, "constant.fp.1.0")}) args0.push_back(item);
        for (auto item : {arg_A}) args0.push_back(item);
        for (auto item : {get_cached_mat_width(Builder2, {arg_transa}, arg_lda, arg_k, arg_m, cache_A, byRef, cublas)}) args0.push_back(item);
        for (auto item : {arg_B}) args0.push_back(item);
        for (auto item : {get_cached_mat_width(Builder2, {arg_transb}, arg_ldb, arg_k, arg_n, cache_B, byRef, cublas)}) args0.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 0.0), byRef, blasFPType, allocationBuilder, "constant.fp.0.0")}) args0.push_back(item);
        for (auto item : {mat_AB}) args0.push_back(item);
        for (auto item : {arg_m}) args0.push_back(item);
        if (byRef) {
           args0.push_back(ConstantInt::get(intType, 1));
           args0.push_back(ConstantInt::get(intType, 1));
        }
    //handling nested blas: 0
    SmallVector<Type*, 1> tys; for (auto arg : args0) tys.push_back(arg->getType());
    llvm::FunctionType *FTgemm = FunctionType::get(Builder2.getVoidTy(), tys, false);
    auto derivcall_gemm = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "gemm" + blas.suffix, FTgemm);
    if (auto F = dyn_cast<Function>(derivcall_gemm.getCallee()))
    {
      attribute_gemm(blas, F);
    }

        Builder2.CreateCall(derivcall_gemm, args0, Defs);
    //handled nested blas: 0
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_m}) args1.push_back(item);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {d_C, arg_ldc}) args1.push_back(item);
        for (auto item : {mat_AB}) args1.push_back(item);
        if (byRef) {
        }
{
    auto derivcall_inner_prod = 
      getorInsertInnerProd(Builder2, *gutils->oldFunc->getParent(), blas, intType, type_vec_like, type_n, fpType, args1, Defs, byRef, cublas, julia_decl);
        CallInst *cubcall = cast<CallInst>(derivcall_inner_prod);
        if (byRef) {
          ((DiffeGradientUtils *)gutils)->addToInvertedPtrDiffe(&call, nullptr, fpType, 0, (called->getParent()->getDataLayout().getTypeSizeInBits(fpType)/8), orig_alpha, cubcall, Builder2);
        } else {
          addToDiffe(orig_alpha, cubcall, Builder2, fpType);
        }
}
    CreateDealloc(Builder2, true_mat_AB);
        if (nextBlock_alpha && byRef) {
          Builder2.CreateBr(nextBlock_alpha);
          Builder2.SetInsertPoint(nextBlock_alpha);
        }
      }
      if (active_A && d_C && d_A) {
        BasicBlock *nextBlock_A = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".A.active");
          nextBlock_A = gutils->addReverseBlock(activeBlock, bb_name + ".A.done");
          Builder2.CreateCondBr(rt_inactive_A, nextBlock_A, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cblas) args1.push_back(arg_layout);
        if (cublas) args1.push_back(arg_handle);
        for (auto item : ({auto brow_2 = ({auto concat_0 = {arg_transb}; auto concat_1 = {arg_transa}; auto concat_2 = {arg_k}; auto concat_3 = {arg_m}; concat_values<ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>>(concat_0, concat_1, concat_2, concat_3); }); auto brow_1 = ({auto concat_0 = {arg_transa}; auto concat_1 = {(arg_transposed_transb = arg_transposed_transb ? arg_transposed_transb : transpose(Builder2, arg_transb, byRef, cublas, charType, allocationBuilder, "transb"))}; auto concat_2 = {arg_m}; auto concat_3 = {arg_k}; concat_values<ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>>(concat_0, concat_1, concat_2, concat_3); }); auto brow_0 = {arg_transa}; get_blas_row(Builder2, brow_0, brow_1, brow_2, byRef, cublas);})) args1.push_back(item);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {arg_alpha}) args1.push_back(item);
        for (auto item : ({auto brow_2 = ({auto concat_0 = {arg_B}; auto concat_1 = {get_cached_mat_width(Builder2, {arg_transb}, arg_ldb, arg_n, arg_k, cache_B, byRef, cublas)}; auto concat_2 = {d_C, arg_ldc}; concat_values<ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>>(concat_0, concat_1, concat_2); }); auto brow_1 = ({auto concat_0 = {d_C, arg_ldc}; auto concat_1 = {arg_B}; auto concat_2 = {get_cached_mat_width(Builder2, {arg_transb}, arg_ldb, arg_n, arg_k, cache_B, byRef, cublas)}; concat_values<ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>>(concat_0, concat_1, concat_2); }); auto brow_0 = {arg_transa}; get_blas_row(Builder2, brow_0, brow_1, brow_2, byRef, cublas);})) args1.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 1.0), byRef, blasFPType, allocationBuilder, "constant.fp.1.0")}) args1.push_back(item);
        for (auto item : {d_A, arg_lda}) args1.push_back(item);
        if (byRef) {
           args1.push_back(ConstantInt::get(intType, 1));
           args1.push_back(ConstantInt::get(intType, 1));
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTgemm;
    if (cublas) {
      FTgemm = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTgemm = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_gemm = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "gemm" + blas.suffix, FTgemm);
    if (auto F = dyn_cast<Function>(derivcall_gemm.getCallee()))
    {
      attribute_gemm(blas, F);
    }

        Builder2.CreateCall(derivcall_gemm, args1, Defs);
        if (nextBlock_A) {
          Builder2.CreateBr(nextBlock_A);
          Builder2.SetInsertPoint(nextBlock_A);
        }
      }
      if (active_B && d_C && d_B) {
        BasicBlock *nextBlock_B = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".B.active");
          nextBlock_B = gutils->addReverseBlock(activeBlock, bb_name + ".B.done");
          Builder2.CreateCondBr(rt_inactive_B, nextBlock_B, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cblas) args1.push_back(arg_layout);
        if (cublas) args1.push_back(arg_handle);
        for (auto item : ({auto brow_2 = ({auto concat_0 = {arg_transb}; auto concat_1 = {arg_transa}; auto concat_2 = {arg_n}; auto concat_3 = {arg_k}; concat_values<ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>>(concat_0, concat_1, concat_2, concat_3); }); auto brow_1 = ({auto concat_0 = {(arg_transposed_transa = arg_transposed_transa ? arg_transposed_transa : transpose(Builder2, arg_transa, byRef, cublas, charType, allocationBuilder, "transa"))}; auto concat_1 = {arg_transb}; auto concat_2 = {arg_k}; auto concat_3 = {arg_n}; concat_values<ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>>(concat_0, concat_1, concat_2, concat_3); }); auto brow_0 = {arg_transb}; get_blas_row(Builder2, brow_0, brow_1, brow_2, byRef, cublas);})) args1.push_back(item);
        for (auto item : {arg_m}) args1.push_back(item);
        for (auto item : {arg_alpha}) args1.push_back(item);
        for (auto item : ({auto brow_2 = ({auto concat_0 = {d_C, arg_ldc}; auto concat_1 = {arg_A}; auto concat_2 = {get_cached_mat_width(Builder2, {arg_transa}, arg_lda, arg_k, arg_m, cache_A, byRef, cublas)}; concat_values<ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>>(concat_0, concat_1, concat_2); }); auto brow_1 = ({auto concat_0 = {arg_A}; auto concat_1 = {get_cached_mat_width(Builder2, {arg_transa}, arg_lda, arg_k, arg_m, cache_A, byRef, cublas)}; auto concat_2 = {d_C, arg_ldc}; concat_values<ArrayRef<Value*>, ArrayRef<Value*>, ArrayRef<Value*>>(concat_0, concat_1, concat_2); }); auto brow_0 = {arg_transb}; get_blas_row(Builder2, brow_0, brow_1, brow_2, byRef, cublas);})) args1.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 1.0), byRef, blasFPType, allocationBuilder, "constant.fp.1.0")}) args1.push_back(item);
        for (auto item : {d_B, arg_ldb}) args1.push_back(item);
        if (byRef) {
           args1.push_back(ConstantInt::get(intType, 1));
           args1.push_back(ConstantInt::get(intType, 1));
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTgemm;
    if (cublas) {
      FTgemm = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTgemm = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_gemm = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "gemm" + blas.suffix, FTgemm);
    if (auto F = dyn_cast<Function>(derivcall_gemm.getCallee()))
    {
      attribute_gemm(blas, F);
    }

        Builder2.CreateCall(derivcall_gemm, args1, Defs);
        if (nextBlock_B) {
          Builder2.CreateBr(nextBlock_B);
          Builder2.SetInsertPoint(nextBlock_B);
        }
      }
      // FrobInnerProd
      if (active_beta && d_C) {
        BasicBlock *nextBlock_beta = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode && byRef) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".beta.active");
          nextBlock_beta = gutils->addReverseBlock(activeBlock, bb_name + ".beta.done");
          Builder2.CreateCondBr(rt_inactive_beta, nextBlock_beta, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_m}) args1.push_back(item);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {d_C, arg_ldc}) args1.push_back(item);
        for (auto item : {input_C}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
{
    auto derivcall_inner_prod = 
      getorInsertInnerProd(Builder2, *gutils->oldFunc->getParent(), blas, intType, type_vec_like, type_n, fpType, ArrayRef<Value *>(args1), Defs, byRef, cublas, julia_decl);
        CallInst *cubcall = cast<CallInst>(derivcall_inner_prod);
        if (byRef) {
          ((DiffeGradientUtils *)gutils)->addToInvertedPtrDiffe(&call, nullptr, fpType, 0, (called->getParent()->getDataLayout().getTypeSizeInBits(fpType)/8), orig_beta, cubcall, Builder2);
        } else {
          addToDiffe(orig_beta, cubcall, Builder2, fpType);
        }
}
        if (nextBlock_beta && byRef) {
          Builder2.CreateBr(nextBlock_beta);
          Builder2.SetInsertPoint(nextBlock_beta);
        }
      }
      if (active_C && d_C) {
        BasicBlock *nextBlock_C = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".C.active");
          nextBlock_C = gutils->addReverseBlock(activeBlock, bb_name + ".C.done");
          Builder2.CreateCondBr(rt_inactive_C, nextBlock_C, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cblas) args1.push_back(arg_layout);
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {to_blas_callconv(Builder2, valueG, byRef, cublas, nullptr, allocationBuilder, "constant.char.G")}) args1.push_back(item);
        for (auto item : {to_blas_callconv(Builder2, ConstantInt::get(intType, 0), byRef, cublas, intType, allocationBuilder, "constant.int.0")}) args1.push_back(item);
        for (auto item : {to_blas_callconv(Builder2, ConstantInt::get(intType, 0), byRef, cublas, intType, allocationBuilder, "constant.int.0")}) args1.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 1.0), byRef, blasFPType, allocationBuilder, "constant.fp.1.0")}) args1.push_back(item);
        for (auto item : {arg_beta}) args1.push_back(item);
        for (auto item : {arg_m}) args1.push_back(item);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {d_C, arg_ldc}) args1.push_back(item);
        for (auto item : {allocationBuilder.CreateAlloca(intType)}) args1.push_back(item);
        if (byRef) {
           args1.push_back(ConstantInt::get(intType, 1));
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTlascl;
    if (cublas) {
      FTlascl = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTlascl = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_lascl = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "lascl" + blas.suffix, FTlascl);
    if (auto F = dyn_cast<Function>(derivcall_lascl.getCallee()))
    {
      attribute_lascl(blas, F);
    }

        Builder2.CreateCall(derivcall_lascl, args1, Defs);
        if (nextBlock_C) {
          Builder2.CreateBr(nextBlock_C);
          Builder2.SetInsertPoint(nextBlock_C);
        }
      }
    },
    d_A, d_B, d_C  );
  }
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {
    if (shouldFree()) {
      if (cache_A) {
        CreateDealloc(Builder2, free_A);
      }
      if (cache_B) {
        CreateDealloc(Builder2, free_B);
      }
      if (cache_C) {
        CreateDealloc(Builder2, free_C);
      }
    }
  }
                                                                   
  if (Mode == DerivativeMode::ReverseModeGradient) {               
    eraseIfUnused(call, /*erase*/ true, /*check*/ false);          
  } else {                                                         
    eraseIfUnused(call);                                           
  }                                                                
  if (gutils->knownRecomputeHeuristic.find(&call) !=
    gutils->knownRecomputeHeuristic.end()) {
    if (!gutils->knownRecomputeHeuristic[&call]) {
     auto cv = gutils->cacheForReverse(BuilderZ, newCall,
     getIndex(&call, CacheType::Self, BuilderZ));
    }
  }
  return true;
#ifdef __clang__
#pragma clang diagnostic pop
#else
#pragma GCC diagnostic pop
#endif
}


bool handle_gemv(BlasInfo blas, llvm::CallInst &call, llvm::Function *called,
    const std::vector<bool> &overwritten_args, llvm::Type *fpType) {
  
#ifdef __clang__
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wunused-but-set-variable"
#else
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif
  using namespace llvm;
  CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&call));
  IRBuilder<> BuilderZ(newCall);
  BuilderZ.setFastMathFlags(getFast());
  IRBuilder<> allocationBuilder(gutils->inversionAllocs);
  allocationBuilder.setFastMathFlags(getFast());
  // never cache in Fwd Mode
  const bool cacheMode = (Mode != DerivativeMode::ForwardMode);
  const bool byRef = blas.prefix == "" || blas.prefix == "cublas_";
  const bool cblas = blas.prefix == "cblas_";
  const bool cublas = blas.prefix == "cublas_" || blas.prefix == "cublas";
  Value *cacheval = nullptr;

  const int offset = ((cblas || cublas) ? 1 : 0);
// Next ones shall only be called in the cublas case,
// they have incorrect meaning otherwise
  const int pos_handle = 0;
  Value *orig_handle = nullptr;
  Value *arg_handle = nullptr;
  Type *type_handle = nullptr;
  bool overwritten_handle = true;
  if (cublas) {
    orig_handle = call.getArgOperand(pos_handle);
    arg_handle = gutils->getNewFromOriginal(orig_handle);
    type_handle = arg_handle->getType();
    overwritten_handle = (cacheMode ? overwritten_args[pos_handle] : false);

  }

// Next ones shall only be called in the cblas case,
// they have incorrect meaning otherwise
  const int pos_layout = 0;
  const auto orig_layout = call.getArgOperand(pos_layout);
  auto arg_layout = gutils->getNewFromOriginal(orig_layout);
  const auto type_layout = arg_layout->getType();
  const bool overwritten_layout = (cacheMode ? overwritten_args[pos_layout] : false);

  const int pos_transa = 0 + offset;
  const auto orig_transa = call.getArgOperand(pos_transa);
  auto arg_transa = gutils->getNewFromOriginal(orig_transa);
  const auto type_transa = arg_transa->getType();
  const bool overwritten_transa = (cacheMode ? overwritten_args[pos_transa] : false);

  const int pos_m = 1 + offset;
  const auto orig_m = call.getArgOperand(pos_m);
  auto arg_m = gutils->getNewFromOriginal(orig_m);
  const auto type_m = arg_m->getType();
  const bool overwritten_m = (cacheMode ? overwritten_args[pos_m] : false);

  const int pos_n = 2 + offset;
  const auto orig_n = call.getArgOperand(pos_n);
  auto arg_n = gutils->getNewFromOriginal(orig_n);
  const auto type_n = arg_n->getType();
  const bool overwritten_n = (cacheMode ? overwritten_args[pos_n] : false);

  const int pos_alpha = 3 + offset;
  const auto orig_alpha = call.getArgOperand(pos_alpha);
  auto arg_alpha = gutils->getNewFromOriginal(orig_alpha);
  const auto type_alpha = arg_alpha->getType();
  const bool overwritten_alpha = (cacheMode ? overwritten_args[pos_alpha] : false);
  bool active_alpha = !gutils->isConstantValue(orig_alpha);
  Value *rt_inactive_alpha = nullptr;

  const int pos_A = 4 + offset;
  const auto orig_A = call.getArgOperand(pos_A);
  auto arg_A = gutils->getNewFromOriginal(orig_A);
  const auto type_A = arg_A->getType();
  const bool overwritten_A = (cacheMode ? overwritten_args[pos_A] : false);
  bool active_A = !gutils->isConstantValue(orig_A);
  Value *rt_inactive_A = nullptr;

  const int pos_lda = 5 + offset;
  const auto orig_lda = call.getArgOperand(pos_lda);
  auto arg_lda = gutils->getNewFromOriginal(orig_lda);
  const auto type_lda = arg_lda->getType();
  const bool overwritten_lda = (cacheMode ? overwritten_args[pos_lda] : false);

  const int pos_x = 6 + offset;
  const auto orig_x = call.getArgOperand(pos_x);
  auto arg_x = gutils->getNewFromOriginal(orig_x);
  const auto type_x = arg_x->getType();
  const bool overwritten_x = (cacheMode ? overwritten_args[pos_x] : false);
  bool active_x = !gutils->isConstantValue(orig_x);
  Value *rt_inactive_x = nullptr;

  const int pos_incx = 7 + offset;
  const auto orig_incx = call.getArgOperand(pos_incx);
  auto arg_incx = gutils->getNewFromOriginal(orig_incx);
  const auto type_incx = arg_incx->getType();
  const bool overwritten_incx = (cacheMode ? overwritten_args[pos_incx] : false);

  const int pos_beta = 8 + offset;
  const auto orig_beta = call.getArgOperand(pos_beta);
  auto arg_beta = gutils->getNewFromOriginal(orig_beta);
  const auto type_beta = arg_beta->getType();
  const bool overwritten_beta = (cacheMode ? overwritten_args[pos_beta] : false);
  bool active_beta = !gutils->isConstantValue(orig_beta);
  Value *rt_inactive_beta = nullptr;

  const int pos_y = 9 + offset;
  const auto orig_y = call.getArgOperand(pos_y);
  auto arg_y = gutils->getNewFromOriginal(orig_y);
  const auto type_y = arg_y->getType();
  const bool overwritten_y = (cacheMode ? overwritten_args[pos_y] : false);
  bool active_y = !gutils->isConstantValue(orig_y);
  Value *rt_inactive_y = nullptr;

  const int pos_incy = 10 + offset;
  const auto orig_incy = call.getArgOperand(pos_incy);
  auto arg_incy = gutils->getNewFromOriginal(orig_incy);
  const auto type_incy = arg_incy->getType();
  const bool overwritten_incy = (cacheMode ? overwritten_args[pos_incy] : false);


  // <X> is inactive either if gutils->isConstantValue(<X>)
  // returns true, or if runtimeActivity is on and the
  // shadow points to the primal arg.
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (byRef && active_alpha) {
      auto shadow_alpha = gutils->invertPointerM(orig_alpha, BuilderZ);
      rt_inactive_alpha = BuilderZ.CreateICmpEQ(shadow_alpha, arg_alpha, "rt.tmp.inactive." "alpha");
    }
    if (active_A) {
      auto shadow_A = gutils->invertPointerM(orig_A, BuilderZ);
      rt_inactive_A = BuilderZ.CreateICmpEQ(shadow_A, arg_A, "rt.tmp.inactive." "A");
    }
    if (active_x) {
      auto shadow_x = gutils->invertPointerM(orig_x, BuilderZ);
      rt_inactive_x = BuilderZ.CreateICmpEQ(shadow_x, arg_x, "rt.tmp.inactive." "x");
    }
    if (byRef && active_beta) {
      auto shadow_beta = gutils->invertPointerM(orig_beta, BuilderZ);
      rt_inactive_beta = BuilderZ.CreateICmpEQ(shadow_beta, arg_beta, "rt.tmp.inactive." "beta");
    }
    if (active_y) {
      auto shadow_y = gutils->invertPointerM(orig_y, BuilderZ);
      rt_inactive_y = BuilderZ.CreateICmpEQ(shadow_y, arg_y, "rt.tmp.inactive." "y");
    }
    Value *rt_inactive_out = nullptr;
    if (active_y) {
      rt_inactive_out = rt_inactive_y;
    } else {
      rt_inactive_out = ConstantInt::getTrue(BuilderZ.getContext());
    }
    if (byRef && active_alpha) {
      rt_inactive_alpha = BuilderZ.CreateOr(rt_inactive_alpha, rt_inactive_out, "rt.inactive." "alpha");
    }
    if (active_A) {
      rt_inactive_A = BuilderZ.CreateOr(rt_inactive_A, rt_inactive_out, "rt.inactive." "A");
    }
    if (active_x) {
      rt_inactive_x = BuilderZ.CreateOr(rt_inactive_x, rt_inactive_out, "rt.inactive." "x");
    }
    if (byRef && active_beta) {
      rt_inactive_beta = BuilderZ.CreateOr(rt_inactive_beta, rt_inactive_out, "rt.inactive." "beta");
    }
    if (active_y) {
      rt_inactive_y = BuilderZ.CreateOr(rt_inactive_y, rt_inactive_out, "rt.inactive." "y");
    }
  }
  Type* blasFPType = type_alpha;
  Type* blasCharType = type_transa;
  Type *cublasEnumType = nullptr;
  if (cublas) cublasEnumType = type_transa;
  Type* blasIntType = type_m;
  Type* cublas_retty = nullptr;
  Value* cublas_handle = nullptr;
  if (cublas) {
    cublas_retty = call.getFunctionType()->getReturnType();
    cublas_handle = call.getArgOperand(0);
  }
  const bool julia_decl = !type_A->isPointerTy();
  Type* type_vec_like = type_A;
  // fpType already given by blas type (s, d, c, z) 
  IntegerType *intType = dyn_cast<IntegerType>(type_m);
  // TODO: add Fortran testcases for Fortran ABI
  if (!intType) {
    const auto PT = cast<PointerType>(type_m);
    if (blas.is64)
      intType = IntegerType::get(PT->getContext(), 64);
    else
      intType = IntegerType::get(PT->getContext(), 32);
  }

  IntegerType *charType = IntegerType::get(intType->getContext(), 8);

  IntegerType *julia_decl_type = nullptr;
  if (julia_decl)
    julia_decl_type = intType;
  Value *valueN = nullptr;
  Value *valueT = nullptr;
  Value *valueG = nullptr;
  if (cublas) {
    valueN = ConstantInt::get(cublasEnumType, cublasOperation_t::CUBLAS_OP_N);
    valueT = ConstantInt::get(cublasEnumType, cublasOperation_t::CUBLAS_OP_T);
    // TODO lascl not available in cublas, nor op G
    valueG = ConstantInt::get(cublasEnumType, 'G');
  } else {
    valueN = ConstantInt::get(charType, 'N');
    valueT = ConstantInt::get(charType, 'T');
    valueG = ConstantInt::get(charType, 'G');
  }

  SmallVector<Type *, 2> cacheTypes;

  // len, fp, etc. must be preserved if overwritten
  bool need_transa = active_x || active_beta || active_alpha || active_y || active_A;
  bool need_m = active_x || active_beta || active_alpha || active_y || active_A;
  bool need_n = active_x || active_beta || active_alpha || active_y || active_A;
  bool need_alpha = active_x || active_A;
  bool need_A = active_x || active_alpha;
  bool need_lda = active_x || active_alpha || active_A;
  bool need_x = active_alpha || active_A;
  bool need_incx = active_x || active_alpha || active_A;
  bool need_beta = active_y;
  bool need_y = false;
  bool need_incy = active_x || active_beta || active_alpha || active_y || active_A;
  bool cache_transa = cacheMode && byRef && overwritten_transa && need_transa;
  bool cache_m = cacheMode && byRef && overwritten_m && need_m;
  bool cache_n = cacheMode && byRef && overwritten_n && need_n;
  bool cache_alpha = cacheMode && byRef && overwritten_alpha && need_alpha;
  bool cache_A = cacheMode && overwritten_A && need_A;
  bool cache_lda = cacheMode && byRef && overwritten_lda && need_lda;
  bool cache_x = cacheMode && overwritten_x && need_x;
  bool cache_incx = cacheMode && byRef && overwritten_incx && need_incx;
  bool cache_beta = cacheMode && byRef && overwritten_beta && need_beta;
  bool cache_y = cacheMode && overwritten_y && need_y;
  bool cache_incy = cacheMode && byRef && overwritten_incy && need_incy;
  // we cache the following matrix,
  // since one rule uses input<y>
  if (active_beta) {
    need_y = true;
    cache_y = true;
  }
  if (cache_transa)
    cacheTypes.push_back(charType);
  if (cache_m)
    cacheTypes.push_back(intType);
  if (cache_n)
    cacheTypes.push_back(intType);
  if (cache_alpha)
    cacheTypes.push_back(fpType);
  if (cache_lda)
    cacheTypes.push_back(intType);
  if (cache_incx)
    cacheTypes.push_back(intType);
  if (cache_beta)
    cacheTypes.push_back(fpType);
  if (cache_incy)
    cacheTypes.push_back(intType);
  if (cache_A)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  if (cache_x)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  if (cache_y)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  Type *cachetype = nullptr;
  switch (cacheTypes.size()) {
  case 0:
    break;
  case 1:
    cachetype = cacheTypes[0];
    break;
  default:
    cachetype = StructType::get(call.getContext(), cacheTypes);
    break;
  }

  if ((Mode == DerivativeMode::ReverseModeCombined ||
       Mode == DerivativeMode::ReverseModePrimal) && cachetype) {
    SmallVector<Value *, 2> cacheValues;
    if (byRef) {
        addValueToCache(arg_transa, cache_transa, charType, cacheValues, BuilderZ, "transa");
        addValueToCache(arg_m, cache_m, intType, cacheValues, BuilderZ, "m");
        addValueToCache(arg_n, cache_n, intType, cacheValues, BuilderZ, "n");
        addValueToCache(arg_alpha, cache_alpha, fpType, cacheValues, BuilderZ, "alpha");
        addValueToCache(arg_lda, cache_lda, intType, cacheValues, BuilderZ, "lda");
        addValueToCache(arg_incx, cache_incx, intType, cacheValues, BuilderZ, "incx");
        addValueToCache(arg_beta, cache_beta, fpType, cacheValues, BuilderZ, "beta");
        addValueToCache(arg_incy, cache_incy, intType, cacheValues, BuilderZ, "incy");
    }
    if (cache_A) {
      auto charTy = IntegerType::get(intType->getContext(), 8);
      Value *M, *N;
      M = arg_m;
      N = arg_n;
      auto *len1 = load_if_ref(BuilderZ, intType, M, byRef);
      auto *len2 = load_if_ref(BuilderZ, intType, N, byRef);
      auto *matSize = BuilderZ.CreateMul(len1, len2);
      auto malins = CreateAllocation(BuilderZ, fpType, matSize, "cache.A");
      SmallVector<ValueType, 7> valueTypes = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
       valueTypes[5] = ValueType::Primal;
      if (byRef) valueTypes[6] = ValueType::Primal;
      if (byRef) valueTypes[2] = ValueType::Primal;
      if (byRef) valueTypes[3] = ValueType::Primal;
      if (EnzymeLapackCopy) {
        Value *uplo = llvm::ConstantInt::get(charTy, 0);
        uplo = to_blas_callconv(BuilderZ, uplo, byRef, cublas, nullptr, allocationBuilder, "copy.garbage");
        SmallVector<Value *, 7> args = {uplo, M, N, arg_A, arg_lda, malins, M};
        if (!byRef) {
           args.insert(args.begin(), arg_layout); valueTypes.insert(valueTypes.begin(), ValueType::Primal); }
        callMemcpyStridedLapack(BuilderZ, *gutils->oldFunc->getParent(), blas, args, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
        auto dmemcpy = getOrInsertMemcpyMat(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *len_lda = load_if_ref(BuilderZ, intType, arg_lda, byRef);
        Value *args[5] = {malins, arg_A, len1, len2, len_lda};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cache_x) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = select_vec_dims(BuilderZ, arg_transa, arg_n, arg_m, byRef, cublas);
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.x");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[7] = ValueType::Primal;
      if (byRef) valueTypes[8] = ValueType::Primal;
      if (byRef) valueTypes[1] = ValueType::Primal;
      if (byRef) valueTypes[3] = ValueType::Primal;
      if (byRef) valueTypes[2] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_x, arg_incx, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_x, arg_incx, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incx, byRef);
        Value *args[4] = {malins, arg_x, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cache_y) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = select_vec_dims(BuilderZ, arg_transa, arg_m, arg_n, byRef, cublas);
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.y");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[10] = ValueType::Primal;
      if (byRef) valueTypes[11] = ValueType::Primal;
      if (byRef) valueTypes[1] = ValueType::Primal;
      if (byRef) valueTypes[2] = ValueType::Primal;
      if (byRef) valueTypes[3] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_y, arg_incy, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_y, arg_incy, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incy, byRef);
        Value *args[4] = {malins, arg_y, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cacheValues.size() == 1) {
      cacheval = cacheValues[0];
    } else {
      cacheval = UndefValue::get(cachetype);
      for (auto&& tup : llvm::enumerate(cacheValues))
        cacheval = BuilderZ.CreateInsertValue(cacheval, tup.value(), tup.index());
    }
    gutils->cacheForReverse(BuilderZ, cacheval,
                            getIndex(&call, CacheType::Tape, BuilderZ));
  }
  unsigned cacheidx = 0;
  Value *true_lda = arg_lda;
  Value *lda = true_lda;
  Value *free_A = nullptr;
  Value *true_incx = arg_incx;
  Value *free_x = nullptr;
  Value *input_y = nullptr;
  Value *free_input_y = nullptr;
  Value *true_incy = arg_incy;
  Value *free_y = nullptr;
  IRBuilder<> Builder2(&call);
  switch (Mode) {
    case DerivativeMode::ReverseModeCombined:
    case DerivativeMode::ReverseModeGradient:
      getReverseBuilder(Builder2);
      break;
    case DerivativeMode::ForwardMode:
    case DerivativeMode::ForwardModeSplit:
      Builder2.SetInsertPoint(BuilderZ.GetInsertBlock(),
                              BuilderZ.GetInsertPoint());
      Builder2.setFastMathFlags(getFast());
      break;
    case DerivativeMode::ReverseModePrimal:
      break;
  }

  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {

    if (cachetype) {
      if (Mode != DerivativeMode::ReverseModeCombined) {
        cacheval = BuilderZ.CreatePHI(cachetype, 0);
      }
      cacheval = gutils->cacheForReverse(
          BuilderZ, cacheval, getIndex(&call, CacheType::Tape, BuilderZ));
      if (Mode != DerivativeMode::ForwardModeSplit)
        cacheval = lookup(cacheval, Builder2);
    }

    if (byRef) {
      if (cache_transa) {
        arg_transa = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.transa");
        auto alloc = allocationBuilder.CreateAlloca(charType, nullptr, "byref.transa");
        Builder2.CreateStore(arg_transa, alloc);
        arg_transa = Builder2.CreatePointerCast(
            alloc, type_transa, "cast.transa");
        cacheidx++;
      }

      if (cache_m) {
        arg_m = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.m");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.m");
        Builder2.CreateStore(arg_m, alloc);
        arg_m = Builder2.CreatePointerCast(
            alloc, type_m, "cast.m");
        cacheidx++;
      }

      if (cache_n) {
        arg_n = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.n");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.n");
        Builder2.CreateStore(arg_n, alloc);
        arg_n = Builder2.CreatePointerCast(
            alloc, type_n, "cast.n");
        cacheidx++;
      }

      if (cache_alpha) {
        arg_alpha = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.alpha");
        auto alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "byref.alpha");
        Builder2.CreateStore(arg_alpha, alloc);
        arg_alpha = Builder2.CreatePointerCast(
            alloc, type_alpha, "cast.alpha");
        cacheidx++;
      }

      if (cache_lda) {
        arg_lda = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.lda");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.lda");
        Builder2.CreateStore(arg_lda, alloc);
        arg_lda = Builder2.CreatePointerCast(
            alloc, type_lda, "cast.lda");
        cacheidx++;
      }

      if (cache_incx) {
        arg_incx = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incx");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incx");
        Builder2.CreateStore(arg_incx, alloc);
        arg_incx = Builder2.CreatePointerCast(
            alloc, type_incx, "cast.incx");
        cacheidx++;
      }

      if (cache_beta) {
        arg_beta = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.beta");
        auto alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "byref.beta");
        Builder2.CreateStore(arg_beta, alloc);
        arg_beta = Builder2.CreatePointerCast(
            alloc, type_beta, "cast.beta");
        cacheidx++;
      }

      if (cache_incy) {
        arg_incy = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incy");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incy");
        Builder2.CreateStore(arg_incy, alloc);
        arg_incy = Builder2.CreatePointerCast(
            alloc, type_incy, "cast.incy");
        cacheidx++;
      }

    }
    if (cache_A) {
      arg_A = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.A");
      free_A = arg_A;
      if (type_A->isIntegerTy()) {
        arg_A = Builder2.CreatePtrToInt(arg_A, type_A);
      } else if (arg_A->getType() != type_A){
        arg_A = Builder2.CreatePointerCast(arg_A, type_A);
      }
      cacheidx++;
    }
    if (cache_x) {
      arg_x = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.x");
      free_x = arg_x;
      if (type_x->isIntegerTy()) {
        arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
      } else if (arg_x->getType() != type_x){
        arg_x = Builder2.CreatePointerCast(arg_x, type_x);
      }
      cacheidx++;
    }
    //handling input
    if (active_beta) {
      input_y = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.y");
      free_input_y = input_y;
      if (type_y->isIntegerTy()) {
        input_y = Builder2.CreatePtrToInt(input_y, type_y);
      } else if (input_y->getType() != type_y){
        input_y = Builder2.CreatePointerCast(input_y, type_y);
      }
    }
    if (cache_y) {
      arg_y = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.y");
      free_y = arg_y;
      if (type_y->isIntegerTy()) {
        arg_y = Builder2.CreatePtrToInt(arg_y, type_y);
      } else if (arg_y->getType() != type_y){
        arg_y = Builder2.CreatePointerCast(arg_y, type_y);
      }
      cacheidx++;
    }
  } else {

    if (type_x->isIntegerTy())
      arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
    if (type_y->isIntegerTy())
      arg_y = Builder2.CreatePtrToInt(arg_y, type_y);
  }
  /* fwd-rewrite */                                 
  if (Mode == DerivativeMode::ForwardMode ||        
      Mode == DerivativeMode::ForwardModeSplit) {   
                                                    
    auto callval = call.getCalledOperand();       

  if (EnzymeRuntimeActivityCheck) {
    std::string s;
    llvm::raw_string_ostream ss(s);
    ss << "gemv" << "\n";
    ss << call.getDebugLoc() << "\n";
    ss << "Runtime Activity not supported for BLAS calls" << "\n";
    if (CustomErrorHandler) {
      IRBuilder<> Builder2(&call);
      getForwardBuilder(BuilderZ);
      CustomErrorHandler(ss.str().c_str(), wrap(&call), ErrorType::NoDerivative,
                         gutils, nullptr, wrap(&BuilderZ));
      return false;
    } else {
      EmitFailure("Unsupported Mode", call.getDebugLoc(), &call, ss.str());
      return false;
    }
  }
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
    Value *d_x = active_x
     ? gutils->invertPointerM(orig_x, Builder2)
     : nullptr;
    Value *d_beta = Constant::getNullValue(gutils->getShadowType(fpType));
    Value *d_alpha = Constant::getNullValue(gutils->getShadowType(fpType));
    Value *d_y = active_y
     ? gutils->invertPointerM(orig_y, Builder2)
     : nullptr;
    Value *d_A = active_A
     ? gutils->invertPointerM(orig_A, Builder2)
     : nullptr;
    Value *dres = applyChainRule(
        call.getType(), Builder2,
        [&](Value *d_alpha, Value *d_A, Value *d_x, Value *d_beta, Value *d_y  ) {
      Value *dres = nullptr;
      if(active_alpha) {
        Value *args1_cblas[12] =  {arg_layout, arg_transa, arg_m, arg_n, d_alpha, arg_A, arg_lda, arg_x, (cache_x ? const_one : arg_incx), arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[11] = {arg_transa, arg_m, arg_n, d_alpha, arg_A, arg_lda, arg_x, (cache_x ? const_one : arg_incx), arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          if (byRef) {
          dres = Builder2.CreateCall(call.getFunctionType(), callval, args1, Defs);
          } else /*cblas*/ {
          dres = Builder2.CreateCall(call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          };
      }
      if(active_A) {
        Value *args1_cblas[12] =  {arg_layout, arg_transa, arg_m, arg_n, arg_alpha, d_A, true_lda, arg_x, (cache_x ? const_one : arg_incx), arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[11] = {arg_transa, arg_m, arg_n, arg_alpha, d_A, true_lda, arg_x, (cache_x ? const_one : arg_incx), arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      if(active_x) {
        Value *args1_cblas[12] =  {arg_layout, arg_transa, arg_m, arg_n, arg_alpha, arg_A, arg_lda, d_x, arg_incx, arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[11] = {arg_transa, arg_m, arg_n, arg_alpha, arg_A, arg_lda, d_x, arg_incx, arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      if(active_beta) {
        Value *args1_cblas[12] =  {arg_layout, arg_transa, arg_m, arg_n, arg_alpha, arg_A, arg_lda, arg_x, (cache_x ? const_one : arg_incx), d_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[11] = {arg_transa, arg_m, arg_n, arg_alpha, arg_A, arg_lda, arg_x, (cache_x ? const_one : arg_incx), d_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      if(active_y) {
        Value *args1_cblas[12] =  {arg_layout, arg_transa, arg_m, arg_n, arg_alpha, arg_A, arg_lda, arg_x, (cache_x ? const_one : arg_incx), arg_beta, d_y, arg_incy};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[11] = {arg_transa, arg_m, arg_n, arg_alpha, arg_A, arg_lda, arg_x, (cache_x ? const_one : arg_incx), arg_beta, d_y, arg_incy};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      return dres;
    },
    d_alpha, d_A, d_x, d_beta, d_y);
    setDiffe(&call, dres, Builder2);
  }
  /* rev-rewrite */                                 
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient) {
    Value *alloc = nullptr;
    if (byRef && !cublas) {
      alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "ret");
    }

    //handling nested blas: 0
    //handled nested blas: 0
    //handling nested blas: 1
    //handled nested blas: 1
    Value *d_alpha = UndefValue::get(fpType);
    Value *d_A = active_A
     ? lookup(gutils->invertPointerM(orig_A, Builder2), Builder2)
     : nullptr;
    Value *d_x = active_x
     ? lookup(gutils->invertPointerM(orig_x, Builder2), Builder2)
     : nullptr;
    Value *d_beta = UndefValue::get(fpType);
    Value *d_y = active_y
     ? lookup(gutils->invertPointerM(orig_y, Builder2), Builder2)
     : nullptr;
    if (!cache_transa && need_transa)
      arg_transa = lookup(arg_transa, Builder2);
    if (!cache_m && need_m)
      arg_m = lookup(arg_m, Builder2);
    if (!cache_n && need_n)
      arg_n = lookup(arg_n, Builder2);
    if (!cache_alpha && need_alpha)
      arg_alpha = lookup(arg_alpha, Builder2);
    if (!cache_A && need_A)
      arg_A = lookup(arg_A, Builder2);
    if (!cache_lda && need_lda)
      arg_lda = lookup(arg_lda, Builder2);
    if (!cache_x && need_x)
      arg_x = lookup(arg_x, Builder2);
    if (!cache_incx && need_incx)
      arg_incx = lookup(arg_incx, Builder2);
    if (!cache_beta && need_beta)
      arg_beta = lookup(arg_beta, Builder2);
    if (!cache_y && need_y)
      arg_y = lookup(arg_y, Builder2);
    if (!cache_incy && need_incy)
      arg_incy = lookup(arg_incy, Builder2);
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (byRef && active_alpha) {
      rt_inactive_alpha = lookup(rt_inactive_alpha, Builder2);
    }
    if (active_A) {
      rt_inactive_A = lookup(rt_inactive_A, Builder2);
    }
    if (active_x) {
      rt_inactive_x = lookup(rt_inactive_x, Builder2);
    }
    if (byRef && active_beta) {
      rt_inactive_beta = lookup(rt_inactive_beta, Builder2);
    }
    if (active_y) {
      rt_inactive_y = lookup(rt_inactive_y, Builder2);
    }
  }
    llvm::Value* arg_transposed_transa = nullptr;
    applyChainRule(
      Builder2,
      [&](Value *d_A, Value *d_x, Value *d_y) {
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
      auto bb_name = Builder2.GetInsertBlock()->getName();
      // Seq
      if (active_alpha && d_y) {
        BasicBlock *nextBlock_alpha = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode && byRef) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".alpha.active");
          nextBlock_alpha = gutils->addReverseBlock(activeBlock, bb_name + ".alpha.done");
          Builder2.CreateCondBr(rt_inactive_alpha, nextBlock_alpha, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
    Value *len1 = load_if_ref(Builder2, intType,arg_m, byRef);
    Value *len2 = load_if_ref(Builder2, intType,arg_n, byRef);
    Value *size_Ax = Builder2.CreateSelect(is_normal(Builder2, arg_transa, byRef, cublas), len1, len2);
    Value * true_mat_Ax = CreateAllocation(Builder2, fpType, size_Ax, "mat_Ax");
    Value * mat_Ax = true_mat_Ax;
    if (type_vec_like->isIntegerTy()) {
      mat_Ax = Builder2.CreatePtrToInt(mat_Ax, type_vec_like);
    } else if (mat_Ax->getType() != type_vec_like){
      mat_Ax = Builder2.CreatePointerCast(mat_Ax, type_vec_like);
    }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
        std::vector<Value *>args0;
        if (cblas) args0.push_back(arg_layout);
        if (cublas) args0.push_back(arg_handle);
        for (auto item : {arg_transa}) args0.push_back(item);
        for (auto item : {arg_m}) args0.push_back(item);
        for (auto item : {arg_n}) args0.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 1.0), byRef, blasFPType, allocationBuilder, "constant.fp.1.0")}) args0.push_back(item);
        for (auto item : {arg_A}) args0.push_back(item);
        for (auto item : {get_cached_mat_width(Builder2, {to_blas_callconv(Builder2, valueN, byRef, cublas, nullptr, allocationBuilder, "constant.char.N")}, arg_lda, arg_m, arg_m, cache_A, byRef, cublas)}) args0.push_back(item);
        for (auto item : {arg_x, (cache_x ? const_one : arg_incx)}) args0.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 0.0), byRef, blasFPType, allocationBuilder, "constant.fp.0.0")}) args0.push_back(item);
        for (auto item : {mat_Ax}) args0.push_back(item);
        for (auto item : {to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "constant.int.1")}) args0.push_back(item);
        if (byRef) {
           args0.push_back(ConstantInt::get(intType, 1));
        }
    //handling nested blas: 0
    SmallVector<Type*, 1> tys; for (auto arg : args0) tys.push_back(arg->getType());
    llvm::FunctionType *FTgemv = FunctionType::get(Builder2.getVoidTy(), tys, false);
    auto derivcall_gemv = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "gemv" + blas.suffix, FTgemv);
    if (auto F = dyn_cast<Function>(derivcall_gemv.getCallee()))
    {
      attribute_gemv(blas, F);
    }

        Builder2.CreateCall(derivcall_gemv, args0, Defs);
    //handled nested blas: 0
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : ({auto brow_2 = {arg_n}; auto brow_1 = {arg_m}; auto brow_0 = {arg_transa}; get_blas_row(Builder2, brow_0, brow_1, brow_2, byRef, cublas);})) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        for (auto item : {mat_Ax}) args1.push_back(item);
        for (auto item : {to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "constant.int.1")}) args1.push_back(item);
        if (byRef) {
        }
    //handling nested blas: 1
    if (cublas) assert(false && "cublas not implemented");
{
      SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTdot = FunctionType::get(fpType, tys, false);
    auto derivcall_dot = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "dot" + blas.suffix, FTdot);
    if (auto F = dyn_cast<Function>(derivcall_dot.getCallee()))
    {
      attribute_dot(blas, F);
    }

        CallInst *cubcall = cast<CallInst>(Builder2.CreateCall(derivcall_dot, args1, Defs));
        if (byRef) {
          ((DiffeGradientUtils *)gutils)->addToInvertedPtrDiffe(&call, nullptr, fpType, 0, (called->getParent()->getDataLayout().getTypeSizeInBits(fpType)/8), orig_alpha, cubcall, Builder2);
        } else {
          addToDiffe(orig_alpha, cubcall, Builder2, fpType);
        }
}
    //handled nested blas: 1
    CreateDealloc(Builder2, true_mat_Ax);
        if (nextBlock_alpha && byRef) {
          Builder2.CreateBr(nextBlock_alpha);
          Builder2.SetInsertPoint(nextBlock_alpha);
        }
      }
      if (active_A && d_y && d_A) {
        BasicBlock *nextBlock_A = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".A.active");
          nextBlock_A = gutils->addReverseBlock(activeBlock, bb_name + ".A.done");
          Builder2.CreateCondBr(rt_inactive_A, nextBlock_A, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cblas) args1.push_back(arg_layout);
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_m}) args1.push_back(item);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {arg_alpha}) args1.push_back(item);
        for (auto item : ({auto brow_2 = ({auto concat_0 = {arg_x, (cache_x ? const_one : arg_incx)}; auto concat_1 = {d_y, arg_incy}; concat_values<ArrayRef<Value*>, ArrayRef<Value*>>(concat_0, concat_1); }); auto brow_1 = ({auto concat_0 = {d_y, arg_incy}; auto concat_1 = {arg_x, (cache_x ? const_one : arg_incx)}; concat_values<ArrayRef<Value*>, ArrayRef<Value*>>(concat_0, concat_1); }); auto brow_0 = {arg_transa}; get_blas_row(Builder2, brow_0, brow_1, brow_2, byRef, cublas);})) args1.push_back(item);
        for (auto item : {d_A, arg_lda}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTger;
    if (cublas) {
      FTger = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTger = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_ger = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "ger" + blas.suffix, FTger);
    if (auto F = dyn_cast<Function>(derivcall_ger.getCallee()))
    {
      attribute_ger(blas, F);
    }

        Builder2.CreateCall(derivcall_ger, args1, Defs);
        if (nextBlock_A) {
          Builder2.CreateBr(nextBlock_A);
          Builder2.SetInsertPoint(nextBlock_A);
        }
      }
      if (active_x && d_x && d_y) {
        BasicBlock *nextBlock_x = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".x.active");
          nextBlock_x = gutils->addReverseBlock(activeBlock, bb_name + ".x.done");
          Builder2.CreateCondBr(rt_inactive_x, nextBlock_x, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cblas) args1.push_back(arg_layout);
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {(arg_transposed_transa = arg_transposed_transa ? arg_transposed_transa : transpose(Builder2, arg_transa, byRef, cublas, charType, allocationBuilder, "transa"))}) args1.push_back(item);
        for (auto item : {arg_m}) args1.push_back(item);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {arg_alpha}) args1.push_back(item);
        for (auto item : {arg_A}) args1.push_back(item);
        for (auto item : {get_cached_mat_width(Builder2, {to_blas_callconv(Builder2, valueN, byRef, cublas, nullptr, allocationBuilder, "constant.char.N")}, arg_lda, arg_m, arg_m, cache_A, byRef, cublas)}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 1.0), byRef, blasFPType, allocationBuilder, "constant.fp.1.0")}) args1.push_back(item);
        for (auto item : {d_x, arg_incx}) args1.push_back(item);
        if (byRef) {
           args1.push_back(ConstantInt::get(intType, 1));
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTgemv;
    if (cublas) {
      FTgemv = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTgemv = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_gemv = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "gemv" + blas.suffix, FTgemv);
    if (auto F = dyn_cast<Function>(derivcall_gemv.getCallee()))
    {
      attribute_gemv(blas, F);
    }

        Builder2.CreateCall(derivcall_gemv, args1, Defs);
        if (nextBlock_x) {
          Builder2.CreateBr(nextBlock_x);
          Builder2.SetInsertPoint(nextBlock_x);
        }
      }
      if (active_beta && d_y) {
        BasicBlock *nextBlock_beta = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode && byRef) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".beta.active");
          nextBlock_beta = gutils->addReverseBlock(activeBlock, bb_name + ".beta.done");
          Builder2.CreateCondBr(rt_inactive_beta, nextBlock_beta, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : ({auto brow_2 = {arg_n}; auto brow_1 = {arg_m}; auto brow_0 = {arg_transa}; get_blas_row(Builder2, brow_0, brow_1, brow_2, byRef, cublas);})) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        for (auto item : {input_y, (cache_y ? const_one : arg_incy)}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
      if (!cublas) {
{
      SmallVector<Type*, 1> tys; for (auto arg : ArrayRef<Value *>(args1)) tys.push_back(arg->getType());
    llvm::FunctionType *FTdot = FunctionType::get(fpType, tys, false);
    auto derivcall_dot = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "dot" + blas.suffix, FTdot);
    if (auto F = dyn_cast<Function>(derivcall_dot.getCallee()))
    {
      attribute_dot(blas, F);
    }

        CallInst *cubcall = cast<CallInst>(Builder2.CreateCall(derivcall_dot, ArrayRef<Value *>(args1), Defs));
        if (byRef) {
          ((DiffeGradientUtils *)gutils)->addToInvertedPtrDiffe(&call, nullptr, fpType, 0, (called->getParent()->getDataLayout().getTypeSizeInBits(fpType)/8), orig_beta, cubcall, Builder2);
        } else {
          addToDiffe(orig_beta, cubcall, Builder2, fpType);
        }
}
      } else {
      }
        if (nextBlock_beta && byRef) {
          Builder2.CreateBr(nextBlock_beta);
          Builder2.SetInsertPoint(nextBlock_beta);
        }
      }
      if (active_y && d_y) {
        BasicBlock *nextBlock_y = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".y.active");
          nextBlock_y = gutils->addReverseBlock(activeBlock, bb_name + ".y.done");
          Builder2.CreateCondBr(rt_inactive_y, nextBlock_y, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : ({auto brow_2 = {arg_n}; auto brow_1 = {arg_m}; auto brow_0 = {arg_transa}; get_blas_row(Builder2, brow_0, brow_1, brow_2, byRef, cublas);})) args1.push_back(item);
        for (auto item : {arg_beta}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTscal;
    if (cublas) {
      FTscal = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTscal = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_scal = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "scal" + blas.suffix, FTscal);
    if (auto F = dyn_cast<Function>(derivcall_scal.getCallee()))
    {
      attribute_scal(blas, F);
    }

        Builder2.CreateCall(derivcall_scal, args1, Defs);
        if (nextBlock_y) {
          Builder2.CreateBr(nextBlock_y);
          Builder2.SetInsertPoint(nextBlock_y);
        }
      }
    },
    d_A, d_x, d_y  );
  }
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {
    if (shouldFree()) {
      if (cache_A) {
        CreateDealloc(Builder2, free_A);
      }
      if (cache_x) {
        CreateDealloc(Builder2, free_x);
      }
      if (cache_y) {
        CreateDealloc(Builder2, free_y);
      }
    }
  }
                                                                   
  if (Mode == DerivativeMode::ReverseModeGradient) {               
    eraseIfUnused(call, /*erase*/ true, /*check*/ false);          
  } else {                                                         
    eraseIfUnused(call);                                           
  }                                                                
  if (gutils->knownRecomputeHeuristic.find(&call) !=
    gutils->knownRecomputeHeuristic.end()) {
    if (!gutils->knownRecomputeHeuristic[&call]) {
     auto cv = gutils->cacheForReverse(BuilderZ, newCall,
     getIndex(&call, CacheType::Self, BuilderZ));
    }
  }
  return true;
#ifdef __clang__
#pragma clang diagnostic pop
#else
#pragma GCC diagnostic pop
#endif
}


bool handle_scal(BlasInfo blas, llvm::CallInst &call, llvm::Function *called,
    const std::vector<bool> &overwritten_args, llvm::Type *fpType) {
  
#ifdef __clang__
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wunused-but-set-variable"
#else
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif
  using namespace llvm;
  CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&call));
  IRBuilder<> BuilderZ(newCall);
  BuilderZ.setFastMathFlags(getFast());
  IRBuilder<> allocationBuilder(gutils->inversionAllocs);
  allocationBuilder.setFastMathFlags(getFast());
  // never cache in Fwd Mode
  const bool cacheMode = (Mode != DerivativeMode::ForwardMode);
  const bool byRef = blas.prefix == "" || blas.prefix == "cublas_";
  const bool cblas = blas.prefix == "cblas_";
  const bool cublas = blas.prefix == "cublas_" || blas.prefix == "cublas";
  Value *cacheval = nullptr;

  const int offset = (cublas ? 1 : 0);
// Next ones shall only be called in the cublas case,
// they have incorrect meaning otherwise
  const int pos_handle = 0;
  Value *orig_handle = nullptr;
  Value *arg_handle = nullptr;
  Type *type_handle = nullptr;
  bool overwritten_handle = true;
  if (cublas) {
    orig_handle = call.getArgOperand(pos_handle);
    arg_handle = gutils->getNewFromOriginal(orig_handle);
    type_handle = arg_handle->getType();
    overwritten_handle = (cacheMode ? overwritten_args[pos_handle] : false);

  }

  const int pos_n = 0 + offset;
  const auto orig_n = call.getArgOperand(pos_n);
  auto arg_n = gutils->getNewFromOriginal(orig_n);
  const auto type_n = arg_n->getType();
  const bool overwritten_n = (cacheMode ? overwritten_args[pos_n] : false);

  const int pos_alpha = 1 + offset;
  const auto orig_alpha = call.getArgOperand(pos_alpha);
  auto arg_alpha = gutils->getNewFromOriginal(orig_alpha);
  const auto type_alpha = arg_alpha->getType();
  const bool overwritten_alpha = (cacheMode ? overwritten_args[pos_alpha] : false);
  bool active_alpha = !gutils->isConstantValue(orig_alpha);
  Value *rt_inactive_alpha = nullptr;

  const int pos_x = 2 + offset;
  const auto orig_x = call.getArgOperand(pos_x);
  auto arg_x = gutils->getNewFromOriginal(orig_x);
  const auto type_x = arg_x->getType();
  const bool overwritten_x = (cacheMode ? overwritten_args[pos_x] : false);
  bool active_x = !gutils->isConstantValue(orig_x);
  Value *rt_inactive_x = nullptr;

  const int pos_incx = 3 + offset;
  const auto orig_incx = call.getArgOperand(pos_incx);
  auto arg_incx = gutils->getNewFromOriginal(orig_incx);
  const auto type_incx = arg_incx->getType();
  const bool overwritten_incx = (cacheMode ? overwritten_args[pos_incx] : false);


  // <X> is inactive either if gutils->isConstantValue(<X>)
  // returns true, or if runtimeActivity is on and the
  // shadow points to the primal arg.
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (byRef && active_alpha) {
      auto shadow_alpha = gutils->invertPointerM(orig_alpha, BuilderZ);
      rt_inactive_alpha = BuilderZ.CreateICmpEQ(shadow_alpha, arg_alpha, "rt.tmp.inactive." "alpha");
    }
    if (active_x) {
      auto shadow_x = gutils->invertPointerM(orig_x, BuilderZ);
      rt_inactive_x = BuilderZ.CreateICmpEQ(shadow_x, arg_x, "rt.tmp.inactive." "x");
    }
    Value *rt_inactive_out = nullptr;
    if (active_x) {
      rt_inactive_out = rt_inactive_x;
    } else {
      rt_inactive_out = ConstantInt::getTrue(BuilderZ.getContext());
    }
    if (byRef && active_alpha) {
      rt_inactive_alpha = BuilderZ.CreateOr(rt_inactive_alpha, rt_inactive_out, "rt.inactive." "alpha");
    }
    if (active_x) {
      rt_inactive_x = BuilderZ.CreateOr(rt_inactive_x, rt_inactive_out, "rt.inactive." "x");
    }
  }
  Type* blasFPType = type_alpha;
  Type* blasCharType = byRef ? (Type*) getInt8PtrTy(call.getContext()) : (Type*) Type::getInt8Ty(call.getContext());
  Type* blasIntType = type_n;
  Type* cublas_retty = nullptr;
  Value* cublas_handle = nullptr;
  if (cublas) {
    cublas_retty = call.getFunctionType()->getReturnType();
    cublas_handle = call.getArgOperand(0);
  }
  const bool julia_decl = !type_x->isPointerTy();
  Type* type_vec_like = type_x;
  // fpType already given by blas type (s, d, c, z) 
  IntegerType *intType = dyn_cast<IntegerType>(type_n);
  // TODO: add Fortran testcases for Fortran ABI
  if (!intType) {
    const auto PT = cast<PointerType>(type_n);
    if (blas.is64)
      intType = IntegerType::get(PT->getContext(), 64);
    else
      intType = IntegerType::get(PT->getContext(), 32);
  }

  IntegerType *charType = IntegerType::get(intType->getContext(), 8);

  IntegerType *julia_decl_type = nullptr;
  if (julia_decl)
    julia_decl_type = intType;
  SmallVector<Type *, 2> cacheTypes;

  // len, fp, etc. must be preserved if overwritten
  bool need_n = active_x || active_alpha;
  bool need_alpha = active_x;
  bool need_x = active_alpha;
  bool need_incx = active_x || active_alpha;
  bool cache_n = cacheMode && byRef && overwritten_n && need_n;
  bool cache_alpha = cacheMode && byRef && overwritten_alpha && need_alpha;
  bool cache_x = cacheMode && overwritten_x && need_x;
  bool cache_incx = cacheMode && byRef && overwritten_incx && need_incx;
  if (cache_n)
    cacheTypes.push_back(intType);
  if (cache_alpha)
    cacheTypes.push_back(fpType);
  if (cache_incx)
    cacheTypes.push_back(intType);
  if (cache_x)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  Type *cachetype = nullptr;
  switch (cacheTypes.size()) {
  case 0:
    break;
  case 1:
    cachetype = cacheTypes[0];
    break;
  default:
    cachetype = StructType::get(call.getContext(), cacheTypes);
    break;
  }

  if ((Mode == DerivativeMode::ReverseModeCombined ||
       Mode == DerivativeMode::ReverseModePrimal) && cachetype) {
    SmallVector<Value *, 2> cacheValues;
    if (byRef) {
        addValueToCache(arg_n, cache_n, intType, cacheValues, BuilderZ, "n");
        addValueToCache(arg_alpha, cache_alpha, fpType, cacheValues, BuilderZ, "alpha");
        addValueToCache(arg_incx, cache_incx, intType, cacheValues, BuilderZ, "incx");
    }
    if (cache_x) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = arg_n;
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.x");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[2] = ValueType::Primal;
      if (byRef) valueTypes[3] = ValueType::Primal;
      if (byRef) valueTypes[0] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_x, arg_incx, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_x, arg_incx, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incx, byRef);
        Value *args[4] = {malins, arg_x, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cacheValues.size() == 1) {
      cacheval = cacheValues[0];
    } else {
      cacheval = UndefValue::get(cachetype);
      for (auto&& tup : llvm::enumerate(cacheValues))
        cacheval = BuilderZ.CreateInsertValue(cacheval, tup.value(), tup.index());
    }
    gutils->cacheForReverse(BuilderZ, cacheval,
                            getIndex(&call, CacheType::Tape, BuilderZ));
  }
  unsigned cacheidx = 0;
  Value *true_incx = arg_incx;
  Value *free_x = nullptr;
  IRBuilder<> Builder2(&call);
  switch (Mode) {
    case DerivativeMode::ReverseModeCombined:
    case DerivativeMode::ReverseModeGradient:
      getReverseBuilder(Builder2);
      break;
    case DerivativeMode::ForwardMode:
    case DerivativeMode::ForwardModeSplit:
      Builder2.SetInsertPoint(BuilderZ.GetInsertBlock(),
                              BuilderZ.GetInsertPoint());
      Builder2.setFastMathFlags(getFast());
      break;
    case DerivativeMode::ReverseModePrimal:
      break;
  }

  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {

    if (cachetype) {
      if (Mode != DerivativeMode::ReverseModeCombined) {
        cacheval = BuilderZ.CreatePHI(cachetype, 0);
      }
      cacheval = gutils->cacheForReverse(
          BuilderZ, cacheval, getIndex(&call, CacheType::Tape, BuilderZ));
      if (Mode != DerivativeMode::ForwardModeSplit)
        cacheval = lookup(cacheval, Builder2);
    }

    if (byRef) {
      if (cache_n) {
        arg_n = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.n");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.n");
        Builder2.CreateStore(arg_n, alloc);
        arg_n = Builder2.CreatePointerCast(
            alloc, type_n, "cast.n");
        cacheidx++;
      }

      if (cache_alpha) {
        arg_alpha = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.alpha");
        auto alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "byref.alpha");
        Builder2.CreateStore(arg_alpha, alloc);
        arg_alpha = Builder2.CreatePointerCast(
            alloc, type_alpha, "cast.alpha");
        cacheidx++;
      }

      if (cache_incx) {
        arg_incx = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incx");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incx");
        Builder2.CreateStore(arg_incx, alloc);
        arg_incx = Builder2.CreatePointerCast(
            alloc, type_incx, "cast.incx");
        cacheidx++;
      }

    }
    if (cache_x) {
      arg_x = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.x");
      free_x = arg_x;
      if (type_x->isIntegerTy()) {
        arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
      } else if (arg_x->getType() != type_x){
        arg_x = Builder2.CreatePointerCast(arg_x, type_x);
      }
      cacheidx++;
    }
  } else {

    if (type_x->isIntegerTy())
      arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
  }
  /* fwd-rewrite */                                 
  if (Mode == DerivativeMode::ForwardMode ||        
      Mode == DerivativeMode::ForwardModeSplit) {   
                                                    
    auto callval = call.getCalledOperand();       

  if (EnzymeRuntimeActivityCheck) {
    std::string s;
    llvm::raw_string_ostream ss(s);
    ss << "scal" << "\n";
    ss << call.getDebugLoc() << "\n";
    ss << "Runtime Activity not supported for BLAS calls" << "\n";
    if (CustomErrorHandler) {
      IRBuilder<> Builder2(&call);
      getForwardBuilder(BuilderZ);
      CustomErrorHandler(ss.str().c_str(), wrap(&call), ErrorType::NoDerivative,
                         gutils, nullptr, wrap(&BuilderZ));
      return false;
    } else {
      EmitFailure("Unsupported Mode", call.getDebugLoc(), &call, ss.str());
      return false;
    }
  }
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
    Value *d_x = active_x
     ? gutils->invertPointerM(orig_x, Builder2)
     : nullptr;
    Value *d_alpha = Constant::getNullValue(gutils->getShadowType(fpType));
    Value *dres = applyChainRule(
        call.getType(), Builder2,
        [&](Value *d_alpha, Value *d_x  ) {
      Value *dres = nullptr;
      if(active_alpha) {
        Value *args1[4] = {arg_n, d_alpha, arg_x, (cache_x ? const_one : arg_incx)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          dres = Builder2.CreateCall(call.getFunctionType(), callval, args1, Defs);
      }
      if(active_x) {
        Value *args1[4] = {arg_n, arg_alpha, d_x, arg_incx};
        auto Defs = gutils->getInvertedBundles(
          &call, {cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      return dres;
    },
    d_alpha, d_x);
    setDiffe(&call, dres, Builder2);
  }
  /* rev-rewrite */                                 
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient) {
    Value *alloc = nullptr;
    if (byRef && !cublas) {
      alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "ret");
    }

    Value *d_alpha = UndefValue::get(fpType);
    Value *d_x = active_x
     ? lookup(gutils->invertPointerM(orig_x, Builder2), Builder2)
     : nullptr;
    if (!cache_n && need_n)
      arg_n = lookup(arg_n, Builder2);
    if (!cache_alpha && need_alpha)
      arg_alpha = lookup(arg_alpha, Builder2);
    if (!cache_x && need_x)
      arg_x = lookup(arg_x, Builder2);
    if (!cache_incx && need_incx)
      arg_incx = lookup(arg_incx, Builder2);
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (byRef && active_alpha) {
      rt_inactive_alpha = lookup(rt_inactive_alpha, Builder2);
    }
    if (active_x) {
      rt_inactive_x = lookup(rt_inactive_x, Builder2);
    }
  }
    applyChainRule(
      Builder2,
      [&](Value *d_x) {
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
      auto bb_name = Builder2.GetInsertBlock()->getName();
      if (active_alpha && d_x) {
        BasicBlock *nextBlock_alpha = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode && byRef) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".alpha.active");
          nextBlock_alpha = gutils->addReverseBlock(activeBlock, bb_name + ".alpha.done");
          Builder2.CreateCondBr(rt_inactive_alpha, nextBlock_alpha, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {arg_x, (cache_x ? const_one : arg_incx)}) args1.push_back(item);
        for (auto item : {d_x, arg_incx}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
      if (!cublas) {
{
      SmallVector<Type*, 1> tys; for (auto arg : ArrayRef<Value *>(args1)) tys.push_back(arg->getType());
    llvm::FunctionType *FTdot = FunctionType::get(fpType, tys, false);
    auto derivcall_dot = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "dot" + blas.suffix, FTdot);
    if (auto F = dyn_cast<Function>(derivcall_dot.getCallee()))
    {
      attribute_dot(blas, F);
    }

        CallInst *cubcall = cast<CallInst>(Builder2.CreateCall(derivcall_dot, ArrayRef<Value *>(args1), Defs));
        if (byRef) {
          ((DiffeGradientUtils *)gutils)->addToInvertedPtrDiffe(&call, nullptr, fpType, 0, (called->getParent()->getDataLayout().getTypeSizeInBits(fpType)/8), orig_alpha, cubcall, Builder2);
        } else {
          addToDiffe(orig_alpha, cubcall, Builder2, fpType);
        }
}
      } else {
      }
        if (nextBlock_alpha && byRef) {
          Builder2.CreateBr(nextBlock_alpha);
          Builder2.SetInsertPoint(nextBlock_alpha);
        }
      }
      if (active_x && d_x) {
        BasicBlock *nextBlock_x = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".x.active");
          nextBlock_x = gutils->addReverseBlock(activeBlock, bb_name + ".x.done");
          Builder2.CreateCondBr(rt_inactive_x, nextBlock_x, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {arg_alpha}) args1.push_back(item);
        for (auto item : {d_x, arg_incx}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTscal;
    if (cublas) {
      FTscal = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTscal = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_scal = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "scal" + blas.suffix, FTscal);
    if (auto F = dyn_cast<Function>(derivcall_scal.getCallee()))
    {
      attribute_scal(blas, F);
    }

        Builder2.CreateCall(derivcall_scal, args1, Defs);
        if (nextBlock_x) {
          Builder2.CreateBr(nextBlock_x);
          Builder2.SetInsertPoint(nextBlock_x);
        }
      }
    },
    d_x  );
  }
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {
    if (shouldFree()) {
      if (cache_x) {
        CreateDealloc(Builder2, free_x);
      }
    }
  }
                                                                   
  if (Mode == DerivativeMode::ReverseModeGradient) {               
    eraseIfUnused(call, /*erase*/ true, /*check*/ false);          
  } else {                                                         
    eraseIfUnused(call);                                           
  }                                                                
  if (gutils->knownRecomputeHeuristic.find(&call) !=
    gutils->knownRecomputeHeuristic.end()) {
    if (!gutils->knownRecomputeHeuristic[&call]) {
     auto cv = gutils->cacheForReverse(BuilderZ, newCall,
     getIndex(&call, CacheType::Self, BuilderZ));
    }
  }
  return true;
#ifdef __clang__
#pragma clang diagnostic pop
#else
#pragma GCC diagnostic pop
#endif
}


bool handle_spmv(BlasInfo blas, llvm::CallInst &call, llvm::Function *called,
    const std::vector<bool> &overwritten_args, llvm::Type *fpType) {
  
#ifdef __clang__
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wunused-but-set-variable"
#else
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif
  using namespace llvm;
  CallInst *const newCall = cast<CallInst>(gutils->getNewFromOriginal(&call));
  IRBuilder<> BuilderZ(newCall);
  BuilderZ.setFastMathFlags(getFast());
  IRBuilder<> allocationBuilder(gutils->inversionAllocs);
  allocationBuilder.setFastMathFlags(getFast());
  // never cache in Fwd Mode
  const bool cacheMode = (Mode != DerivativeMode::ForwardMode);
  const bool byRef = blas.prefix == "" || blas.prefix == "cublas_";
  const bool cblas = blas.prefix == "cblas_";
  const bool cublas = blas.prefix == "cublas_" || blas.prefix == "cublas";
  Value *cacheval = nullptr;

  const int offset = ((cblas || cublas) ? 1 : 0);
// Next ones shall only be called in the cublas case,
// they have incorrect meaning otherwise
  const int pos_handle = 0;
  Value *orig_handle = nullptr;
  Value *arg_handle = nullptr;
  Type *type_handle = nullptr;
  bool overwritten_handle = true;
  if (cublas) {
    orig_handle = call.getArgOperand(pos_handle);
    arg_handle = gutils->getNewFromOriginal(orig_handle);
    type_handle = arg_handle->getType();
    overwritten_handle = (cacheMode ? overwritten_args[pos_handle] : false);

  }

// Next ones shall only be called in the cblas case,
// they have incorrect meaning otherwise
  const int pos_layout = 0;
  const auto orig_layout = call.getArgOperand(pos_layout);
  auto arg_layout = gutils->getNewFromOriginal(orig_layout);
  const auto type_layout = arg_layout->getType();
  const bool overwritten_layout = (cacheMode ? overwritten_args[pos_layout] : false);

  const int pos_uplo = 0 + offset;
  const auto orig_uplo = call.getArgOperand(pos_uplo);
  auto arg_uplo = gutils->getNewFromOriginal(orig_uplo);
  const auto type_uplo = arg_uplo->getType();
  const bool overwritten_uplo = (cacheMode ? overwritten_args[pos_uplo] : false);

  const int pos_n = 1 + offset;
  const auto orig_n = call.getArgOperand(pos_n);
  auto arg_n = gutils->getNewFromOriginal(orig_n);
  const auto type_n = arg_n->getType();
  const bool overwritten_n = (cacheMode ? overwritten_args[pos_n] : false);

  const int pos_alpha = 2 + offset;
  const auto orig_alpha = call.getArgOperand(pos_alpha);
  auto arg_alpha = gutils->getNewFromOriginal(orig_alpha);
  const auto type_alpha = arg_alpha->getType();
  const bool overwritten_alpha = (cacheMode ? overwritten_args[pos_alpha] : false);
  bool active_alpha = !gutils->isConstantValue(orig_alpha);
  Value *rt_inactive_alpha = nullptr;

  const int pos_ap = 3 + offset;
  const auto orig_ap = call.getArgOperand(pos_ap);
  auto arg_ap = gutils->getNewFromOriginal(orig_ap);
  const auto type_ap = arg_ap->getType();
  const bool overwritten_ap = (cacheMode ? overwritten_args[pos_ap] : false);
  bool active_ap = !gutils->isConstantValue(orig_ap);
  Value *rt_inactive_ap = nullptr;

  const int pos_x = 4 + offset;
  const auto orig_x = call.getArgOperand(pos_x);
  auto arg_x = gutils->getNewFromOriginal(orig_x);
  const auto type_x = arg_x->getType();
  const bool overwritten_x = (cacheMode ? overwritten_args[pos_x] : false);
  bool active_x = !gutils->isConstantValue(orig_x);
  Value *rt_inactive_x = nullptr;

  const int pos_incx = 5 + offset;
  const auto orig_incx = call.getArgOperand(pos_incx);
  auto arg_incx = gutils->getNewFromOriginal(orig_incx);
  const auto type_incx = arg_incx->getType();
  const bool overwritten_incx = (cacheMode ? overwritten_args[pos_incx] : false);

  const int pos_beta = 6 + offset;
  const auto orig_beta = call.getArgOperand(pos_beta);
  auto arg_beta = gutils->getNewFromOriginal(orig_beta);
  const auto type_beta = arg_beta->getType();
  const bool overwritten_beta = (cacheMode ? overwritten_args[pos_beta] : false);
  bool active_beta = !gutils->isConstantValue(orig_beta);
  Value *rt_inactive_beta = nullptr;

  const int pos_y = 7 + offset;
  const auto orig_y = call.getArgOperand(pos_y);
  auto arg_y = gutils->getNewFromOriginal(orig_y);
  const auto type_y = arg_y->getType();
  const bool overwritten_y = (cacheMode ? overwritten_args[pos_y] : false);
  bool active_y = !gutils->isConstantValue(orig_y);
  Value *rt_inactive_y = nullptr;

  const int pos_incy = 8 + offset;
  const auto orig_incy = call.getArgOperand(pos_incy);
  auto arg_incy = gutils->getNewFromOriginal(orig_incy);
  const auto type_incy = arg_incy->getType();
  const bool overwritten_incy = (cacheMode ? overwritten_args[pos_incy] : false);


  // <X> is inactive either if gutils->isConstantValue(<X>)
  // returns true, or if runtimeActivity is on and the
  // shadow points to the primal arg.
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (byRef && active_alpha) {
      auto shadow_alpha = gutils->invertPointerM(orig_alpha, BuilderZ);
      rt_inactive_alpha = BuilderZ.CreateICmpEQ(shadow_alpha, arg_alpha, "rt.tmp.inactive." "alpha");
    }
    if (active_ap) {
      auto shadow_ap = gutils->invertPointerM(orig_ap, BuilderZ);
      rt_inactive_ap = BuilderZ.CreateICmpEQ(shadow_ap, arg_ap, "rt.tmp.inactive." "ap");
    }
    if (active_x) {
      auto shadow_x = gutils->invertPointerM(orig_x, BuilderZ);
      rt_inactive_x = BuilderZ.CreateICmpEQ(shadow_x, arg_x, "rt.tmp.inactive." "x");
    }
    if (byRef && active_beta) {
      auto shadow_beta = gutils->invertPointerM(orig_beta, BuilderZ);
      rt_inactive_beta = BuilderZ.CreateICmpEQ(shadow_beta, arg_beta, "rt.tmp.inactive." "beta");
    }
    if (active_y) {
      auto shadow_y = gutils->invertPointerM(orig_y, BuilderZ);
      rt_inactive_y = BuilderZ.CreateICmpEQ(shadow_y, arg_y, "rt.tmp.inactive." "y");
    }
    Value *rt_inactive_out = nullptr;
    if (active_y) {
      rt_inactive_out = rt_inactive_y;
    } else {
      rt_inactive_out = ConstantInt::getTrue(BuilderZ.getContext());
    }
    if (byRef && active_alpha) {
      rt_inactive_alpha = BuilderZ.CreateOr(rt_inactive_alpha, rt_inactive_out, "rt.inactive." "alpha");
    }
    if (active_ap) {
      rt_inactive_ap = BuilderZ.CreateOr(rt_inactive_ap, rt_inactive_out, "rt.inactive." "ap");
    }
    if (active_x) {
      rt_inactive_x = BuilderZ.CreateOr(rt_inactive_x, rt_inactive_out, "rt.inactive." "x");
    }
    if (byRef && active_beta) {
      rt_inactive_beta = BuilderZ.CreateOr(rt_inactive_beta, rt_inactive_out, "rt.inactive." "beta");
    }
    if (active_y) {
      rt_inactive_y = BuilderZ.CreateOr(rt_inactive_y, rt_inactive_out, "rt.inactive." "y");
    }
  }
  Type* blasFPType = type_alpha;
  Type* blasCharType = type_uplo;
  Type* blasIntType = type_n;
  Type* cublas_retty = nullptr;
  Value* cublas_handle = nullptr;
  if (cublas) {
    cublas_retty = call.getFunctionType()->getReturnType();
    cublas_handle = call.getArgOperand(0);
  }
  const bool julia_decl = !type_ap->isPointerTy();
  Type* type_vec_like = type_ap;
  // fpType already given by blas type (s, d, c, z) 
  IntegerType *intType = dyn_cast<IntegerType>(type_n);
  // TODO: add Fortran testcases for Fortran ABI
  if (!intType) {
    const auto PT = cast<PointerType>(type_n);
    if (blas.is64)
      intType = IntegerType::get(PT->getContext(), 64);
    else
      intType = IntegerType::get(PT->getContext(), 32);
  }

  IntegerType *charType = IntegerType::get(intType->getContext(), 8);

  IntegerType *julia_decl_type = nullptr;
  if (julia_decl)
    julia_decl_type = intType;
  SmallVector<Type *, 2> cacheTypes;

  // len, fp, etc. must be preserved if overwritten
  bool need_uplo = active_ap || active_alpha || active_x;
  bool need_n = active_beta || active_ap || active_y || active_alpha || active_x;
  bool need_alpha = active_ap || active_x;
  bool need_ap = active_alpha || active_x;
  bool need_x = active_ap || active_alpha;
  bool need_incx = active_ap || active_alpha || active_x;
  bool need_beta = active_y;
  bool need_y = false;
  bool need_incy = active_beta || active_ap || active_y || active_alpha || active_x;
  bool cache_uplo = cacheMode && byRef && overwritten_uplo && need_uplo;
  bool cache_n = cacheMode && byRef && overwritten_n && need_n;
  bool cache_alpha = cacheMode && byRef && overwritten_alpha && need_alpha;
  bool cache_ap = cacheMode && overwritten_ap && need_ap;
  bool cache_x = cacheMode && overwritten_x && need_x;
  bool cache_incx = cacheMode && byRef && overwritten_incx && need_incx;
  bool cache_beta = cacheMode && byRef && overwritten_beta && need_beta;
  bool cache_y = cacheMode && overwritten_y && need_y;
  bool cache_incy = cacheMode && byRef && overwritten_incy && need_incy;
  // we cache the following matrix,
  // since one rule uses input<y>
  if (active_beta) {
    need_y = true;
    cache_y = true;
  }
  if (cache_uplo)
    cacheTypes.push_back(charType);
  if (cache_n)
    cacheTypes.push_back(intType);
  if (cache_alpha)
    cacheTypes.push_back(fpType);
  if (cache_incx)
    cacheTypes.push_back(intType);
  if (cache_beta)
    cacheTypes.push_back(fpType);
  if (cache_incy)
    cacheTypes.push_back(intType);
  if (cache_ap)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  if (cache_x)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  if (cache_y)
    cacheTypes.push_back(PointerType::getUnqual(fpType));
  Type *cachetype = nullptr;
  switch (cacheTypes.size()) {
  case 0:
    break;
  case 1:
    cachetype = cacheTypes[0];
    break;
  default:
    cachetype = StructType::get(call.getContext(), cacheTypes);
    break;
  }

  if ((Mode == DerivativeMode::ReverseModeCombined ||
       Mode == DerivativeMode::ReverseModePrimal) && cachetype) {
    SmallVector<Value *, 2> cacheValues;
    if (byRef) {
        addValueToCache(arg_n, cache_n, intType, cacheValues, BuilderZ, "n");
        addValueToCache(arg_alpha, cache_alpha, fpType, cacheValues, BuilderZ, "alpha");
        addValueToCache(arg_incx, cache_incx, intType, cacheValues, BuilderZ, "incx");
        addValueToCache(arg_beta, cache_beta, fpType, cacheValues, BuilderZ, "beta");
        addValueToCache(arg_incy, cache_incy, intType, cacheValues, BuilderZ, "incy");
    }
    if (cache_ap) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = arg_n;
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.ap");
      Value *margs[] = {malins, arg_ap, malloc_size, llvm::ConstantInt::getFalse(IntegerType::getInt1Ty(call.getContext()))};
      Type *tys[] = {margs[0]->getType(), margs[1]->getType(),                     margs[2]->getType()};
      auto memcpyF = Intrinsic::getDeclaration(gutils->oldFunc->getParent(), Intrinsic::memcpy, tys);
      BuilderZ.CreateCall(memcpyF, margs);
      cacheValues.push_back(malins);
    }
    if (cache_x) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = arg_n;
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.x");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[5] = ValueType::Primal;
      if (byRef) valueTypes[6] = ValueType::Primal;
      if (byRef) valueTypes[2] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_x, arg_incx, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_x, arg_incx, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incx, byRef);
        Value *args[4] = {malins, arg_x, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cache_y) {
      Value *malloc_size;
      // arg_malloc_size will keep the original type
      Value *arg_malloc_size;
      malloc_size = arg_n;
      arg_malloc_size = malloc_size;
      malloc_size = load_if_ref(BuilderZ, intType, malloc_size, byRef);
      auto malins = CreateAllocation(BuilderZ, fpType, malloc_size, "cache.y");
      ValueType valueTypes[] = {ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None, ValueType::None};
      valueTypes[8] = ValueType::Primal;
      if (byRef) valueTypes[9] = ValueType::Primal;
      if (byRef) valueTypes[2] = ValueType::Primal;
      if (cublas) {
          Value *args[6] = {arg_handle, arg_malloc_size, arg_y, arg_incy, malins, ConstantInt::get(intType, 1)};
          callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, cublas_retty, gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
        } else if (EnzymeBlasCopy) {
        Value *args[5] = {arg_malloc_size, arg_y, arg_incy, malins, to_blas_callconv(BuilderZ, ConstantInt::get(intType, 1), byRef, cublas, julia_decl_type, allocationBuilder)};
        callMemcpyStridedBlas(BuilderZ, *gutils->oldFunc->getParent(), blas, args, Type::getVoidTy(call.getContext()), gutils->getInvertedBundles(&call, valueTypes, BuilderZ, /*lookup*/false));
      } else {
       auto dmemcpy = getOrInsertMemcpyStrided(*gutils->oldFunc->getParent(), fpType, cast<PointerType>(malins->getType()), intType, 0, 0);
        Value *inc = load_if_ref(BuilderZ, intType, arg_incy, byRef);
        Value *args[4] = {malins, arg_y, malloc_size, inc};
        if (args[1]->getType()->isIntegerTy())
          args[1] = BuilderZ.CreateIntToPtr(args[1], malins->getType());
        else if (args[1]->getType() != malins->getType())
          args[1] = BuilderZ.CreatePointerCast(args[1], malins->getType());
        BuilderZ.CreateCall(dmemcpy, args,
            gutils->getInvertedBundles(&call, valueTypes,
            BuilderZ, /*lookup*/ false));
      }
      cacheValues.push_back(malins);
    }
    if (cacheValues.size() == 1) {
      cacheval = cacheValues[0];
    } else {
      cacheval = UndefValue::get(cachetype);
      for (auto&& tup : llvm::enumerate(cacheValues))
        cacheval = BuilderZ.CreateInsertValue(cacheval, tup.value(), tup.index());
    }
    gutils->cacheForReverse(BuilderZ, cacheval,
                            getIndex(&call, CacheType::Tape, BuilderZ));
  }
  unsigned cacheidx = 0;
  Value *free_ap = nullptr;
  Value *true_incx = arg_incx;
  Value *free_x = nullptr;
  Value *input_y = nullptr;
  Value *free_input_y = nullptr;
  Value *true_incy = arg_incy;
  Value *free_y = nullptr;
  IRBuilder<> Builder2(&call);
  switch (Mode) {
    case DerivativeMode::ReverseModeCombined:
    case DerivativeMode::ReverseModeGradient:
      getReverseBuilder(Builder2);
      break;
    case DerivativeMode::ForwardMode:
    case DerivativeMode::ForwardModeSplit:
      Builder2.SetInsertPoint(BuilderZ.GetInsertBlock(),
                              BuilderZ.GetInsertPoint());
      Builder2.setFastMathFlags(getFast());
      break;
    case DerivativeMode::ReverseModePrimal:
      break;
  }

  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {

    if (cachetype) {
      if (Mode != DerivativeMode::ReverseModeCombined) {
        cacheval = BuilderZ.CreatePHI(cachetype, 0);
      }
      cacheval = gutils->cacheForReverse(
          BuilderZ, cacheval, getIndex(&call, CacheType::Tape, BuilderZ));
      if (Mode != DerivativeMode::ForwardModeSplit)
        cacheval = lookup(cacheval, Builder2);
    }

    if (byRef) {
      if (cache_n) {
        arg_n = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.n");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.n");
        Builder2.CreateStore(arg_n, alloc);
        arg_n = Builder2.CreatePointerCast(
            alloc, type_n, "cast.n");
        cacheidx++;
      }

      if (cache_alpha) {
        arg_alpha = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.alpha");
        auto alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "byref.alpha");
        Builder2.CreateStore(arg_alpha, alloc);
        arg_alpha = Builder2.CreatePointerCast(
            alloc, type_alpha, "cast.alpha");
        cacheidx++;
      }

      if (cache_incx) {
        arg_incx = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incx");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incx");
        Builder2.CreateStore(arg_incx, alloc);
        arg_incx = Builder2.CreatePointerCast(
            alloc, type_incx, "cast.incx");
        cacheidx++;
      }

      if (cache_beta) {
        arg_beta = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.beta");
        auto alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "byref.beta");
        Builder2.CreateStore(arg_beta, alloc);
        arg_beta = Builder2.CreatePointerCast(
            alloc, type_beta, "cast.beta");
        cacheidx++;
      }

      if (cache_incy) {
        arg_incy = (cacheTypes.size() == 1)
                    ? cacheval
                    : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.incy");
        auto alloc = allocationBuilder.CreateAlloca(intType, nullptr, "byref.incy");
        Builder2.CreateStore(arg_incy, alloc);
        arg_incy = Builder2.CreatePointerCast(
            alloc, type_incy, "cast.incy");
        cacheidx++;
      }

    }
    if (cache_ap) {
      arg_ap = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.ap");
      free_ap = arg_ap;
      if (type_ap->isIntegerTy()) {
        arg_ap = Builder2.CreatePtrToInt(arg_ap, type_ap);
      } else if (arg_ap->getType() != type_ap){
        arg_ap = Builder2.CreatePointerCast(arg_ap, type_ap);
      }
      cacheidx++;
    }
    if (cache_x) {
      arg_x = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.x");
      free_x = arg_x;
      if (type_x->isIntegerTy()) {
        arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
      } else if (arg_x->getType() != type_x){
        arg_x = Builder2.CreatePointerCast(arg_x, type_x);
      }
      cacheidx++;
    }
    //handling input
    if (active_beta) {
      input_y = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.y");
      free_input_y = input_y;
      if (type_y->isIntegerTy()) {
        input_y = Builder2.CreatePtrToInt(input_y, type_y);
      } else if (input_y->getType() != type_y){
        input_y = Builder2.CreatePointerCast(input_y, type_y);
      }
    }
    if (cache_y) {
      arg_y = (cacheTypes.size() == 1)
                  ? cacheval
                  : Builder2.CreateExtractValue(cacheval, {cacheidx}, "tape.ext.y");
      free_y = arg_y;
      if (type_y->isIntegerTy()) {
        arg_y = Builder2.CreatePtrToInt(arg_y, type_y);
      } else if (arg_y->getType() != type_y){
        arg_y = Builder2.CreatePointerCast(arg_y, type_y);
      }
      cacheidx++;
    }
  } else {

    if (type_x->isIntegerTy())
      arg_x = Builder2.CreatePtrToInt(arg_x, type_x);
    if (type_y->isIntegerTy())
      arg_y = Builder2.CreatePtrToInt(arg_y, type_y);
  }
  /* fwd-rewrite */                                 
  if (Mode == DerivativeMode::ForwardMode ||        
      Mode == DerivativeMode::ForwardModeSplit) {   
                                                    
    auto callval = call.getCalledOperand();       

  if (EnzymeRuntimeActivityCheck) {
    std::string s;
    llvm::raw_string_ostream ss(s);
    ss << "spmv" << "\n";
    ss << call.getDebugLoc() << "\n";
    ss << "Runtime Activity not supported for BLAS calls" << "\n";
    if (CustomErrorHandler) {
      IRBuilder<> Builder2(&call);
      getForwardBuilder(BuilderZ);
      CustomErrorHandler(ss.str().c_str(), wrap(&call), ErrorType::NoDerivative,
                         gutils, nullptr, wrap(&BuilderZ));
      return false;
    } else {
      EmitFailure("Unsupported Mode", call.getDebugLoc(), &call, ss.str());
      return false;
    }
  }
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
    Value *d_beta = Constant::getNullValue(gutils->getShadowType(fpType));
    Value *d_ap = active_ap
     ? gutils->invertPointerM(orig_ap, Builder2)
     : nullptr;
    Value *d_y = active_y
     ? gutils->invertPointerM(orig_y, Builder2)
     : nullptr;
    Value *d_alpha = Constant::getNullValue(gutils->getShadowType(fpType));
    Value *d_x = active_x
     ? gutils->invertPointerM(orig_x, Builder2)
     : nullptr;
    Value *dres = applyChainRule(
        call.getType(), Builder2,
        [&](Value *d_alpha, Value *d_ap, Value *d_x, Value *d_beta, Value *d_y  ) {
      Value *dres = nullptr;
      if(active_alpha) {
        Value *args1_cblas[10] =  {arg_layout, arg_uplo, arg_n, d_alpha, arg_ap, arg_x, (cache_x ? const_one : arg_incx), arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[9] = {arg_uplo, arg_n, d_alpha, arg_ap, arg_x, (cache_x ? const_one : arg_incx), arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          if (byRef) {
          dres = Builder2.CreateCall(call.getFunctionType(), callval, args1, Defs);
          } else /*cblas*/ {
          dres = Builder2.CreateCall(call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          };
      }
      if(active_ap) {
        Value *args1_cblas[10] =  {arg_layout, arg_uplo, arg_n, arg_alpha, d_ap, arg_x, (cache_x ? const_one : arg_incx), arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[9] = {arg_uplo, arg_n, arg_alpha, d_ap, arg_x, (cache_x ? const_one : arg_incx), arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      if(active_x) {
        Value *args1_cblas[10] =  {arg_layout, arg_uplo, arg_n, arg_alpha, arg_ap, d_x, arg_incx, arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[9] = {arg_uplo, arg_n, arg_alpha, arg_ap, d_x, arg_incx, arg_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      if(active_beta) {
        Value *args1_cblas[10] =  {arg_layout, arg_uplo, arg_n, arg_alpha, arg_ap, arg_x, (cache_x ? const_one : arg_incx), d_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[9] = {arg_uplo, arg_n, arg_alpha, arg_ap, arg_x, (cache_x ? const_one : arg_incx), d_beta, arg_y, (cache_y ? const_one : arg_incy)};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      if(active_y) {
        Value *args1_cblas[10] =  {arg_layout, arg_uplo, arg_n, arg_alpha, arg_ap, arg_x, (cache_x ? const_one : arg_incx), arg_beta, d_y, arg_incy};
        auto Defs_cblas = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
        Value *args1[9] = {arg_uplo, arg_n, arg_alpha, arg_ap, arg_x, (cache_x ? const_one : arg_incx), arg_beta, d_y, arg_incy};
        auto Defs = gutils->getInvertedBundles(
          &call, {ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ false);
          Value *nextCall;
          if (byRef) {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1, Defs);
          } else {
        nextCall = Builder2.CreateCall(
          call.getFunctionType(), callval, args1_cblas, Defs_cblas);
          }
        if (dres)
          dres = Builder2.CreateFAdd(dres, nextCall);
        else
          dres = nextCall;
      }
      return dres;
    },
    d_alpha, d_ap, d_x, d_beta, d_y);
    setDiffe(&call, dres, Builder2);
  }
  /* rev-rewrite */                                 
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient) {
    Value *alloc = nullptr;
    if (byRef && !cublas) {
      alloc = allocationBuilder.CreateAlloca(fpType, nullptr, "ret");
    }

    //handling nested blas: 0
    //handled nested blas: 0
    //handling nested blas: 1
    //handled nested blas: 1
    //handling nested blas: 0
    //handled nested blas: 0
    Value *d_alpha = UndefValue::get(fpType);
    Value *d_ap = active_ap
     ? lookup(gutils->invertPointerM(orig_ap, Builder2), Builder2)
     : nullptr;
    Value *d_x = active_x
     ? lookup(gutils->invertPointerM(orig_x, Builder2), Builder2)
     : nullptr;
    Value *d_beta = UndefValue::get(fpType);
    Value *d_y = active_y
     ? lookup(gutils->invertPointerM(orig_y, Builder2), Builder2)
     : nullptr;
    if (!cache_uplo && need_uplo)
      arg_uplo = lookup(arg_uplo, Builder2);
    if (!cache_n && need_n)
      arg_n = lookup(arg_n, Builder2);
    if (!cache_alpha && need_alpha)
      arg_alpha = lookup(arg_alpha, Builder2);
    if (!cache_ap && need_ap)
      arg_ap = lookup(arg_ap, Builder2);
    if (!cache_x && need_x)
      arg_x = lookup(arg_x, Builder2);
    if (!cache_incx && need_incx)
      arg_incx = lookup(arg_incx, Builder2);
    if (!cache_beta && need_beta)
      arg_beta = lookup(arg_beta, Builder2);
    if (!cache_y && need_y)
      arg_y = lookup(arg_y, Builder2);
    if (!cache_incy && need_incy)
      arg_incy = lookup(arg_incy, Builder2);
  if(EnzymeRuntimeActivityCheck && cacheMode) {
    if (byRef && active_alpha) {
      rt_inactive_alpha = lookup(rt_inactive_alpha, Builder2);
    }
    if (active_ap) {
      rt_inactive_ap = lookup(rt_inactive_ap, Builder2);
    }
    if (active_x) {
      rt_inactive_x = lookup(rt_inactive_x, Builder2);
    }
    if (byRef && active_beta) {
      rt_inactive_beta = lookup(rt_inactive_beta, Builder2);
    }
    if (active_y) {
      rt_inactive_y = lookup(rt_inactive_y, Builder2);
    }
  }
    applyChainRule(
      Builder2,
      [&](Value *d_ap, Value *d_x, Value *d_y) {
Value * const_one = to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "int.one");
      auto bb_name = Builder2.GetInsertBlock()->getName();
      // Seq
      if (active_alpha && d_y) {
        BasicBlock *nextBlock_alpha = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode && byRef) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".alpha.active");
          nextBlock_alpha = gutils->addReverseBlock(activeBlock, bb_name + ".alpha.done");
          Builder2.CreateCondBr(rt_inactive_alpha, nextBlock_alpha, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
    Value *len = load_if_ref(Builder2, intType,arg_n, byRef);
    Value *size_y0 = Builder2.CreateMul(len, Builder2.CreateAdd(len, ConstantInt::get(intType, 1)), "square_mat_size_y0");
    size_y0 = Builder2.CreateUDiv(size_y0, ConstantInt::get(intType, 2), "size_y0");
    Value * true_mat_y0 = CreateAllocation(Builder2, fpType, size_y0, "mat_y0");
    Value * mat_y0 = true_mat_y0;
    if (type_vec_like->isIntegerTy()) {
      mat_y0 = Builder2.CreatePtrToInt(mat_y0, type_vec_like);
    } else if (mat_y0->getType() != type_vec_like){
      mat_y0 = Builder2.CreatePointerCast(mat_y0, type_vec_like);
    }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
        std::vector<Value *>args0;
        if (cblas) args0.push_back(arg_layout);
        if (cublas) args0.push_back(arg_handle);
        for (auto item : {arg_uplo}) args0.push_back(item);
        for (auto item : {arg_n}) args0.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 1.0), byRef, blasFPType, allocationBuilder, "constant.fp.1.0")}) args0.push_back(item);
        for (auto item : {arg_ap}) args0.push_back(item);
        for (auto item : {arg_x, (cache_x ? const_one : arg_incx)}) args0.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 0.0), byRef, blasFPType, allocationBuilder, "constant.fp.0.0")}) args0.push_back(item);
        for (auto item : {mat_y0}) args0.push_back(item);
        for (auto item : {to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "constant.int.1")}) args0.push_back(item);
        if (byRef) {
        }
    //handling nested blas: 0
    SmallVector<Type*, 1> tys; for (auto arg : args0) tys.push_back(arg->getType());
    llvm::FunctionType *FTspmv = FunctionType::get(Builder2.getVoidTy(), tys, false);
    auto derivcall_spmv = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "spmv" + blas.suffix, FTspmv);
    if (auto F = dyn_cast<Function>(derivcall_spmv.getCallee()))
    {
      attribute_spmv(blas, F);
    }

        Builder2.CreateCall(derivcall_spmv, args0, Defs);
    //handled nested blas: 0
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        for (auto item : {mat_y0}) args1.push_back(item);
        for (auto item : {to_blas_callconv(Builder2, ConstantInt::get(intType, 1), byRef, cublas, intType, allocationBuilder, "constant.int.1")}) args1.push_back(item);
        if (byRef) {
        }
    //handling nested blas: 1
    if (cublas) assert(false && "cublas not implemented");
{
      SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTdot = FunctionType::get(fpType, tys, false);
    auto derivcall_dot = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "dot" + blas.suffix, FTdot);
    if (auto F = dyn_cast<Function>(derivcall_dot.getCallee()))
    {
      attribute_dot(blas, F);
    }

        CallInst *cubcall = cast<CallInst>(Builder2.CreateCall(derivcall_dot, args1, Defs));
        if (byRef) {
          ((DiffeGradientUtils *)gutils)->addToInvertedPtrDiffe(&call, nullptr, fpType, 0, (called->getParent()->getDataLayout().getTypeSizeInBits(fpType)/8), orig_alpha, cubcall, Builder2);
        } else {
          addToDiffe(orig_alpha, cubcall, Builder2, fpType);
        }
}
    //handled nested blas: 1
    CreateDealloc(Builder2, true_mat_y0);
        if (nextBlock_alpha && byRef) {
          Builder2.CreateBr(nextBlock_alpha);
          Builder2.SetInsertPoint(nextBlock_alpha);
        }
      }
      // Seq
      if (active_ap && d_ap && d_y) {
        BasicBlock *nextBlock_ap = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode && byRef) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".ap.active");
          nextBlock_ap = gutils->addReverseBlock(activeBlock, bb_name + ".ap.done");
          Builder2.CreateCondBr(rt_inactive_ap, nextBlock_ap, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
        std::vector<Value *>args0;
        if (cblas) args0.push_back(arg_layout);
        if (cublas) args0.push_back(arg_handle);
        for (auto item : {arg_uplo}) args0.push_back(item);
        for (auto item : {arg_n}) args0.push_back(item);
        for (auto item : {arg_alpha}) args0.push_back(item);
        for (auto item : {arg_x, (cache_x ? const_one : arg_incx)}) args0.push_back(item);
        for (auto item : {d_y, arg_incy}) args0.push_back(item);
        for (auto item : {d_ap}) args0.push_back(item);
        if (byRef) {
        }
    //handling nested blas: 0
    SmallVector<Type*, 1> tys; for (auto arg : args0) tys.push_back(arg->getType());
    llvm::FunctionType *FTspr2 = FunctionType::get(Builder2.getVoidTy(), tys, false);
    auto derivcall_spr2 = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "spr2" + blas.suffix, FTspr2);
    if (auto F = dyn_cast<Function>(derivcall_spr2.getCallee()))
    {
      attribute_spr2(blas, F);
    }

        Builder2.CreateCall(derivcall_spr2, args0, Defs);
    //handled nested blas: 0
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_uplo}) args1.push_back(item);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {arg_alpha}) args1.push_back(item);
        for (auto item : {arg_x, (cache_x ? const_one : arg_incx)}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        for (auto item : {d_ap}) args1.push_back(item);
        if (byRef) {
        }
callSPMVDiagUpdate(Builder2, *gutils->oldFunc->getParent(), blas, intType, blasCharType, blasFPType, type_vec_like, type_n, fpType, ArrayRef<Value *>(args1), Defs, byRef, julia_decl);
        if (nextBlock_ap && byRef) {
          Builder2.CreateBr(nextBlock_ap);
          Builder2.SetInsertPoint(nextBlock_ap);
        }
      }
      if (active_x && d_x && d_y) {
        BasicBlock *nextBlock_x = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".x.active");
          nextBlock_x = gutils->addReverseBlock(activeBlock, bb_name + ".x.done");
          Builder2.CreateCondBr(rt_inactive_x, nextBlock_x, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cblas) args1.push_back(arg_layout);
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_uplo}) args1.push_back(item);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {arg_alpha}) args1.push_back(item);
        for (auto item : {arg_ap}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        for (auto item : {to_blas_fp_callconv(Builder2, ConstantFP::get(fpType, 1.0), byRef, blasFPType, allocationBuilder, "constant.fp.1.0")}) args1.push_back(item);
        for (auto item : {d_x, arg_incx}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTspmv;
    if (cublas) {
      FTspmv = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTspmv = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_spmv = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "spmv" + blas.suffix, FTspmv);
    if (auto F = dyn_cast<Function>(derivcall_spmv.getCallee()))
    {
      attribute_spmv(blas, F);
    }

        Builder2.CreateCall(derivcall_spmv, args1, Defs);
        if (nextBlock_x) {
          Builder2.CreateBr(nextBlock_x);
          Builder2.SetInsertPoint(nextBlock_x);
        }
      }
      if (active_beta && d_y) {
        BasicBlock *nextBlock_beta = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode && byRef) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".beta.active");
          nextBlock_beta = gutils->addReverseBlock(activeBlock, bb_name + ".beta.done");
          Builder2.CreateCondBr(rt_inactive_beta, nextBlock_beta, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        for (auto item : {input_y, (cache_y ? const_one : arg_incy)}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both, cache_y ? ValueType::Both : ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
      if (!cublas) {
{
      SmallVector<Type*, 1> tys; for (auto arg : ArrayRef<Value *>(args1)) tys.push_back(arg->getType());
    llvm::FunctionType *FTdot = FunctionType::get(fpType, tys, false);
    auto derivcall_dot = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "dot" + blas.suffix, FTdot);
    if (auto F = dyn_cast<Function>(derivcall_dot.getCallee()))
    {
      attribute_dot(blas, F);
    }

        CallInst *cubcall = cast<CallInst>(Builder2.CreateCall(derivcall_dot, ArrayRef<Value *>(args1), Defs));
        if (byRef) {
          ((DiffeGradientUtils *)gutils)->addToInvertedPtrDiffe(&call, nullptr, fpType, 0, (called->getParent()->getDataLayout().getTypeSizeInBits(fpType)/8), orig_beta, cubcall, Builder2);
        } else {
          addToDiffe(orig_beta, cubcall, Builder2, fpType);
        }
}
      } else {
      }
        if (nextBlock_beta && byRef) {
          Builder2.CreateBr(nextBlock_beta);
          Builder2.SetInsertPoint(nextBlock_beta);
        }
      }
      if (active_y && d_y) {
        BasicBlock *nextBlock_y = nullptr;
        if (EnzymeRuntimeActivityCheck && cacheMode) {
          BasicBlock *current = Builder2.GetInsertBlock();
          auto activeBlock = gutils->addReverseBlock(current,bb_name + ".y.active");
          nextBlock_y = gutils->addReverseBlock(activeBlock, bb_name + ".y.done");
          Builder2.CreateCondBr(rt_inactive_y, nextBlock_y, activeBlock);
          Builder2.SetInsertPoint(activeBlock);
        }
        std::vector<Value *>args1;
        if (cublas) args1.push_back(arg_handle);
        for (auto item : {arg_n}) args1.push_back(item);
        for (auto item : {arg_beta}) args1.push_back(item);
        for (auto item : {d_y, arg_incy}) args1.push_back(item);
        if (byRef) {
        }
        const auto Defs = gutils->getInvertedBundles(&call, {ValueType::Both, ValueType::Both, cache_alpha ? ValueType::Both : ValueType::Both, ValueType::Both, cache_x ? ValueType::Both : ValueType::Both, ValueType::Both, cache_beta ? ValueType::Both : ValueType::Both, ValueType::Both, ValueType::Both}, Builder2, /* lookup */ true);
    SmallVector<Type*, 1> tys; for (auto arg : args1) tys.push_back(arg->getType());
    llvm::FunctionType *FTscal;
    if (cublas) {
      FTscal = FunctionType::get(cublas_retty, tys, false);
    } else {
      FTscal = FunctionType::get(Builder2.getVoidTy(), tys, false);
    }
    auto derivcall_scal = gutils->oldFunc->getParent()->getOrInsertFunction(
  blas.prefix + blas.floatType + "scal" + blas.suffix, FTscal);
    if (auto F = dyn_cast<Function>(derivcall_scal.getCallee()))
    {
      attribute_scal(blas, F);
    }

        Builder2.CreateCall(derivcall_scal, args1, Defs);
        if (nextBlock_y) {
          Builder2.CreateBr(nextBlock_y);
          Builder2.SetInsertPoint(nextBlock_y);
        }
      }
    },
    d_ap, d_x, d_y  );
  }
  if (Mode == DerivativeMode::ReverseModeCombined ||
      Mode == DerivativeMode::ReverseModeGradient ||
      Mode == DerivativeMode::ForwardModeSplit) {
    if (shouldFree()) {
      if (cache_ap) {
        CreateDealloc(Builder2, free_ap);
      }
      if (cache_x) {
        CreateDealloc(Builder2, free_x);
      }
      if (cache_y) {
        CreateDealloc(Builder2, free_y);
      }
    }
  }
                                                                   
  if (Mode == DerivativeMode::ReverseModeGradient) {               
    eraseIfUnused(call, /*erase*/ true, /*check*/ false);          
  } else {                                                         
    eraseIfUnused(call);                                           
  }                                                                
  if (gutils->knownRecomputeHeuristic.find(&call) !=
    gutils->knownRecomputeHeuristic.end()) {
    if (!gutils->knownRecomputeHeuristic[&call]) {
     auto cv = gutils->cacheForReverse(BuilderZ, newCall,
     getIndex(&call, CacheType::Self, BuilderZ));
    }
  }
  return true;
#ifdef __clang__
#pragma clang diagnostic pop
#else
#pragma GCC diagnostic pop
#endif
}

